package main

import (
	"log"

	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

type Link struct {
	ID          primitive.ObjectID `bson:"_id" json:"id"`
	Url         string             `bson:"url"`
	Description string             `bson:"description"`
}

func addLinkToDatabase(l Link) bool {
	_, err := colLinks.InsertOne(mongoCtx, l)
	if err != nil {
		log.Println("Could not add new link to database: ", err)
		return false
	}
	return true
}

func deleteLinkFromDatabase(id primitive.ObjectID) bool {
	_, err := colLinks.DeleteOne(mongoCtx, bson.M{"_id": id})
	if err != nil {
		log.Println("Could not remove link from database: ", err)
		return false
	}
	return true
}

func getLinksFromDatabase() (links []Link) {
	cursor, err := colLinks.Find(mongoCtx, bson.M{})
	if err != nil {
		log.Println("Could not remove link from database: ", err)
		return nil
	}
	cursor.All(mongoCtx, &links)
	return
}
