SET NAMES utf8mb4;
SET time_zone = '+01:00';
SET foreign_key_checks = 0;

CREATE OR REPLACE DATABASE `%[1]s_W20_21`;
GRANT ALL ON `%[1]s_W20_21`.* TO '%[1]s'@'%%';
USE `%[1]s_W20_21`;

#
# TABLE STRUCTURE FOR: wein_typ
#

DROP TABLE IF EXISTS `wein_typ`;

CREATE TABLE `wein_typ` (
  `weintyp_id` int(11) NOT NULL,
  `weintyp_bezeichnung` varchar(69) DEFAULT NULL,
  PRIMARY KEY (`weintyp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (0, 'Weißwein');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (1, 'Rotwein');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (2, 'Sekt');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (3, 'Brachialus');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (4, 'Gelbwein');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (5, 'Rose');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (6, 'Bier');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (7, 'Schnaps');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (8, 'Korkenwein');
INSERT INTO `wein_typ` (`weintyp_id`, `weintyp_bezeichnung`) VALUES (9, 'Blumenwein');

#
# TABLE STRUCTURE FOR: artikel_typ
#

DROP TABLE IF EXISTS `artikel_typ`;

CREATE TABLE `artikel_typ` (
  `arttyp_id` int(11) NOT NULL,
  `arttyp_bezeichnung` varchar(69) NOT NULL,
  PRIMARY KEY (`arttyp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (0, 'Wein');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (1, 'Sekt');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (2, 'Bier');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (3, 'Saft');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (4, 'Vodka');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (5, 'Mixgetränk');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (6, 'Corkery');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (7, 'Vandervort');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (8, 'Keeling');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (9, 'Mante');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (10, 'Klein');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (11, 'Will');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (12, 'Hermann');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (13, 'Nader');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (14, 'Prohaska');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (15, 'Hagenes');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (16, 'Tromp');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (17, 'Cruickshank');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (18, 'Waters');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (19, 'Kassulke');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (20, 'Harber');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (21, 'Hartmann');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (22, 'Adams');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (23, 'Mohr');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (24, 'Gleichner');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (25, 'Homenick');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (26, 'Hara');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (27, 'Schowalter');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (28, 'Ullrich');
INSERT INTO `artikel_typ` (`arttyp_id`, `arttyp_bezeichnung`) VALUES (29, 'Schmeler');


#
# TABLE STRUCTURE FOR: geschmack_typ
#

DROP TABLE IF EXISTS `geschmack_typ`;

CREATE TABLE `geschmack_typ` (
  `geschmack_id` int(11) NOT NULL,
  `geschmack_name` varchar(69) DEFAULT NULL,
  `geschmack_beschreibung` varchar(69) DEFAULT NULL,
  PRIMARY KEY (`geschmack_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (0, 'Trocken', 'Aut nemo corrupti ea.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (1, 'Halbtrocken', 'Excepturi sunt ipsum consequatur.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (2, 'Süß', 'Officiis dolores quasi.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (3, 'Muller', 'Porro voluptatem aut nemo molestias quidem.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (4, 'Schamberger', 'Distinctio sequi aut.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (5, 'Trantow', 'Corporis mollitia facilis ullam error quia.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (6, 'Mertz', 'Quisquam voluptatem laudantium doloremque.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (7, 'Lesch', 'Optio sequi eum laboriosam.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (8, 'Kirlin', 'Et ut aut excepturi magni.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (9, 'Stamm', 'Et aut ipsam fugiat accusamus veniam.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (10, 'McGlynn', 'Doloribus autem sed perferendis dolores.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (11, 'Schroeder', 'Est eveniet sunt.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (12, 'Nitzsche', 'Sit repellendus placeat nam enim.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (13, 'Ernser', 'Nobis earum placeat laboriosam eaque.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (14, 'Corkery', 'Autem officiis ut dolorem.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (15, 'Reilly', 'Sit sed similique aliquid et.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (16, 'Schroeder', 'Nostrum sint molestiae assumenda cupiditate qui.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (17, 'Wisoky', 'Natus voluptatem iusto voluptas quia.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (18, 'Bins', 'Vitae id sed consequatur.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (19, 'Tremblay', 'Necessitatibus consequatur minus.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (20, 'Hegmann', 'Blanditiis eos voluptate laudantium.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (21, 'Wiegand', 'Blanditiis nulla et officiis saepe excepturi.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (22, 'Gibson', 'Corporis aut minus deleniti dolor.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (23, 'Davis', 'Ducimus animi vero veritatis cupiditate.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (24, 'Rodriguez', 'Sint et sit omnis labore.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (25, 'Zboncak', 'Architecto qui et accusantium aut adipisci.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (26, 'Gottlieb', 'Error harum cupiditate quam optio.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (27, 'Schneider', 'Asperiores dolorem dolores alias enim.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (28, 'Upton', 'Corporis quas et sint deserunt ea.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (29, 'Bode', 'Corporis quam quaerat velit.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (30, 'Schiller', 'Dolore non id beatae aut sed.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (31, 'Bogan', 'Soluta animi minima quas.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (32, 'Gottlieb', 'Quia repudiandae ab.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (33, 'Hackett', 'Est in dignissimos.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (34, 'Krajcik', 'Quibusdam nemo nesciunt ad.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (35, 'Von', 'Eum sunt voluptates autem.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (36, 'Zemlak', 'Et aliquam eos.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (37, 'Wiza', 'Non maiores dolorem vel.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (38, 'Kutch', 'Est nam ratione est.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (39, 'Bednar', 'Odio et nisi ullam qui.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (40, 'Bayer', 'Doloribus sed ullam consequatur eum cupiditate.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (41, 'Pouros', 'Quaerat quam ut dicta officiis.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (42, 'Schamberger', 'In magni assumenda iste facilis libero.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (43, 'Beer', 'Similique voluptas sint modi.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (44, 'Crona', 'Voluptatem rerum aut est.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (45, 'Bradtke', 'Voluptate nostrum accusamus voluptate.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (46, 'Bayer', 'Assumenda consequatur soluta sapiente consequatur.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (47, 'Runte', 'Tempora architecto autem.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (48, 'Rath', 'Rerum maiores est ipsa.');
INSERT INTO `geschmack_typ` (`geschmack_id`, `geschmack_name`, `geschmack_beschreibung`) VALUES (49, 'Hettinger', 'Fugiat aliquid molestiae.');


#
# TABLE STRUCTURE FOR: kunde
#

DROP TABLE IF EXISTS `kunde`;

CREATE TABLE `kunde` (
  `kd_id` int(11) NOT NULL,
  `kd_firma` varchar(69) DEFAULT NULL,
  `kd_plz` varchar(10) DEFAULT NULL,
  `kd_ort` varchar(100) DEFAULT NULL,
  `kd_strasse` varchar(100) DEFAULT NULL,
  `kd_hausnr` int(11) DEFAULT NULL,
  PRIMARY KEY (`kd_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (0, 'Bayer and Sons', '08984', 'Abshireborough', 'Effertz Route', 60);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (1, 'Towne-Altenwerth', '46123', 'Port Linwood', 'Aric Trace', 140);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (2, 'Rutherford PLC', '36232', 'Camronshire', 'Cremin Field', 62);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (3, 'Huels Inc', '64092', 'West Pearlieville', 'Hane Rue', 195);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (4, 'Wisozk LLC', '93117', 'Lake Kaitlin', 'Janet Underpass', 30);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (5, 'Gleichner, Rice and Bogan', '33997', 'Brandtfurt', 'Ruecker Brook', 40);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (6, 'Kassulke, Kuhn and Murazik', '86558', 'Whitechester', 'Una Lights', 126);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (7, 'Schuppe Inc', '36364', 'Aufderharland', 'Kemmer Fort', 41);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (8, 'Quitzon and Sons', '35285', 'New Vivientown', 'Senger Junctions', 30);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (9, 'Tromp-Hand', '57960', 'Kshlerinmouth', 'Romaguera Ports', 37);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (10, 'Smith-Corwin', '44324', 'Oberbrunnerberg', 'Marks Loaf', 121);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (11, 'Leannon LLC', '91979', 'Davidstad', 'Jennifer Road', 67);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (12, 'Wiza-Strosin', '14431', 'Wizaport', 'Dayna Turnpike', 24);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (13, 'Buckridge Inc', '99264', 'Janiyaside', 'Balistreri Cape', 41);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (14, 'Murazik PLC', '73547', 'Danielfurt', 'Lakin Bypass', 4);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (15, 'Hintz and Sons', '98241', 'Hellenchester', 'Schumm Via', 131);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (16, 'Price, Powlowski and Howe', '74995', 'North Hailey', 'Leilani Fall', 105);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (17, 'Nolan-Pouros', '17521', 'Lake Chelsieton', 'Colton Parks', 71);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (18, 'Nienow-Gaylord', '32974', 'Casperburgh', 'Boyer Manors', 158);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (19, 'Hilll LLC', '76439', 'West Kenyattaport', 'Triston Drives', 197);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (20, 'Barrows-Walker', '56643', 'New Berry', 'Lind Land', 195);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (21, 'Cummings-O\'Conner', '72425', 'Mohammadtown', 'Eleazar Well', 137);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (22, 'VonRueden, Schmeler and Hayes', '76191', 'Effertzport', 'Liam Islands', 93);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (23, 'Collier Group', '29510', 'Bartolettiside', 'Orion Mountains', 70);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (24, 'Mayert PLC', '68218', 'East Jensen', 'Donnelly Wall', 44);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (25, 'Lockman Inc', '22837', 'East Geraldine', 'Stewart Knolls', 33);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (26, 'Emard-O\'Reilly', '86734', 'North Don', 'Stroman Passage', 141);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (27, 'Mayert-Durgan', '63087', 'South Rosellabury', 'Christy Station', 8);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (28, 'Sporer Inc', '91466', 'West Alexandershire', 'Fritsch Village', 185);
INSERT INTO `kunde` (`kd_id`, `kd_firma`, `kd_plz`, `kd_ort`, `kd_strasse`, `kd_hausnr`) VALUES (29, 'Wilkinson-Kunde', '65326', 'South Breana', 'Kian Place', 78);


#
# TABLE STRUCTURE FOR: rechnung
#

DROP TABLE IF EXISTS `rechnung`;

CREATE TABLE `rechnung` (
  `rg_id` int(11) NOT NULL,
  `rg_kdid` int(11) DEFAULT NULL,
  `rg_rgnr` int(11) DEFAULT NULL,
  `rg_rgdatum` date DEFAULT NULL,
  PRIMARY KEY (`rg_id`),
  FOREIGN KEY (`rg_kdid`) REFERENCES `kunde` (`kd_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (0, 21, 888, '2014-12-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (1, 19, 515, '2013-09-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (2, 11, 833, '2011-04-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (3, 22, 871, '2014-01-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (4, 16, 444, '2020-02-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (5, 22, 196, '2012-02-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (6, 10, 898, '2013-05-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (7, 14, 645, '2020-08-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (8, 24, 281, '2019-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (9, 2, 988, '2012-12-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (10, 9, 230, '2016-01-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (11, 23, 220, '2013-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (12, 23, 856, '2016-06-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (13, 29, 809, '2017-02-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (14, 4, 252, '2011-10-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (15, 0, 564, '2011-04-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (16, 0, 875, '2017-03-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (17, 26, 169, '2012-05-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (18, 12, 266, '2014-01-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (19, 17, 564, '2016-11-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (20, 24, 498, '2012-12-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (21, 15, 656, '2016-07-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (22, 6, 819, '2014-06-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (23, 12, 640, '2013-02-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (24, 4, 570, '2013-08-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (25, 1, 523, '2012-05-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (26, 9, 827, '2015-07-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (27, 21, 58, '2017-10-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (28, 1, 330, '2011-07-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (29, 29, 427, '2019-12-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (30, 12, 184, '2015-05-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (31, 24, 540, '2018-06-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (32, 21, 9, '2020-03-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (33, 20, 946, '2011-08-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (34, 25, 52, '2019-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (35, 29, 623, '2017-09-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (36, 15, 601, '2019-07-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (37, 13, 915, '2016-03-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (38, 4, 753, '2015-12-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (39, 4, 803, '2015-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (40, 6, 261, '2012-08-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (41, 29, 979, '2013-03-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (42, 27, 143, '2012-05-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (43, 21, 871, '2018-12-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (44, 9, 88, '2012-10-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (45, 28, 797, '2012-09-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (46, 4, 635, '2017-05-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (47, 8, 594, '2017-12-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (48, 5, 395, '2011-05-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (49, 6, 941, '2016-12-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (50, 13, 838, '2020-12-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (51, 13, 284, '2013-08-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (52, 17, 721, '2012-12-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (53, 19, 2, '2011-03-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (54, 27, 198, '2013-05-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (55, 26, 848, '2017-09-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (56, 27, 686, '2012-05-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (57, 4, 844, '2021-02-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (58, 15, 391, '2020-11-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (59, 14, 144, '2014-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (60, 19, 364, '2019-02-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (61, 18, 478, '2011-09-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (62, 6, 647, '2013-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (63, 24, 253, '2019-01-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (64, 15, 626, '2016-01-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (65, 19, 669, '2013-01-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (66, 17, 956, '2020-03-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (67, 8, 686, '2019-04-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (68, 0, 72, '2013-12-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (69, 25, 373, '2015-11-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (70, 5, 100, '2015-08-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (71, 18, 772, '2013-10-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (72, 20, 711, '2018-11-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (73, 5, 647, '2013-01-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (74, 9, 217, '2011-04-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (75, 26, 633, '2019-08-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (76, 23, 312, '2011-12-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (77, 20, 11, '2014-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (78, 21, 751, '2011-07-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (79, 21, 85, '2020-01-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (80, 26, 84, '2021-02-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (81, 24, 475, '2015-02-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (82, 25, 409, '2020-03-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (83, 0, 729, '2020-07-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (84, 23, 898, '2015-04-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (85, 28, 362, '2013-12-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (86, 10, 67, '2019-03-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (87, 5, 437, '2018-08-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (88, 5, 574, '2016-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (89, 29, 241, '2015-06-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (90, 9, 389, '2019-01-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (91, 10, 943, '2011-07-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (92, 16, 612, '2020-05-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (93, 3, 122, '2013-08-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (94, 18, 952, '2019-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (95, 3, 947, '2020-11-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (96, 5, 654, '2019-02-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (97, 12, 485, '2017-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (98, 3, 101, '2014-08-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (99, 25, 84, '2019-08-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (100, 16, 851, '2013-04-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (101, 10, 365, '2019-10-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (102, 12, 646, '2013-11-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (103, 12, 674, '2019-02-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (104, 23, 829, '2018-02-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (105, 21, 467, '2014-12-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (106, 13, 715, '2013-08-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (107, 6, 898, '2017-08-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (108, 10, 99, '2020-02-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (109, 16, 171, '2017-04-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (110, 19, 480, '2012-02-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (111, 26, 596, '2020-02-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (112, 19, 661, '2020-03-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (113, 8, 679, '2018-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (114, 5, 888, '2012-07-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (115, 20, 477, '2011-06-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (116, 14, 700, '2014-03-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (117, 26, 983, '2015-11-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (118, 12, 159, '2018-07-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (119, 5, 244, '2021-01-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (120, 11, 760, '2014-03-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (121, 11, 627, '2012-12-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (122, 24, 467, '2020-03-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (123, 7, 535, '2013-04-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (124, 11, 805, '2015-09-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (125, 20, 305, '2011-09-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (126, 26, 522, '2018-11-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (127, 25, 481, '2018-08-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (128, 7, 130, '2013-01-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (129, 6, 768, '2018-10-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (130, 0, 826, '2018-08-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (131, 15, 755, '2019-03-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (132, 9, 231, '2012-01-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (133, 4, 981, '2018-10-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (134, 18, 371, '2013-09-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (135, 12, 564, '2012-03-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (136, 4, 556, '2016-11-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (137, 22, 277, '2014-06-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (138, 17, 687, '2013-10-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (139, 16, 859, '2019-10-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (140, 26, 998, '2014-04-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (141, 19, 194, '2020-03-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (142, 10, 551, '2014-06-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (143, 3, 586, '2018-05-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (144, 14, 947, '2018-10-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (145, 27, 48, '2016-01-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (146, 24, 502, '2016-03-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (147, 29, 611, '2016-09-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (148, 6, 497, '2020-08-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (149, 15, 53, '2016-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (150, 15, 164, '2020-03-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (151, 16, 815, '2020-02-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (152, 12, 587, '2017-10-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (153, 23, 652, '2015-08-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (154, 26, 738, '2018-09-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (155, 27, 778, '2017-11-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (156, 11, 701, '2011-07-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (157, 9, 997, '2011-12-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (158, 1, 427, '2017-06-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (159, 3, 29, '2016-07-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (160, 20, 130, '2020-03-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (161, 13, 886, '2013-11-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (162, 1, 840, '2013-06-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (163, 16, 902, '2015-10-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (164, 15, 741, '2019-04-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (165, 4, 437, '2015-04-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (166, 18, 299, '2020-07-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (167, 14, 259, '2017-12-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (168, 23, 651, '2020-03-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (169, 11, 999, '2017-01-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (170, 9, 949, '2013-06-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (171, 1, 212, '2017-04-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (172, 16, 10, '2019-09-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (173, 10, 769, '2016-12-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (174, 25, 314, '2012-12-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (175, 15, 875, '2012-02-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (176, 24, 575, '2016-01-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (177, 18, 962, '2016-07-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (178, 16, 234, '2018-02-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (179, 29, 223, '2020-01-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (180, 3, 735, '2017-10-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (181, 21, 32, '2018-12-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (182, 28, 732, '2018-06-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (183, 25, 431, '2015-01-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (184, 0, 203, '2017-03-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (185, 8, 355, '2014-04-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (186, 7, 734, '2014-04-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (187, 11, 881, '2014-02-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (188, 7, 54, '2016-08-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (189, 2, 532, '2018-02-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (190, 10, 863, '2014-02-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (191, 15, 772, '2012-11-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (192, 2, 4, '2019-01-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (193, 3, 918, '2016-01-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (194, 26, 489, '2019-05-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (195, 14, 172, '2017-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (196, 6, 417, '2018-06-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (197, 4, 636, '2013-07-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (198, 20, 397, '2020-11-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (199, 4, 889, '2019-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (200, 7, 28, '2014-05-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (201, 16, 411, '2016-01-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (202, 5, 333, '2019-03-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (203, 9, 659, '2012-02-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (204, 13, 910, '2020-03-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (205, 1, 677, '2014-08-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (206, 5, 542, '2016-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (207, 12, 953, '2014-09-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (208, 23, 72, '2013-02-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (209, 3, 791, '2012-12-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (210, 23, 66, '2018-11-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (211, 28, 81, '2018-05-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (212, 22, 226, '2016-04-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (213, 18, 904, '2020-12-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (214, 0, 873, '2019-03-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (215, 10, 17, '2012-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (216, 7, 617, '2018-04-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (217, 3, 954, '2014-06-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (218, 7, 572, '2014-11-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (219, 14, 167, '2017-02-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (220, 20, 616, '2016-06-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (221, 20, 692, '2014-06-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (222, 19, 556, '2018-07-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (223, 11, 133, '2020-05-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (224, 23, 709, '2013-05-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (225, 11, 728, '2012-10-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (226, 26, 886, '2017-05-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (227, 11, 400, '2020-03-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (228, 8, 653, '2019-06-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (229, 18, 736, '2019-09-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (230, 11, 347, '2018-11-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (231, 8, 539, '2012-01-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (232, 4, 440, '2014-06-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (233, 8, 465, '2015-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (234, 2, 667, '2018-09-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (235, 15, 336, '2016-10-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (236, 3, 769, '2015-03-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (237, 11, 662, '2018-05-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (238, 1, 524, '2019-08-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (239, 22, 761, '2018-10-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (240, 23, 172, '2015-06-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (241, 24, 209, '2015-05-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (242, 7, 692, '2016-11-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (243, 7, 239, '2011-10-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (244, 15, 610, '2019-03-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (245, 17, 414, '2014-06-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (246, 9, 502, '2013-10-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (247, 8, 722, '2015-05-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (248, 24, 231, '2018-04-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (249, 24, 65, '2015-02-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (250, 6, 432, '2017-11-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (251, 9, 807, '2012-12-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (252, 24, 768, '2012-07-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (253, 28, 663, '2017-02-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (254, 13, 637, '2012-07-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (255, 5, 425, '2012-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (256, 22, 567, '2018-10-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (257, 21, 376, '2011-11-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (258, 27, 803, '2011-12-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (259, 13, 476, '2018-05-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (260, 19, 823, '2011-11-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (261, 29, 861, '2018-01-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (262, 4, 878, '2019-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (263, 16, 296, '2011-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (264, 26, 436, '2016-01-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (265, 23, 429, '2014-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (266, 27, 966, '2016-09-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (267, 2, 639, '2014-02-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (268, 10, 124, '2019-07-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (269, 24, 829, '2018-09-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (270, 17, 913, '2015-05-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (271, 24, 691, '2015-09-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (272, 1, 345, '2016-01-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (273, 7, 56, '2015-04-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (274, 17, 648, '2015-05-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (275, 4, 480, '2014-03-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (276, 2, 178, '2020-02-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (277, 24, 100, '2012-03-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (278, 16, 481, '2019-09-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (279, 22, 622, '2016-11-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (280, 7, 624, '2015-12-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (281, 16, 288, '2011-03-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (282, 17, 558, '2020-11-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (283, 16, 385, '2017-12-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (284, 3, 603, '2019-04-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (285, 27, 318, '2012-12-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (286, 8, 239, '2012-12-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (287, 28, 519, '2012-07-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (288, 17, 769, '2021-02-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (289, 19, 483, '2014-08-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (290, 18, 923, '2011-05-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (291, 5, 408, '2019-11-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (292, 16, 872, '2016-04-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (293, 6, 628, '2013-12-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (294, 0, 776, '2011-07-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (295, 14, 813, '2013-07-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (296, 1, 29, '2013-07-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (297, 20, 115, '2017-09-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (298, 19, 106, '2018-11-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (299, 0, 954, '2018-05-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (300, 4, 193, '2017-10-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (301, 3, 458, '2015-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (302, 19, 627, '2018-03-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (303, 14, 51, '2015-11-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (304, 24, 609, '2017-04-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (305, 6, 459, '2015-01-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (306, 1, 643, '2014-04-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (307, 0, 491, '2020-11-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (308, 27, 778, '2014-06-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (309, 17, 576, '2016-05-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (310, 15, 542, '2020-11-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (311, 0, 695, '2012-08-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (312, 15, 582, '2019-08-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (313, 17, 539, '2020-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (314, 15, 663, '2011-12-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (315, 19, 610, '2012-05-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (316, 3, 835, '2020-12-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (317, 4, 944, '2019-09-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (318, 25, 383, '2018-08-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (319, 7, 672, '2020-09-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (320, 18, 76, '2011-05-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (321, 26, 914, '2013-06-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (322, 3, 509, '2012-05-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (323, 8, 846, '2019-01-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (324, 18, 612, '2019-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (325, 15, 432, '2020-11-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (326, 21, 646, '2019-01-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (327, 22, 379, '2011-08-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (328, 12, 993, '2012-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (329, 24, 947, '2013-07-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (330, 15, 263, '2015-06-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (331, 17, 684, '2014-03-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (332, 11, 119, '2015-03-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (333, 6, 524, '2014-10-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (334, 9, 990, '2015-10-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (335, 17, 538, '2012-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (336, 20, 824, '2011-04-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (337, 22, 714, '2020-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (338, 26, 354, '2014-02-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (339, 22, 116, '2013-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (340, 20, 174, '2019-11-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (341, 21, 510, '2011-04-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (342, 1, 257, '2017-02-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (343, 4, 951, '2017-03-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (344, 0, 261, '2015-05-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (345, 22, 868, '2018-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (346, 20, 437, '2016-05-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (347, 14, 380, '2016-02-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (348, 19, 954, '2019-01-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (349, 23, 302, '2011-07-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (350, 13, 343, '2015-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (351, 27, 238, '2021-02-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (352, 7, 1, '2011-08-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (353, 1, 579, '2011-05-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (354, 25, 481, '2018-05-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (355, 0, 706, '2016-05-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (356, 9, 105, '2020-10-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (357, 16, 754, '2019-06-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (358, 13, 739, '2020-03-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (359, 7, 628, '2017-10-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (360, 7, 157, '2012-11-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (361, 9, 278, '2014-05-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (362, 28, 492, '2020-01-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (363, 29, 691, '2020-02-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (364, 5, 764, '2019-09-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (365, 11, 464, '2020-02-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (366, 19, 802, '2015-07-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (367, 28, 924, '2018-12-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (368, 21, 135, '2019-09-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (369, 18, 621, '2013-05-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (370, 20, 934, '2014-12-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (371, 7, 990, '2019-10-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (372, 16, 680, '2017-12-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (373, 26, 486, '2011-04-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (374, 10, 923, '2012-05-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (375, 29, 193, '2017-04-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (376, 1, 200, '2018-04-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (377, 5, 695, '2016-05-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (378, 23, 897, '2013-06-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (379, 10, 188, '2020-05-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (380, 3, 856, '2016-12-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (381, 29, 184, '2012-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (382, 8, 414, '2015-12-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (383, 12, 383, '2015-06-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (384, 1, 431, '2015-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (385, 12, 265, '2013-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (386, 25, 109, '2013-05-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (387, 29, 51, '2011-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (388, 3, 232, '2019-04-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (389, 24, 389, '2016-03-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (390, 2, 398, '2019-11-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (391, 29, 949, '2015-10-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (392, 27, 838, '2011-10-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (393, 16, 937, '2014-02-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (394, 29, 536, '2017-07-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (395, 8, 80, '2012-09-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (396, 18, 238, '2017-01-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (397, 17, 151, '2018-04-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (398, 18, 174, '2016-02-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (399, 27, 235, '2012-09-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (400, 6, 747, '2020-08-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (401, 2, 777, '2019-08-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (402, 12, 170, '2015-05-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (403, 28, 482, '2020-04-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (404, 3, 614, '2014-11-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (405, 8, 611, '2018-11-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (406, 17, 513, '2020-08-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (407, 25, 174, '2011-10-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (408, 19, 151, '2019-03-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (409, 12, 610, '2019-12-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (410, 18, 470, '2014-09-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (411, 5, 687, '2016-01-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (412, 13, 490, '2016-08-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (413, 11, 519, '2017-06-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (414, 16, 101, '2016-12-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (415, 0, 157, '2019-08-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (416, 3, 552, '2016-12-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (417, 6, 522, '2020-10-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (418, 5, 536, '2015-06-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (419, 18, 498, '2021-03-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (420, 18, 55, '2018-07-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (421, 28, 539, '2018-03-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (422, 3, 703, '2020-02-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (423, 19, 575, '2016-07-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (424, 1, 840, '2015-03-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (425, 0, 294, '2018-05-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (426, 4, 454, '2019-09-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (427, 3, 714, '2012-09-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (428, 9, 886, '2019-09-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (429, 29, 264, '2014-04-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (430, 28, 579, '2020-08-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (431, 3, 949, '2019-09-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (432, 7, 339, '2017-06-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (433, 28, 774, '2011-03-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (434, 17, 179, '2018-11-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (435, 26, 392, '2011-04-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (436, 3, 430, '2013-03-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (437, 4, 603, '2016-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (438, 16, 432, '2019-07-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (439, 14, 126, '2012-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (440, 8, 463, '2012-09-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (441, 2, 348, '2020-12-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (442, 15, 77, '2015-11-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (443, 20, 621, '2018-02-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (444, 2, 200, '2013-04-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (445, 16, 145, '2016-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (446, 1, 293, '2018-06-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (447, 15, 877, '2019-04-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (448, 25, 721, '2017-07-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (449, 23, 950, '2016-06-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (450, 24, 833, '2018-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (451, 12, 419, '2016-09-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (452, 27, 82, '2017-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (453, 19, 533, '2019-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (454, 28, 259, '2017-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (455, 6, 521, '2018-04-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (456, 24, 473, '2012-08-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (457, 22, 452, '2019-06-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (458, 0, 336, '2019-05-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (459, 5, 405, '2019-01-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (460, 6, 347, '2011-08-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (461, 2, 854, '2016-09-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (462, 0, 440, '2019-10-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (463, 24, 107, '2014-01-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (464, 0, 939, '2017-06-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (465, 19, 944, '2015-02-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (466, 4, 806, '2019-02-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (467, 9, 259, '2011-09-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (468, 8, 597, '2017-04-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (469, 0, 546, '2017-05-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (470, 14, 7, '2012-02-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (471, 8, 492, '2020-07-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (472, 20, 64, '2019-10-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (473, 29, 93, '2016-01-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (474, 10, 369, '2015-09-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (475, 29, 230, '2020-10-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (476, 7, 214, '2017-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (477, 15, 311, '2018-01-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (478, 1, 275, '2021-01-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (479, 18, 691, '2017-10-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (480, 29, 560, '2019-08-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (481, 10, 500, '2012-06-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (482, 21, 818, '2017-10-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (483, 8, 596, '2012-03-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (484, 23, 430, '2016-07-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (485, 3, 11, '2017-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (486, 29, 67, '2014-02-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (487, 18, 595, '2020-05-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (488, 21, 850, '2020-09-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (489, 10, 635, '2014-12-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (490, 19, 509, '2012-01-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (491, 14, 379, '2014-10-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (492, 6, 304, '2019-05-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (493, 26, 808, '2018-12-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (494, 26, 862, '2014-12-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (495, 20, 646, '2016-12-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (496, 22, 634, '2018-03-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (497, 26, 992, '2020-01-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (498, 1, 349, '2020-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (499, 2, 138, '2018-10-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (500, 29, 211, '2019-11-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (501, 3, 381, '2019-02-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (502, 11, 884, '2017-10-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (503, 17, 271, '2012-06-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (504, 15, 183, '2014-02-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (505, 1, 798, '2012-10-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (506, 27, 27, '2020-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (507, 17, 116, '2018-03-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (508, 21, 526, '2019-06-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (509, 6, 98, '2011-06-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (510, 10, 260, '2014-09-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (511, 11, 139, '2020-09-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (512, 2, 219, '2019-08-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (513, 19, 832, '2013-03-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (514, 22, 184, '2015-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (515, 15, 654, '2016-01-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (516, 25, 875, '2018-10-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (517, 13, 774, '2019-05-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (518, 2, 270, '2016-02-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (519, 20, 16, '2019-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (520, 25, 778, '2013-10-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (521, 10, 715, '2018-01-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (522, 3, 321, '2020-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (523, 4, 260, '2013-02-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (524, 2, 264, '2014-01-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (525, 25, 89, '2011-03-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (526, 11, 962, '2018-11-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (527, 17, 937, '2017-02-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (528, 22, 767, '2017-03-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (529, 7, 564, '2013-10-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (530, 21, 421, '2019-02-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (531, 4, 913, '2016-11-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (532, 9, 821, '2016-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (533, 19, 316, '2017-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (534, 2, 298, '2014-01-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (535, 28, 882, '2015-04-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (536, 26, 652, '2017-07-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (537, 29, 97, '2018-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (538, 27, 414, '2018-09-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (539, 21, 542, '2013-12-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (540, 27, 28, '2021-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (541, 10, 366, '2017-09-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (542, 28, 519, '2012-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (543, 26, 913, '2014-11-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (544, 8, 718, '2016-06-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (545, 22, 199, '2020-02-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (546, 23, 271, '2012-05-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (547, 2, 596, '2017-03-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (548, 20, 944, '2012-02-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (549, 10, 856, '2012-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (550, 8, 138, '2016-04-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (551, 11, 292, '2020-11-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (552, 13, 378, '2019-06-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (553, 13, 634, '2013-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (554, 27, 897, '2013-07-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (555, 13, 302, '2015-01-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (556, 27, 46, '2017-08-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (557, 21, 959, '2017-09-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (558, 4, 854, '2016-05-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (559, 13, 462, '2019-04-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (560, 16, 51, '2014-09-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (561, 26, 392, '2015-02-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (562, 17, 718, '2013-06-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (563, 11, 148, '2017-04-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (564, 5, 90, '2018-09-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (565, 28, 216, '2016-12-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (566, 6, 904, '2018-01-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (567, 16, 809, '2020-01-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (568, 28, 952, '2016-12-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (569, 10, 399, '2017-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (570, 12, 745, '2012-03-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (571, 9, 187, '2015-10-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (572, 15, 194, '2016-02-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (573, 14, 319, '2018-02-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (574, 3, 584, '2013-11-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (575, 27, 954, '2020-02-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (576, 6, 907, '2020-11-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (577, 12, 657, '2017-11-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (578, 0, 23, '2013-07-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (579, 17, 719, '2013-10-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (580, 18, 84, '2014-05-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (581, 20, 226, '2011-12-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (582, 21, 935, '2015-06-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (583, 28, 319, '2016-04-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (584, 12, 321, '2012-07-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (585, 21, 1, '2011-12-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (586, 27, 580, '2018-07-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (587, 7, 289, '2017-02-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (588, 10, 701, '2019-06-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (589, 22, 360, '2018-10-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (590, 0, 235, '2019-04-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (591, 18, 127, '2013-06-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (592, 2, 346, '2018-12-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (593, 24, 63, '2013-05-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (594, 3, 260, '2011-11-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (595, 11, 15, '2017-04-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (596, 21, 904, '2013-03-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (597, 12, 676, '2011-10-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (598, 1, 700, '2019-02-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (599, 9, 287, '2012-03-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (600, 19, 367, '2019-07-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (601, 22, 637, '2011-06-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (602, 4, 754, '2013-05-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (603, 8, 644, '2014-05-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (604, 21, 715, '2020-07-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (605, 11, 780, '2019-06-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (606, 5, 708, '2013-04-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (607, 29, 346, '2015-08-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (608, 20, 436, '2017-08-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (609, 20, 208, '2017-06-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (610, 12, 76, '2015-08-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (611, 9, 842, '2017-05-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (612, 26, 45, '2011-04-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (613, 6, 909, '2018-05-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (614, 23, 388, '2021-03-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (615, 12, 136, '2014-08-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (616, 14, 313, '2019-12-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (617, 23, 104, '2012-08-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (618, 14, 929, '2014-12-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (619, 15, 296, '2014-01-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (620, 13, 679, '2012-05-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (621, 17, 269, '2013-03-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (622, 23, 280, '2018-01-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (623, 2, 670, '2015-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (624, 22, 335, '2012-01-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (625, 22, 98, '2020-01-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (626, 9, 836, '2011-04-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (627, 7, 939, '2020-11-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (628, 6, 709, '2017-07-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (629, 13, 495, '2019-03-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (630, 24, 481, '2020-10-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (631, 8, 598, '2015-07-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (632, 9, 817, '2019-08-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (633, 11, 492, '2017-12-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (634, 20, 416, '2013-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (635, 28, 888, '2013-12-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (636, 12, 512, '2011-06-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (637, 21, 461, '2017-04-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (638, 22, 24, '2018-06-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (639, 4, 427, '2016-07-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (640, 4, 476, '2014-05-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (641, 20, 663, '2015-01-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (642, 9, 906, '2020-11-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (643, 23, 550, '2020-03-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (644, 10, 593, '2018-11-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (645, 2, 341, '2016-03-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (646, 13, 124, '2020-06-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (647, 6, 52, '2020-06-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (648, 27, 840, '2016-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (649, 9, 991, '2013-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (650, 14, 853, '2012-02-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (651, 14, 889, '2012-07-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (652, 20, 33, '2018-11-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (653, 9, 337, '2020-08-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (654, 8, 25, '2014-01-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (655, 4, 778, '2019-08-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (656, 8, 845, '2016-06-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (657, 20, 511, '2019-02-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (658, 16, 684, '2015-07-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (659, 29, 636, '2020-05-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (660, 28, 36, '2018-03-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (661, 11, 605, '2020-05-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (662, 25, 267, '2012-12-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (663, 6, 431, '2019-06-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (664, 21, 493, '2013-10-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (665, 7, 373, '2016-10-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (666, 0, 609, '2019-10-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (667, 12, 34, '2017-09-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (668, 17, 777, '2014-06-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (669, 12, 63, '2020-09-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (670, 2, 536, '2019-10-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (671, 6, 790, '2012-12-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (672, 26, 698, '2013-02-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (673, 7, 735, '2012-11-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (674, 2, 933, '2016-01-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (675, 20, 240, '2020-09-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (676, 0, 455, '2011-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (677, 21, 255, '2013-08-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (678, 16, 159, '2018-11-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (679, 26, 112, '2014-03-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (680, 18, 178, '2018-08-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (681, 7, 17, '2014-10-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (682, 20, 710, '2017-08-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (683, 17, 774, '2012-09-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (684, 10, 437, '2014-11-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (685, 15, 67, '2017-09-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (686, 14, 207, '2011-10-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (687, 5, 747, '2017-10-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (688, 29, 583, '2021-01-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (689, 8, 107, '2011-09-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (690, 21, 868, '2020-08-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (691, 15, 578, '2012-02-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (692, 1, 91, '2016-10-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (693, 28, 833, '2014-12-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (694, 13, 253, '2013-01-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (695, 20, 394, '2019-03-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (696, 15, 11, '2017-07-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (697, 14, 258, '2014-05-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (698, 25, 307, '2014-01-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (699, 10, 949, '2015-11-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (700, 23, 49, '2017-02-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (701, 1, 389, '2015-01-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (702, 4, 897, '2016-12-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (703, 27, 88, '2017-08-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (704, 23, 43, '2019-02-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (705, 29, 312, '2015-05-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (706, 19, 588, '2014-08-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (707, 22, 129, '2013-08-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (708, 13, 412, '2016-02-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (709, 14, 574, '2019-09-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (710, 3, 725, '2011-09-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (711, 19, 237, '2019-11-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (712, 1, 504, '2019-11-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (713, 9, 348, '2013-06-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (714, 25, 134, '2011-07-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (715, 7, 640, '2017-06-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (716, 18, 36, '2014-05-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (717, 28, 462, '2019-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (718, 7, 420, '2011-09-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (719, 0, 720, '2019-05-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (720, 2, 969, '2014-12-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (721, 17, 263, '2015-09-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (722, 13, 591, '2013-11-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (723, 7, 742, '2020-12-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (724, 25, 294, '2015-03-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (725, 22, 848, '2012-08-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (726, 22, 267, '2020-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (727, 28, 405, '2019-06-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (728, 26, 331, '2014-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (729, 12, 741, '2017-02-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (730, 12, 947, '2011-05-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (731, 14, 694, '2016-08-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (732, 19, 871, '2014-09-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (733, 3, 190, '2014-12-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (734, 5, 368, '2011-05-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (735, 24, 901, '2017-06-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (736, 5, 432, '2016-07-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (737, 22, 571, '2018-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (738, 1, 429, '2017-09-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (739, 2, 224, '2019-09-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (740, 6, 614, '2018-10-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (741, 13, 710, '2013-09-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (742, 1, 606, '2019-09-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (743, 18, 514, '2011-12-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (744, 9, 171, '2017-02-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (745, 27, 873, '2016-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (746, 11, 222, '2016-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (747, 27, 336, '2012-01-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (748, 24, 70, '2018-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (749, 25, 627, '2018-02-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (750, 28, 992, '2011-10-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (751, 10, 901, '2011-11-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (752, 7, 198, '2017-03-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (753, 24, 477, '2011-06-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (754, 12, 664, '2018-09-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (755, 5, 175, '2020-10-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (756, 14, 561, '2011-11-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (757, 2, 296, '2018-01-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (758, 29, 366, '2012-08-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (759, 10, 991, '2016-06-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (760, 0, 386, '2021-02-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (761, 23, 37, '2012-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (762, 2, 357, '2016-08-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (763, 26, 337, '2018-10-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (764, 26, 749, '2016-08-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (765, 9, 837, '2012-03-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (766, 28, 778, '2018-03-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (767, 25, 64, '2018-10-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (768, 11, 969, '2014-04-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (769, 14, 552, '2020-11-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (770, 18, 298, '2018-02-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (771, 9, 256, '2013-09-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (772, 21, 340, '2015-07-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (773, 27, 754, '2014-08-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (774, 26, 188, '2014-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (775, 29, 550, '2015-11-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (776, 6, 987, '2014-02-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (777, 12, 758, '2016-12-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (778, 12, 927, '2012-04-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (779, 27, 632, '2018-07-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (780, 10, 2, '2013-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (781, 23, 535, '2016-03-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (782, 6, 777, '2013-12-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (783, 6, 892, '2018-11-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (784, 9, 887, '2015-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (785, 23, 978, '2015-05-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (786, 0, 697, '2013-04-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (787, 14, 305, '2016-01-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (788, 20, 851, '2017-12-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (789, 22, 601, '2019-04-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (790, 11, 408, '2015-04-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (791, 4, 923, '2014-06-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (792, 27, 598, '2021-01-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (793, 25, 416, '2017-01-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (794, 17, 853, '2020-04-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (795, 22, 994, '2019-04-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (796, 3, 350, '2019-06-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (797, 19, 522, '2016-10-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (798, 3, 978, '2014-04-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (799, 28, 243, '2016-02-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (800, 16, 565, '2018-06-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (801, 18, 791, '2016-11-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (802, 17, 652, '2018-08-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (803, 5, 468, '2018-08-31');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (804, 1, 532, '2013-03-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (805, 17, 676, '2018-04-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (806, 28, 771, '2011-10-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (807, 21, 25, '2016-01-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (808, 16, 687, '2015-03-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (809, 7, 966, '2012-02-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (810, 25, 163, '2013-06-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (811, 5, 79, '2011-10-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (812, 28, 972, '2017-08-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (813, 4, 186, '2011-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (814, 25, 213, '2012-10-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (815, 0, 565, '2012-02-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (816, 7, 664, '2013-07-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (817, 15, 969, '2018-10-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (818, 18, 587, '2011-04-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (819, 19, 826, '2012-09-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (820, 27, 475, '2018-01-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (821, 16, 176, '2020-05-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (822, 21, 690, '2015-02-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (823, 9, 247, '2013-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (824, 14, 298, '2016-10-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (825, 14, 859, '2018-09-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (826, 13, 632, '2011-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (827, 11, 712, '2016-05-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (828, 14, 397, '2011-10-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (829, 22, 28, '2016-03-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (830, 5, 219, '2018-05-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (831, 25, 60, '2012-03-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (832, 22, 304, '2021-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (833, 20, 668, '2020-10-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (834, 2, 67, '2012-11-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (835, 27, 492, '2018-03-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (836, 20, 711, '2013-08-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (837, 16, 722, '2011-08-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (838, 9, 25, '2020-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (839, 5, 972, '2013-12-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (840, 29, 785, '2018-06-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (841, 14, 786, '2019-12-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (842, 12, 34, '2019-11-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (843, 19, 350, '2018-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (844, 25, 404, '2014-10-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (845, 12, 554, '2011-03-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (846, 25, 887, '2015-07-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (847, 11, 812, '2012-10-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (848, 5, 825, '2017-06-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (849, 11, 105, '2018-12-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (850, 26, 46, '2013-10-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (851, 23, 32, '2019-09-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (852, 25, 633, '2016-12-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (853, 1, 106, '2018-01-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (854, 0, 964, '2020-11-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (855, 28, 774, '2012-01-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (856, 13, 351, '2019-05-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (857, 8, 771, '2013-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (858, 1, 978, '2014-09-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (859, 10, 470, '2012-01-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (860, 22, 123, '2012-11-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (861, 5, 476, '2016-03-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (862, 28, 16, '2020-05-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (863, 22, 752, '2015-09-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (864, 2, 26, '2017-08-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (865, 15, 293, '2018-11-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (866, 19, 393, '2011-12-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (867, 25, 176, '2012-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (868, 25, 249, '2014-12-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (869, 13, 305, '2021-03-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (870, 24, 143, '2014-04-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (871, 27, 746, '2016-03-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (872, 5, 894, '2018-06-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (873, 1, 48, '2011-03-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (874, 5, 842, '2021-01-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (875, 16, 285, '2015-08-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (876, 24, 486, '2020-09-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (877, 2, 246, '2013-09-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (878, 18, 933, '2019-04-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (879, 17, 72, '2020-04-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (880, 24, 857, '2018-05-14');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (881, 4, 183, '2018-12-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (882, 7, 77, '2017-08-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (883, 6, 148, '2018-02-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (884, 15, 255, '2017-02-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (885, 16, 687, '2020-04-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (886, 26, 404, '2015-09-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (887, 8, 946, '2018-03-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (888, 10, 537, '2019-03-02');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (889, 25, 932, '2016-07-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (890, 21, 452, '2019-11-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (891, 0, 360, '2013-09-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (892, 29, 899, '2012-03-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (893, 20, 393, '2011-09-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (894, 0, 872, '2014-08-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (895, 14, 91, '2020-09-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (896, 17, 424, '2017-01-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (897, 23, 508, '2020-10-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (898, 10, 480, '2017-11-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (899, 21, 83, '2018-05-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (900, 7, 171, '2017-04-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (901, 26, 802, '2013-11-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (902, 19, 733, '2014-05-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (903, 13, 777, '2012-12-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (904, 0, 868, '2014-06-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (905, 29, 469, '2015-03-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (906, 21, 517, '2020-06-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (907, 17, 730, '2018-10-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (908, 8, 41, '2020-05-07');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (909, 6, 287, '2017-01-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (910, 18, 202, '2019-10-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (911, 18, 296, '2018-04-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (912, 8, 20, '2012-05-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (913, 13, 793, '2015-08-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (914, 3, 861, '2012-09-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (915, 10, 526, '2013-06-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (916, 18, 503, '2018-02-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (917, 29, 964, '2018-03-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (918, 14, 5, '2019-02-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (919, 15, 313, '2020-01-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (920, 19, 724, '2013-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (921, 15, 671, '2018-12-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (922, 1, 912, '2020-06-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (923, 5, 540, '2017-03-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (924, 0, 128, '2018-03-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (925, 2, 558, '2013-04-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (926, 8, 528, '2015-04-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (927, 10, 894, '2014-08-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (928, 1, 967, '2013-05-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (929, 14, 353, '2018-05-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (930, 27, 466, '2018-08-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (931, 2, 142, '2019-03-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (932, 23, 395, '2020-01-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (933, 28, 708, '2016-12-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (934, 29, 207, '2017-05-09');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (935, 22, 583, '2011-12-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (936, 9, 974, '2013-01-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (937, 17, 511, '2019-02-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (938, 2, 124, '2011-06-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (939, 4, 14, '2015-10-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (940, 6, 989, '2012-08-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (941, 27, 819, '2018-07-27');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (942, 7, 863, '2013-05-26');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (943, 24, 961, '2017-11-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (944, 16, 483, '2017-10-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (945, 5, 253, '2014-08-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (946, 1, 901, '2017-01-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (947, 14, 686, '2012-03-24');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (948, 13, 163, '2017-02-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (949, 11, 555, '2016-05-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (950, 29, 941, '2019-06-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (951, 0, 571, '2019-02-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (952, 8, 878, '2020-09-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (953, 8, 617, '2020-09-17');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (954, 15, 875, '2015-03-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (955, 9, 507, '2017-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (956, 11, 36, '2012-06-30');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (957, 8, 425, '2020-06-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (958, 4, 483, '2011-09-19');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (959, 21, 767, '2015-04-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (960, 6, 163, '2013-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (961, 25, 662, '2018-06-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (962, 22, 540, '2011-09-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (963, 28, 619, '2018-03-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (964, 4, 565, '2019-09-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (965, 2, 488, '2012-09-22');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (966, 8, 204, '2020-05-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (967, 7, 418, '2020-02-28');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (968, 25, 590, '2015-01-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (969, 10, 12, '2020-10-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (970, 24, 964, '2021-01-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (971, 23, 924, '2015-01-08');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (972, 16, 911, '2016-04-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (973, 2, 955, '2018-02-03');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (974, 18, 91, '2018-04-15');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (975, 19, 166, '2020-10-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (976, 12, 775, '2019-04-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (977, 18, 503, '2018-07-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (978, 27, 394, '2019-11-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (979, 24, 163, '2019-02-16');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (980, 3, 87, '2018-11-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (981, 13, 635, '2015-06-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (982, 28, 705, '2019-11-12');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (983, 8, 54, '2011-06-25');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (984, 0, 534, '2020-11-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (985, 13, 605, '2016-12-10');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (986, 23, 70, '2012-05-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (987, 1, 37, '2018-06-05');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (988, 24, 928, '2019-03-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (989, 11, 542, '2018-07-13');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (990, 3, 134, '2015-11-21');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (991, 6, 479, '2019-08-29');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (992, 23, 695, '2012-01-06');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (993, 23, 631, '2013-03-18');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (994, 17, 534, '2015-01-11');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (995, 13, 503, '2014-02-04');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (996, 26, 449, '2014-06-20');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (997, 1, 784, '2012-11-23');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (998, 13, 857, '2016-01-01');
INSERT INTO `rechnung` (`rg_id`, `rg_kdid`, `rg_rgnr`, `rg_rgdatum`) VALUES (999, 5, 513, '2011-08-31');

#
# TABLE STRUCTURE FOR: artikel
#

DROP TABLE IF EXISTS `artikel`;

CREATE TABLE `artikel` (
  `art_id` int(11) NOT NULL,
  `art_nr` varchar(69) DEFAULT NULL,
  `art_bezeichnung` varchar(69) DEFAULT NULL,
  `art_preis` float DEFAULT NULL,
  `art_arttypid` int(11) DEFAULT NULL,
  `art_weintypid` int(11) DEFAULT NULL,
  `art_geschmacktypid` int(11) DEFAULT NULL,
  PRIMARY KEY (`art_id`),
  FOREIGN KEY (`art_arttypid`) REFERENCES `artikel_typ` (`arttyp_id`),
  FOREIGN KEY (`art_weintypid`) REFERENCES `wein_typ` (`weintyp_id`),
  FOREIGN KEY (`art_geschmacktypid`) REFERENCES `geschmack_typ` (`geschmack_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (0, '33693', 'Non repudiandae autem quaerat.', '18.53', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (1, '75973', 'Consequatur autem dolores distinctio.', '19.38', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (2, '54500', 'Unde reprehenderit.', '20.8', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (3, '93894', 'Eos tempore omnis dolor.', '40.67', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (4, '50728', 'Dicta ex nostrum.', '17.6', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (5, '77348', 'Sequi possimus et.', '56.24', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (6, '44119', 'Eveniet consectetur aliquid.', '57.63', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (7, '01222', 'Animi voluptatum exercitationem.', '78.03', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (8, '48186', 'Vel eius impedit quisquam eius.', '9.08', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (9, '94444', 'Qui dignissimos dolor.', '21.84', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (10, '97868', 'Ipsum dignissimos quibusdam.', '37.16', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (11, '07153', 'Aliquam quia eius.', '57.09', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (12, '70203', 'Magni officiis vel est vero.', '83.99', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (13, '30583', 'Vitae sed magni sit.', '56.84', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (14, '70026', 'Aut dolorem dolorum doloribus.', '6.6', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (15, '59862', 'Nihil reprehenderit qui qui.', '8.88', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (16, '29683', 'Sit necessitatibus eum.', '3.27', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (17, '51570', 'Modi fugiat consequatur.', '83.98', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (18, '11708', 'Accusamus blanditiis ipsam laudantium.', '8.14', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (19, '07292', 'Dolorem sapiente perferendis ut.', '3.91', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (20, '45326', 'Nihil quaerat eos dolorem unde.', '6.2', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (21, '66558', 'Maiores eius ut.', '24.92', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (22, '45836', 'Ab est ratione.', '57.83', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (23, '53870', 'Eius in adipisci.', '91.4', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (24, '26597', 'Totam recusandae beatae unde.', '86.34', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (25, '57113', 'Voluptatum at impedit placeat.', '34.84', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (26, '33095', 'Laudantium sunt et.', '81.45', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (27, '02964', 'Dolores quia.', '35.82', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (28, '82308', 'Nesciunt et sapiente voluptate.', '75.8', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (29, '66006', 'Odit minus illum dolor impedit.', '30.81', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (30, '46532', 'Hic voluptatum.', '76.78', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (31, '33992', 'Qui distinctio.', '73.7', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (32, '09367', 'Perspiciatis nostrum et.', '25.4', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (33, '49240', 'Dolores enim alias voluptatem aut.', '40.49', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (34, '52753', 'Et ducimus nam.', '28.07', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (35, '22953', 'Ut nihil dolores aut.', '12.76', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (36, '49037', 'Labore ratione debitis quaerat voluptatum.', '95.27', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (37, '88561', 'Eum dolorum nesciunt magni.', '69.32', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (38, '53429', 'A ut facere.', '28.48', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (39, '47003', 'Ut dolor adipisci.', '86.37', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (40, '63321', 'Incidunt illum quos aperiam.', '6.45', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (41, '03329', 'Excepturi laboriosam provident.', '32.8', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (42, '96431', 'Exercitationem ut molestiae est.', '88.82', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (43, '67449', 'Vitae ut laudantium.', '79.88', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (44, '57566', 'Assumenda dolor quaerat qui.', '13.79', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (45, '26114', 'Est nihil illum et.', '19.77', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (46, '51232', 'Molestiae a.', '18.8', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (47, '16909', 'Voluptatem repellat.', '58.79', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (48, '52939', 'Sunt eos veniam sequi omnis.', '85.35', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (49, '54847', 'Molestiae et.', '59.38', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (50, '25516', 'Iusto voluptate ipsa.', '57.85', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (51, '85244', 'Itaque ratione velit qui.', '54.56', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (52, '12572', 'Veniam expedita alias cumque ut.', '38.02', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (53, '64487', 'Et perspiciatis deserunt.', '39.96', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (54, '41843', 'Dolores aspernatur sit.', '81.64', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (55, '23805', 'Quo qui.', '15.42', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (56, '49799', 'Aut sint.', '73.05', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (57, '05412', 'Accusantium autem libero.', '16.02', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (58, '81543', 'Et tempore eos nam.', '80.93', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (59, '80333', 'Aut velit earum soluta vero.', '67.5', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (60, '87515', 'Libero quas vitae et.', '57.9', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (61, '57574', 'Voluptatibus eius aperiam.', '14.16', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (62, '39251', 'Ex quo mollitia exercitationem.', '52.83', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (63, '45639', 'Et possimus ipsum.', '53.6', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (64, '97275', 'Veritatis veritatis dolor quis.', '44.04', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (65, '40102', 'Dolorem mollitia.', '23.85', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (66, '97729', 'Qui et maiores.', '82.98', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (67, '66969', 'Autem exercitationem vel et rerum.', '14.93', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (68, '47527', 'A molestiae esse inventore.', '58.44', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (69, '80003', 'Quibusdam molestiae.', '61.11', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (70, '12647', 'Et magnam consequatur.', '59.39', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (71, '95152', 'Deserunt beatae tempora.', '72.47', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (72, '49932', 'Nisi laborum rem non.', '65.2', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (73, '07693', 'Est et corrupti aperiam.', '63.94', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (74, '99630', 'Consequatur dolore et aliquid.', '22.03', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (75, '85965', 'Dolorem omnis repudiandae molestias aut.', '83.5', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (76, '61175', 'Eum consectetur qui.', '56.52', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (77, '83396', 'Velit voluptatem libero.', '73.82', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (78, '89319', 'Eum sint laudantium ut.', '44.67', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (79, '36146', 'Odit a quis.', '77.69', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (80, '45276', 'Necessitatibus nihil.', '13.37', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (81, '84557', 'Omnis neque.', '58.9', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (82, '34285', 'Exercitationem autem et repellendus.', '38.82', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (83, '51993', 'Nostrum aut quia veniam.', '12.92', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (84, '15744', 'Ipsa eos quia consequatur.', '19.6', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (85, '31989', 'Quis quis ullam voluptatum.', '43.12', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (86, '64201', 'Est impedit qui animi esse.', '54.87', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (87, '08960', 'Enim sit facilis aliquid.', '73.04', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (88, '84643', 'Deleniti velit sed.', '13.72', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (89, '72529', 'Temporibus voluptas corporis et.', '68.6', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (90, '84238', 'Reiciendis illo rem accusamus.', '56.03', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (91, '53721', 'Eos cum quod.', '56.64', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (92, '40725', 'Doloremque eius magni debitis non.', '75.04', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (93, '83266', 'Iste et sed consequatur.', '50.25', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (94, '56238', 'Quas exercitationem dolorem.', '90.92', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (95, '61829', 'Earum et quibusdam.', '63.42', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (96, '68794', 'Inventore repellendus blanditiis suscipit.', '54.85', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (97, '86695', 'Iure quo sint.', '24.02', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (98, '52116', 'Sunt fugit temporibus.', '89.5', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (99, '70481', 'Aliquid placeat laudantium est.', '70.12', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (100, '31788', 'Et est debitis voluptatem.', '69.62', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (101, '15025', 'Sapiente voluptas culpa dolor qui.', '72.33', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (102, '23520', 'Nihil sint velit.', '4.73', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (103, '94411', 'Nostrum sed quae.', '69.65', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (104, '08795', 'Ut illum et ut.', '55.71', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (105, '89377', 'Maiores et et ipsam.', '65.72', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (106, '27362', 'Quo in iure.', '5.39', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (107, '77172', 'Aspernatur quas amet.', '87.35', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (108, '75878', 'Soluta facere qui earum ipsam.', '83.15', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (109, '68631', 'Amet quod eaque.', '70.14', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (110, '71934', 'Sapiente atque aut.', '34.41', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (111, '77281', 'Facilis numquam quae.', '90.85', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (112, '71294', 'Eum error ipsa.', '79.74', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (113, '69696', 'Est deserunt dolores.', '86.72', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (114, '85524', 'Maiores quas atque aut.', '18.12', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (115, '78267', 'Autem molestiae illum ipsam.', '53.99', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (116, '96268', 'Quos magni unde maxime.', '77.43', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (117, '55587', 'Rerum eaque dicta recusandae.', '39.5', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (118, '49548', 'Rerum nisi ut.', '14.17', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (119, '78643', 'In maxime dolor.', '63.12', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (120, '04719', 'Molestiae libero assumenda deleniti.', '54.96', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (121, '12858', 'Tempore consequatur harum quidem.', '58.31', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (122, '82857', 'Magni magnam.', '52.05', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (123, '73032', 'Consequatur pariatur et qui.', '36.02', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (124, '01593', 'Ipsam aliquid sunt.', '68.13', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (125, '22449', 'Eveniet itaque beatae.', '27.43', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (126, '80175', 'Omnis sed quam.', '62.38', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (127, '62394', 'Eos accusamus earum.', '4.35', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (128, '29025', 'Unde atque.', '89.82', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (129, '54168', 'Aliquid sint qui eaque.', '55.37', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (130, '94825', 'Officiis nostrum.', '40.29', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (131, '56955', 'Sequi quia aut.', '89.98', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (132, '02272', 'Et et qui incidunt fugit.', '6.07', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (133, '65152', 'Tempore provident eos necessitatibus.', '34.34', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (134, '96450', 'Laudantium voluptatem iure.', '37.47', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (135, '95241', 'In dolorum dolores sunt non.', '73.49', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (136, '76304', 'Incidunt quisquam doloremque aperiam molestiae.', '53.09', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (137, '46494', 'Natus illum sunt incidunt.', '30.87', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (138, '92262', 'Eveniet ut possimus beatae vel.', '89.68', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (139, '62174', 'Et fugit blanditiis.', '22.91', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (140, '26493', 'Eos quo voluptatem.', '74.68', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (141, '94765', 'Nihil nam soluta.', '31.84', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (142, '07423', 'Officiis distinctio et.', '65.17', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (143, '28596', 'Deserunt omnis iure facere.', '94.62', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (144, '07585', 'Autem repudiandae molestias.', '90.15', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (145, '45101', 'Tempore impedit placeat.', '18.15', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (146, '21435', 'Dolores ut nisi.', '32.61', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (147, '36608', 'Eligendi enim adipisci.', '84.39', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (148, '89522', 'Deserunt consequatur mollitia optio.', '38.73', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (149, '67540', 'Ratione est et eius.', '39.02', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (150, '61295', 'Aut est voluptates.', '99.11', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (151, '53011', 'Mollitia in qui minima.', '33.72', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (152, '24570', 'Exercitationem rerum repellendus.', '46.91', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (153, '36671', 'Est ab voluptate iure.', '24.11', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (154, '39607', 'Numquam quo architecto rerum.', '81.93', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (155, '30978', 'Tempore necessitatibus saepe qui.', '98.25', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (156, '14729', 'Nostrum distinctio veniam.', '78.91', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (157, '62392', 'Et perferendis quae.', '53.66', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (158, '78692', 'Sunt optio ipsa velit qui.', '14.71', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (159, '55320', 'A omnis eum sed.', '12.45', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (160, '79047', 'Quas optio voluptatem vel.', '91.62', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (161, '09995', 'Et esse explicabo saepe.', '28.71', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (162, '54588', 'Sit qui in molestias.', '20.12', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (163, '77393', 'Ab possimus laudantium blanditiis.', '27.59', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (164, '79891', 'Vero deserunt ipsum quisquam.', '56.86', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (165, '11239', 'Dignissimos ex qui.', '58.03', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (166, '13519', 'Delectus maxime consequatur.', '59.14', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (167, '12901', 'Id necessitatibus eveniet tempora.', '12.68', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (168, '05829', 'Ut natus facere.', '48.28', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (169, '68837', 'Culpa libero magnam.', '95.85', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (170, '59835', 'Eum dolores veniam.', '16.26', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (171, '90162', 'Autem tempora voluptatum.', '88.6', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (172, '02571', 'Odit id odit officia.', '99.57', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (173, '67393', 'Et ut animi velit.', '65.6', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (174, '86944', 'Quisquam ut est.', '80.44', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (175, '37888', 'Quaerat nihil sapiente sint.', '26.03', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (176, '21021', 'Eum enim quos.', '18.58', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (177, '13849', 'Suscipit corporis.', '68.41', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (178, '74055', 'Maxime et sunt.', '89.28', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (179, '86500', 'Dolorem officiis laudantium omnis sed.', '76.94', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (180, '46284', 'Dolores voluptatem molestias.', '34.94', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (181, '93778', 'Officiis aut a.', '80.16', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (182, '47542', 'Voluptatem nihil ut.', '51.16', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (183, '26320', 'Pariatur vel autem sed.', '12.75', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (184, '06501', 'Aut a minus.', '99.66', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (185, '11286', 'Aliquam vitae id.', '69.55', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (186, '88951', 'Ut ea deleniti.', '29.85', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (187, '17213', 'Officia cum dolorem.', '35.52', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (188, '37099', 'Explicabo odit quisquam.', '32.07', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (189, '02706', 'Sapiente consectetur quis ex.', '35.44', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (190, '32786', 'Quo qui aliquam expedita.', '95.72', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (191, '10057', 'Sunt tempore facere laudantium.', '32.28', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (192, '69552', 'Aut voluptatibus doloremque.', '86.23', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (193, '73550', 'Quam molestiae consequatur aut.', '83.88', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (194, '93492', 'Illum beatae velit.', '18.49', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (195, '68551', 'Architecto corrupti et fugiat.', '88.45', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (196, '97813', 'Voluptatem perspiciatis ullam doloribus.', '26.65', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (197, '55208', 'Possimus eaque veniam.', '11.38', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (198, '24198', 'Architecto perspiciatis porro.', '79.07', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (199, '73840', 'Quisquam nihil quis non.', '74.13', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (200, '49947', 'Quidem unde qui dolore tempore.', '50.04', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (201, '35608', 'Accusamus aut aut voluptatem.', '17.04', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (202, '34596', 'Quia alias et reprehenderit.', '11.86', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (203, '03381', 'Eveniet tempora eos.', '77.51', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (204, '64149', 'Voluptatem reprehenderit et et.', '20.3', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (205, '93283', 'Sapiente quos.', '48.99', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (206, '98475', 'Qui consequuntur veritatis.', '62.75', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (207, '82518', 'Laborum minus aperiam totam.', '22.45', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (208, '81234', 'Est ex dolores.', '39.79', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (209, '36676', 'Aliquid eum iusto nostrum.', '34.9', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (210, '41693', 'Inventore eum quod.', '52.38', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (211, '35451', 'Ducimus consequuntur.', '59.44', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (212, '02538', 'Dolor quas porro voluptatibus.', '62.23', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (213, '93356', 'At necessitatibus enim deleniti.', '69.44', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (214, '51115', 'Iste laboriosam ratione.', '14.58', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (215, '52003', 'Adipisci sunt tenetur et.', '72.15', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (216, '46428', 'Architecto maxime dignissimos.', '10.5', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (217, '58462', 'Aliquam id consectetur et.', '34.23', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (218, '52392', 'Qui error consequuntur officiis.', '18.49', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (219, '33721', 'Ut vel distinctio nulla.', '72.76', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (220, '77452', 'Harum quam harum.', '10.92', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (221, '06212', 'At dolorem facilis minus sed.', '28.72', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (222, '44632', 'Similique non earum.', '52.3', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (223, '70149', 'Cumque qui fugiat maiores.', '25.87', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (224, '72605', 'Rem et quia ut.', '63.81', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (225, '27297', 'Et excepturi.', '72.45', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (226, '41830', 'Quam laborum officia consequatur.', '62.98', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (227, '35059', 'Enim labore aspernatur optio.', '31.82', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (228, '68128', 'Ad amet facere.', '86.97', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (229, '91728', 'Minima quis modi mollitia.', '37.35', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (230, '71356', 'Dolores ipsa nesciunt.', '79.59', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (231, '46067', 'Consequuntur aut similique.', '80.03', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (232, '36336', 'Dolorem aut voluptatem.', '98.99', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (233, '32787', 'Et molestiae non.', '7.98', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (234, '55623', 'Deleniti repellendus recusandae.', '57.34', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (235, '84438', 'Est quia rem ab.', '28.53', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (236, '36640', 'Est voluptatem in maxime.', '85.48', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (237, '09802', 'Dolorum deserunt alias.', '81.14', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (238, '22271', 'In et facilis nobis.', '62.13', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (239, '20829', 'Nostrum reprehenderit odit.', '96.23', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (240, '76728', 'Corporis aut eum.', '50.64', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (241, '79724', 'Sit mollitia totam.', '89.75', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (242, '41125', 'Nisi ea doloremque distinctio.', '77.97', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (243, '66427', 'Qui accusantium dolores.', '17.27', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (244, '19564', 'Quibusdam ut sint culpa.', '35.14', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (245, '46650', 'Pariatur cum accusamus.', '47.78', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (246, '73978', 'Quia sed modi molestiae inventore.', '22.08', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (247, '45702', 'Rerum dolorem eos.', '73.55', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (248, '62158', 'Ullam quae possimus eaque.', '42.94', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (249, '53166', 'Sit aliquam a.', '77.17', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (250, '63008', 'Dolorum consequuntur laudantium ut.', '78.37', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (251, '48425', 'Sequi placeat eius eos.', '64.6', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (252, '60598', 'Culpa voluptatum sed.', '12', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (253, '71606', 'Est eum qui.', '13.99', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (254, '59488', 'Omnis deserunt dicta.', '48.15', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (255, '24235', 'Ut facilis qui.', '91.57', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (256, '03595', 'Quae consequatur et ut.', '90.76', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (257, '06418', 'Sit quam.', '6.18', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (258, '94725', 'Sapiente harum tempora enim ex.', '96.46', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (259, '77185', 'Et recusandae soluta.', '55.81', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (260, '06829', 'Fuga suscipit et nemo quod.', '38.58', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (261, '61567', 'Distinctio earum ea.', '10.49', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (262, '42926', 'Et labore aut.', '37.28', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (263, '18754', 'Sit excepturi repudiandae architecto.', '93.69', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (264, '02200', 'Quae voluptatibus odio consequatur.', '55.31', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (265, '07415', 'Aut voluptate id.', '32.24', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (266, '40416', 'Possimus cum quis.', '88.44', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (267, '22300', 'Incidunt qui quas.', '36.92', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (268, '83689', 'Tempora libero inventore quisquam harum.', '84.59', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (269, '47544', 'Dolorum et repellendus labore.', '4.25', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (270, '69987', 'Autem et recusandae eius.', '39.49', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (271, '05308', 'Est perspiciatis ut.', '93.97', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (272, '41705', 'Perferendis placeat maiores.', '58.76', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (273, '50974', 'Porro nihil omnis sit.', '97.32', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (274, '61032', 'At rem.', '9.63', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (275, '50294', 'Iure nam non.', '50.47', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (276, '68246', 'Nulla sit natus cumque voluptates.', '17.75', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (277, '14914', 'Aut quo eum est.', '17.16', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (278, '70511', 'Voluptatem id quisquam minima corporis.', '62.83', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (279, '07290', 'Est tenetur praesentium in.', '76.2', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (280, '69533', 'Ab aperiam ut ut.', '80.04', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (281, '42224', 'Odit et iure enim.', '37.1', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (282, '60009', 'Hic ea porro.', '45.04', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (283, '76951', 'Iusto voluptate debitis nemo error.', '6.61', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (284, '06176', 'Quam itaque distinctio vel.', '27.09', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (285, '49752', 'Praesentium eaque id.', '37.16', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (286, '60519', 'Aut deleniti officiis asperiores.', '79.16', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (287, '30801', 'Officia sit est.', '29.93', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (288, '27218', 'Sint tempore a.', '39.63', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (289, '96352', 'Voluptate voluptas est.', '68.07', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (290, '39539', 'Odio sint provident.', '6.57', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (291, '50350', 'Nemo odit distinctio dicta.', '49.49', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (292, '67049', 'Iste dolor qui.', '87', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (293, '21157', 'Dolores in possimus consectetur sunt.', '5.03', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (294, '33330', 'Doloribus dolor eligendi.', '95.78', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (295, '57203', 'Occaecati et atque exercitationem.', '66.02', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (296, '99821', 'Sit suscipit temporibus laborum.', '8.07', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (297, '63611', 'Reiciendis itaque nesciunt.', '95.94', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (298, '87002', 'Officia labore atque.', '61.91', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (299, '24307', 'Repellat voluptatem ducimus.', '63.64', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (300, '50577', 'Qui ut sunt.', '9.77', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (301, '61232', 'Et impedit culpa ut.', '80.79', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (302, '44985', 'Quo ut cum.', '69.08', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (303, '39174', 'Velit excepturi ducimus ut.', '67.75', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (304, '96423', 'Et illum et.', '30.56', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (305, '17189', 'Recusandae tempora quam.', '6.96', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (306, '68621', 'Qui ad nihil non.', '74.95', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (307, '76160', 'Ut tempora voluptas.', '61.99', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (308, '36625', 'Rerum quis quasi.', '78', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (309, '79964', 'Commodi voluptate tenetur ea.', '60.82', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (310, '18700', 'Et necessitatibus sed.', '18.58', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (311, '11794', 'Ut explicabo labore molestiae.', '94.59', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (312, '97620', 'Officiis explicabo aliquam similique.', '77.33', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (313, '13396', 'Est qui unde.', '45.26', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (314, '98836', 'Repudiandae sit nihil officia.', '97.89', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (315, '00041', 'Accusantium ducimus porro molestias.', '12.02', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (316, '76721', 'Magni illo exercitationem ad.', '21.68', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (317, '88423', 'Ut enim omnis.', '21.19', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (318, '02256', 'Dolor dolor voluptatibus.', '15.03', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (319, '04934', 'Eos voluptas possimus.', '64.98', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (320, '42930', 'Modi omnis est sit.', '60.29', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (321, '45431', 'Omnis aliquam omnis sed.', '75.56', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (322, '34208', 'Doloremque nulla est.', '41.16', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (323, '86266', 'Illo consequatur ipsam consequatur.', '13.32', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (324, '56243', 'Fugit quisquam molestias consequuntur.', '32.91', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (325, '79098', 'Sapiente est eligendi.', '59.26', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (326, '76207', 'Autem necessitatibus dolores aliquam.', '96.5', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (327, '69699', 'Molestiae pariatur enim minus quibusdam.', '13.34', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (328, '77123', 'Ut facilis placeat dignissimos.', '36.96', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (329, '44339', 'Eum possimus.', '58.78', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (330, '10083', 'Dolorem provident voluptatem.', '51.84', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (331, '37341', 'Fugiat doloribus.', '56.27', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (332, '45661', 'Voluptate id veritatis.', '46.99', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (333, '05420', 'Quia in eius temporibus.', '93.86', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (334, '02949', 'Alias dignissimos magni odio.', '43.92', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (335, '94508', 'Perferendis dolorum qui quibusdam.', '7.96', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (336, '47110', 'Alias rerum aut.', '93.92', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (337, '11339', 'Fuga facilis corporis error.', '21.03', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (338, '40912', 'Perferendis maiores incidunt.', '66.08', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (339, '71121', 'Totam omnis qui numquam.', '45.37', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (340, '55766', 'Error totam incidunt maiores.', '86.68', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (341, '32058', 'Asperiores dolores perspiciatis distinctio.', '22.32', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (342, '16666', 'Voluptatem perspiciatis earum ipsam.', '79.15', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (343, '11246', 'Ex consequatur dolore et.', '55.61', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (344, '69114', 'Sit voluptas commodi.', '21.83', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (345, '16900', 'Consequuntur molestiae voluptas temporibus.', '4.82', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (346, '48386', 'Est est aut nostrum rerum.', '20.8', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (347, '13292', 'Odio occaecati alias voluptas voluptas.', '60.33', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (348, '51161', 'Numquam minus doloribus.', '5.69', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (349, '45215', 'Non iste omnis.', '55.48', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (350, '50773', 'Unde ducimus magnam dolor.', '66.2', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (351, '95719', 'Aut consectetur placeat officiis.', '18.38', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (352, '64573', 'Reiciendis velit quo.', '38.92', 6, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (353, '60945', 'Provident voluptatem maiores ullam.', '24.07', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (354, '25759', 'Ea quia earum ratione.', '4.8', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (355, '10487', 'Natus quibusdam aut molestiae.', '64.67', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (356, '93189', 'Minima quo nihil ut.', '44.24', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (357, '22979', 'Laudantium vel expedita.', '86.22', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (358, '02655', 'Quia repellendus quia.', '32.6', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (359, '61870', 'Consectetur est.', '48.67', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (360, '76381', 'Explicabo porro quia non.', '30.27', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (361, '01247', 'Et sunt.', '95.96', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (362, '87226', 'Adipisci vel reprehenderit id.', '3.6', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (363, '16691', 'Ab ad error harum.', '12.8', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (364, '13881', 'Sit quibusdam magnam ad.', '30.75', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (365, '53105', 'Accusantium odit sint ullam.', '91.6', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (366, '74818', 'Provident dolorem fugiat a.', '81.57', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (367, '60430', 'Consequatur aliquid sint.', '18.26', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (368, '66354', 'Quis in minima velit.', '30.13', 13, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (369, '05784', 'Quas numquam blanditiis mollitia.', '94.13', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (370, '13177', 'Aut ad recusandae alias.', '53.7', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (371, '27391', 'Velit ut amet.', '14.06', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (372, '76882', 'Aut veritatis rerum nihil.', '98.53', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (373, '94539', 'Praesentium et.', '85.85', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (374, '34588', 'Sed repellat modi.', '73.04', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (375, '82210', 'Laboriosam ratione occaecati asperiores.', '12.41', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (376, '91921', 'Vel iure aliquam.', '3.25', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (377, '65434', 'Ducimus amet.', '88.13', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (378, '47101', 'Est excepturi ut voluptates.', '90.22', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (379, '69508', 'Eius praesentium sapiente minus.', '45.36', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (380, '89967', 'Incidunt non soluta aut.', '49.64', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (381, '78958', 'Cupiditate soluta voluptatum.', '77.14', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (382, '96083', 'Aut ducimus atque autem.', '72.94', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (383, '14749', 'Ut quia voluptas.', '86.3', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (384, '44908', 'Dolores officiis possimus.', '18.74', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (385, '72715', 'Autem deleniti non consectetur repellendus.', '32.85', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (386, '78259', 'Perferendis qui.', '71.5', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (387, '88749', 'Odit voluptatibus sint.', '89.22', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (388, '72545', 'Est asperiores omnis.', '96.19', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (389, '35686', 'Aliquid ipsa.', '41.58', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (390, '50952', 'Sapiente qui in.', '32.58', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (391, '68567', 'Molestias sapiente neque.', '76.32', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (392, '61795', 'Qui iure ipsam.', '66.14', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (393, '56523', 'Facere id enim.', '55.01', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (394, '35356', 'Eum adipisci.', '30.59', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (395, '87012', 'Dolores aut sequi voluptas.', '71.1', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (396, '40677', 'In id.', '27.3', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (397, '62775', 'Totam reiciendis quia.', '30.39', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (398, '60686', 'Iusto consequatur veritatis laudantium officiis.', '77.98', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (399, '51841', 'Nemo et consectetur temporibus.', '12.57', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (400, '70772', 'Quidem facilis itaque amet.', '70.66', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (401, '97788', 'Qui culpa eum.', '10.79', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (402, '14381', 'Repellat natus facere sed.', '74.47', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (403, '77236', 'Eos odio.', '56.29', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (404, '84970', 'Qui omnis vero eaque.', '91.05', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (405, '24813', 'Suscipit autem velit quidem et.', '40.91', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (406, '29397', 'Est commodi eveniet.', '19.11', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (407, '60590', 'Quia omnis laudantium laboriosam.', '22.6', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (408, '53841', 'Cum quidem ipsam.', '9.68', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (409, '35927', 'Unde perferendis fugit quod.', '62.75', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (410, '20404', 'Inventore laboriosam.', '70.5', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (411, '78383', 'Facere quaerat.', '26.41', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (412, '71545', 'Quasi rerum et officiis.', '52.92', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (413, '32362', 'Sapiente et.', '24.78', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (414, '11323', 'Atque dolorum minima eum et.', '52.23', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (415, '80211', 'Earum dolorem ut aliquid.', '93.34', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (416, '27599', 'Iure rerum et sit.', '7.43', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (417, '12157', 'Corporis ratione saepe.', '99.81', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (418, '73376', 'Reprehenderit modi tenetur ut.', '38.13', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (419, '46070', 'Voluptatem et ipsum.', '49.78', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (420, '52173', 'Dolor accusamus nesciunt.', '28.49', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (421, '95969', 'Ducimus neque voluptatem delectus.', '55.4', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (422, '51889', 'Architecto velit quaerat voluptatibus.', '65.03', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (423, '40817', 'Omnis autem velit.', '61.34', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (424, '34237', 'Ducimus voluptatem atque minima.', '82.6', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (425, '18516', 'Quisquam veritatis aut.', '67.93', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (426, '98722', 'Sint numquam corrupti consequatur.', '67.27', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (427, '91727', 'Veniam nobis asperiores sint.', '92.76', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (428, '80257', 'Dolorem aut sed aspernatur recusandae.', '28.09', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (429, '06348', 'Est dignissimos odio fuga.', '32.78', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (430, '96591', 'Dolores expedita eum.', '72.24', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (431, '59896', 'Odio explicabo aut et.', '29.41', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (432, '33778', 'Fuga dolor est quia.', '70.7', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (433, '27398', 'Impedit itaque.', '27.37', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (434, '67837', 'Modi sit consequatur nam.', '70.14', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (435, '95644', 'Ipsam fuga est.', '58.67', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (436, '37867', 'Placeat officia provident.', '66.39', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (437, '55451', 'Et ut nostrum omnis.', '52.96', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (438, '25320', 'Soluta corporis quasi omnis.', '99.38', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (439, '84389', 'Excepturi iure delectus.', '98.18', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (440, '33449', 'Nobis et.', '62.19', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (441, '14038', 'Corrupti eaque minus.', '19.63', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (442, '40819', 'Quasi dolores impedit voluptatem.', '67.83', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (443, '76785', 'Magnam quasi eius.', '15.98', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (444, '27228', 'Error impedit accusamus reiciendis.', '78.63', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (445, '16727', 'Maiores qui quia ut temporibus.', '49.9', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (446, '88499', 'Provident consequuntur voluptatem libero.', '7.89', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (447, '57587', 'Nesciunt vel numquam.', '63.26', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (448, '12792', 'Voluptas velit qui voluptatem.', '65.07', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (449, '12079', 'Quia quia itaque.', '38.77', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (450, '38533', 'Alias in sed qui.', '57.46', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (451, '28799', 'Eum accusamus tempora.', '58.48', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (452, '49808', 'Sint cupiditate veniam.', '41.52', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (453, '01403', 'Dicta ut.', '31.51', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (454, '63774', 'Quia consequatur deserunt quibusdam.', '10.85', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (455, '24645', 'Eos eum vitae est.', '28.53', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (456, '90928', 'Quis commodi libero facere.', '97.2', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (457, '43924', 'Iusto error vel est.', '29.65', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (458, '16850', 'Cumque quia et.', '50.54', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (459, '41163', 'Voluptatem architecto veniam.', '6.7', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (460, '14710', 'Occaecati labore voluptatem.', '27.35', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (461, '16804', 'Aut ex voluptatem.', '78.84', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (462, '96913', 'Vitae excepturi ut est voluptas.', '23.57', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (463, '38062', 'Omnis et.', '69.55', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (464, '97817', 'Quia quis fugit voluptas.', '30.01', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (465, '22746', 'Iure iste maxime nihil.', '76.12', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (466, '39929', 'Non aliquid voluptatem tempora.', '70.34', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (467, '46258', 'Voluptas nihil ea.', '41.14', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (468, '83727', 'Beatae ut.', '55.64', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (469, '39371', 'Est est quo.', '96.68', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (470, '98210', 'Ea qui quae.', '27.49', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (471, '36775', 'Dolor nihil ipsa.', '12.83', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (472, '86739', 'Soluta blanditiis labore distinctio.', '12.03', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (473, '91749', 'Dolores voluptas in.', '20.12', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (474, '84705', 'Odio quia ut quia.', '84.01', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (475, '85315', 'Error aut repellat corrupti architecto.', '21.19', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (476, '45602', 'Enim veniam sit.', '92.89', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (477, '33972', 'Blanditiis ea.', '40.92', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (478, '30635', 'Provident molestias aut.', '6.86', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (479, '94584', 'Aperiam animi id eius.', '41.68', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (480, '80424', 'Iusto quibusdam ducimus tempora.', '3.09', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (481, '23279', 'Excepturi quia quas.', '35.01', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (482, '00609', 'Quis quidem corporis libero.', '99.26', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (483, '03316', 'Voluptatem iure odio recusandae.', '99.62', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (484, '54152', 'Sint beatae corrupti maiores.', '68.58', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (485, '92644', 'Maxime quisquam rem accusantium.', '79.75', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (486, '36562', 'Illum consequatur voluptatem nemo.', '88.7', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (487, '90397', 'Ut libero voluptatum animi.', '22', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (488, '21417', 'Laboriosam ut id.', '37.08', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (489, '19569', 'Et expedita aperiam cum.', '53.41', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (490, '18604', 'Sed aliquam.', '68.02', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (491, '05702', 'Impedit reiciendis et porro.', '78.38', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (492, '07588', 'Odio cum quasi quis.', '77.32', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (493, '48405', 'Libero rerum ipsa vel deleniti.', '19.38', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (494, '71781', 'Id autem labore assumenda magni.', '12.75', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (495, '16112', 'Expedita nisi assumenda.', '88.94', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (496, '82947', 'Eius quaerat aut exercitationem.', '11.4', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (497, '35311', 'Porro consectetur at aperiam.', '75.2', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (498, '42323', 'Optio aliquam.', '50.5', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (499, '23292', 'Minus alias sed.', '91.18', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (500, '76427', 'Quia est natus suscipit.', '91.67', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (501, '89697', 'Et nam magni.', '63.41', 3, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (502, '99033', 'Est eum aut.', '78.77', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (503, '74825', 'Consequuntur pariatur reiciendis.', '53.37', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (504, '69659', 'Commodi occaecati dolor.', '93.16', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (505, '78078', 'Et aspernatur quo quo.', '75.91', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (506, '67323', 'Optio repudiandae consequuntur est.', '74.92', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (507, '42955', 'Doloribus sapiente nemo.', '22.62', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (508, '40371', 'Et aut possimus maxime fugiat.', '26.99', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (509, '36606', 'Voluptatem voluptas ad.', '64.43', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (510, '96426', 'Quidem mollitia.', '12.77', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (511, '22216', 'Quas blanditiis velit.', '99.32', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (512, '39163', 'Et rerum voluptatum.', '14.07', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (513, '47661', 'Molestiae tempore nulla aut.', '73.43', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (514, '87948', 'Maiores esse voluptatem natus totam.', '19.68', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (515, '78141', 'Accusamus necessitatibus.', '26.63', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (516, '57527', 'Unde dignissimos nihil molestiae.', '51.22', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (517, '45645', 'Blanditiis sint dolorem.', '97.84', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (518, '89914', 'Necessitatibus numquam qui incidunt.', '4.95', 16, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (519, '03683', 'Dolorum voluptatem rerum.', '38.99', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (520, '34133', 'Voluptatem ex ut molestias molestiae.', '34.37', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (521, '07847', 'Rerum consequatur et ullam labore.', '65.94', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (522, '60862', 'Deserunt facere.', '66.9', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (523, '92435', 'Dolorem quia repudiandae quia minima.', '29.69', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (524, '53069', 'Natus necessitatibus atque est.', '30.88', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (525, '92704', 'Rerum temporibus et laboriosam quos.', '71.44', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (526, '76655', 'Ut iusto possimus maxime.', '59.08', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (527, '69890', 'Qui quaerat modi dicta.', '8.04', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (528, '72717', 'Quod aut atque.', '22.4', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (529, '50924', 'Aut dolores sit quibusdam.', '84.91', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (530, '56643', 'Voluptatem perspiciatis nostrum.', '64.74', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (531, '39327', 'Quia rerum qui assumenda.', '86.81', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (532, '90754', 'Sint et necessitatibus eius.', '41.39', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (533, '21386', 'Ipsa rerum modi id.', '81.82', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (534, '87959', 'Animi omnis reiciendis nemo.', '3.23', 29, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (535, '96425', 'Quis ut voluptatem iure.', '12.27', 17, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (536, '25593', 'Id sapiente aut.', '86.92', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (537, '35750', 'Illum saepe quia quidem.', '19.52', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (538, '12899', 'Modi laboriosam quos omnis.', '65.02', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (539, '11609', 'Voluptas itaque qui.', '76.85', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (540, '81137', 'Quia architecto dicta.', '29.3', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (541, '22565', 'Facilis ratione soluta libero.', '81.71', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (542, '76585', 'Explicabo corrupti exercitationem.', '16.82', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (543, '78139', 'Qui aliquam.', '56.72', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (544, '33464', 'Pariatur sint omnis.', '40.84', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (545, '07383', 'Non pariatur sed.', '21.22', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (546, '29938', 'Unde eum repellendus.', '73.3', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (547, '59479', 'Commodi placeat eum neque.', '70.05', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (548, '69616', 'Possimus debitis reiciendis.', '76.89', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (549, '33465', 'Autem eum ab.', '87.05', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (550, '87746', 'Totam odit at facere.', '62.4', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (551, '65474', 'Eum quod dignissimos.', '69.66', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (552, '98031', 'Iusto culpa ratione quas ducimus.', '46.07', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (553, '63787', 'Consequatur ipsa sunt.', '88.14', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (554, '17497', 'Accusamus in aut.', '26.34', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (555, '16394', 'Blanditiis quasi natus.', '14.85', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (556, '97645', 'Debitis dolores nulla.', '43.51', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (557, '17241', 'Quasi quia neque.', '50.49', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (558, '25567', 'Voluptatem incidunt sapiente consequatur.', '42.34', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (559, '08520', 'Id magni quia sed.', '38.93', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (560, '65190', 'Illo maxime perferendis at.', '64.83', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (561, '77782', 'Eveniet nam labore rem.', '21.97', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (562, '94769', 'Ratione fugit voluptas consequatur.', '70.03', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (563, '76840', 'Omnis nulla.', '65.4', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (564, '67562', 'Reiciendis officiis dignissimos blanditiis.', '36.12', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (565, '68682', 'Ea ut et et.', '29.05', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (566, '17945', 'Culpa sed soluta molestiae.', '53.62', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (567, '71043', 'Tempora distinctio ea et optio.', '81.08', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (568, '31174', 'Velit et rem excepturi voluptatem.', '97.73', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (569, '59965', 'Aperiam consequatur sed.', '61.69', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (570, '37609', 'Aut sed ipsam.', '46.64', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (571, '44111', 'Quis soluta et.', '10.65', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (572, '36110', 'Pariatur voluptatem voluptas.', '76.08', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (573, '05812', 'Nostrum vel velit.', '93.25', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (574, '39084', 'Sit nam quam placeat.', '23.93', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (575, '57063', 'Sit consequatur quibusdam blanditiis nihil.', '60.86', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (576, '28365', 'Voluptatibus molestiae.', '91.66', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (577, '22845', 'Animi quas iusto.', '63.4', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (578, '18869', 'Repellendus blanditiis repellendus.', '80.13', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (579, '46144', 'Dolor architecto.', '38.39', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (580, '04678', 'Et soluta nihil.', '35.06', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (581, '79831', 'A saepe repudiandae nostrum labore.', '44.86', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (582, '88154', 'Tenetur incidunt.', '96.45', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (583, '04599', 'Eveniet itaque.', '9.58', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (584, '76821', 'Et alias ex id.', '41.51', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (585, '71455', 'Sint est quos et.', '21.19', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (586, '43653', 'Et earum.', '52.27', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (587, '74311', 'Quia eius laudantium qui.', '7.08', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (588, '77014', 'Laudantium molestiae dicta.', '97.66', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (589, '70398', 'Sit ipsum nam libero numquam.', '93.71', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (590, '21866', 'Qui mollitia aliquid.', '74.61', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (591, '58841', 'Voluptatum maxime.', '22.75', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (592, '81129', 'Quasi dicta et totam.', '69.86', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (593, '98388', 'Praesentium voluptatem.', '4.25', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (594, '27250', 'Minima cum qui.', '67.98', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (595, '96409', 'Optio repudiandae et sunt.', '71.65', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (596, '09080', 'Nostrum et vitae.', '73.84', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (597, '52456', 'Ut ea nihil odio.', '22.99', 4, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (598, '26295', 'Rerum recusandae velit.', '19.65', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (599, '85562', 'Animi eos.', '27.11', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (600, '18463', 'Occaecati assumenda laborum et.', '36.16', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (601, '69952', 'Deleniti omnis et.', '75.82', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (602, '07571', 'Alias alias consequatur.', '31.66', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (603, '04260', 'Voluptatem incidunt aliquid in.', '10.93', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (604, '31115', 'Laboriosam maxime dicta nemo.', '41.51', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (605, '65863', 'Iusto necessitatibus dolorum.', '25.98', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (606, '55380', 'Molestiae eius.', '84.62', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (607, '80488', 'Et velit doloribus natus.', '66.72', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (608, '71099', 'Perferendis excepturi aspernatur.', '18.45', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (609, '71973', 'Ut repudiandae numquam.', '22.04', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (610, '93460', 'Sit unde accusamus et.', '62.25', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (611, '61785', 'Totam dolore magnam nobis.', '23.61', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (612, '31092', 'Et in quas.', '93.33', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (613, '62283', 'Cum officia neque dolor.', '98.84', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (614, '48486', 'Dolore hic ut.', '39.69', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (615, '39573', 'Et maiores corrupti quia ut.', '35.95', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (616, '38521', 'Labore corrupti voluptate.', '30.59', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (617, '11532', 'Magni repellendus est quibusdam cupiditate.', '87', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (618, '63522', 'Similique illum.', '96.48', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (619, '23227', 'Voluptas assumenda.', '74.95', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (620, '66197', 'Sint maxime.', '43.12', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (621, '37072', 'Aliquid aliquam architecto et.', '71.11', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (622, '40334', 'Porro cupiditate fugit aspernatur.', '51.7', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (623, '54189', 'Nihil sapiente enim.', '77.58', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (624, '34021', 'Exercitationem est voluptas.', '76.2', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (625, '76332', 'Vero optio vitae.', '46.66', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (626, '54228', 'Maxime maiores ut.', '66.84', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (627, '95807', 'Eius aliquam voluptatem fugiat doloribus.', '9.55', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (628, '71608', 'Tempore laborum qui rerum.', '9.68', 12, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (629, '99922', 'Aperiam soluta tempore est.', '11.21', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (630, '25711', 'Saepe nam quia eius blanditiis.', '10.46', 19, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (631, '31453', 'Maiores et porro dolor.', '25.96', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (632, '30219', 'Quo nulla est eos.', '15.62', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (633, '13641', 'Et est quibusdam asperiores.', '92.48', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (634, '86418', 'Ut magni rerum nihil.', '30.78', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (635, '83657', 'Quae omnis ex mollitia.', '71.25', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (636, '71518', 'Qui sunt quos architecto.', '79.34', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (637, '96070', 'Itaque eum aliquid deserunt.', '33.89', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (638, '02316', 'Architecto quibusdam ullam alias.', '15.59', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (639, '48864', 'Dolores dicta nihil autem.', '98.45', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (640, '19567', 'Voluptatem magni asperiores odio.', '24.33', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (641, '46547', 'Laborum molestias veritatis.', '50.96', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (642, '70754', 'Corporis occaecati ut.', '53.35', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (643, '80492', 'Consectetur aut placeat sit.', '83.43', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (644, '17939', 'Qui illum hic ipsum.', '96.27', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (645, '26602', 'Voluptatibus voluptate necessitatibus autem.', '67.18', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (646, '47570', 'Perspiciatis laudantium facere repellendus.', '11.11', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (647, '07166', 'Sint consectetur ratione cumque.', '89.22', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (648, '25179', 'Officia rerum.', '12.32', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (649, '99504', 'Natus deserunt officia.', '77.92', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (650, '37643', 'Qui et quis.', '76.22', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (651, '22033', 'Optio excepturi nihil rerum et.', '17.64', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (652, '93899', 'Sunt odit repellat fugit.', '91.23', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (653, '76408', 'Natus provident consequatur alias.', '93.74', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (654, '23072', 'Dolorem ab quibusdam laboriosam.', '43.57', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (655, '99001', 'Est debitis dolore occaecati.', '29.13', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (656, '03584', 'Iste dignissimos totam veritatis.', '63.64', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (657, '91343', 'Quis porro velit ut.', '65.51', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (658, '66914', 'Accusamus sed ut.', '29.6', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (659, '68665', 'Repudiandae quia exercitationem aut.', '76.17', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (660, '73699', 'Suscipit laudantium aliquid.', '53.96', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (661, '88190', 'Minus mollitia et.', '57.99', 14, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (662, '97311', 'Asperiores eum asperiores.', '31.79', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (663, '59561', 'Nihil ducimus debitis praesentium.', '79.38', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (664, '46094', 'Qui aut rem.', '50.74', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (665, '49930', 'Maxime dolore maiores adipisci sint.', '17.85', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (666, '66020', 'Enim fuga eligendi.', '94.31', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (667, '13065', 'Ducimus et.', '35.77', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (668, '89659', 'Sequi reiciendis rerum labore.', '10.27', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (669, '46620', 'Nesciunt nostrum voluptatem ullam.', '27.42', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (670, '96479', 'Esse ipsum non ut.', '66.03', 4, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (671, '96435', 'Cumque molestiae quidem aliquid.', '27.69', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (672, '19213', 'Eius qui fuga dicta.', '51.12', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (673, '89758', 'Et distinctio tempora vero.', '46.28', 13, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (674, '21002', 'Molestiae vel maxime.', '41.87', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (675, '93648', 'Voluptates cum facere.', '37.1', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (676, '27224', 'Modi qui sit.', '55.27', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (677, '07236', 'Aut consectetur deleniti non veniam.', '41.99', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (678, '34139', 'Ex et qui veritatis omnis.', '47.08', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (679, '80237', 'Non voluptatem eaque itaque.', '32.62', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (680, '43683', 'Libero ea ea ut harum.', '69.46', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (681, '81596', 'Deleniti omnis ab provident officiis.', '83.92', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (682, '49347', 'Facere perspiciatis voluptatem praesentium.', '76.77', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (683, '13074', 'Et et accusantium.', '22.25', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (684, '36372', 'Consequuntur est dolores dolorem.', '7.51', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (685, '27686', 'Impedit recusandae non quam quia.', '80.3', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (686, '95466', 'Qui deleniti aliquam.', '97.89', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (687, '74054', 'Qui eius omnis.', '29.52', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (688, '08711', 'Maiores officiis.', '17.48', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (689, '95511', 'Ea possimus.', '72.33', 7, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (690, '19006', 'Iure voluptatem et voluptas.', '96.19', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (691, '27059', 'Dolores quis aut minima.', '72.29', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (692, '42250', 'Dicta ipsa saepe.', '91.78', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (693, '79236', 'Fugit repudiandae voluptatum sit.', '11.94', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (694, '37944', 'Aut consequatur omnis qui.', '56.68', 26, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (695, '04747', 'Pariatur sed consectetur molestiae pariatur.', '87.9', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (696, '90442', 'Dolor vero qui reiciendis.', '83.86', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (697, '00655', 'Aliquid non aut nemo.', '60.09', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (698, '07804', 'Qui sint id.', '71.25', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (699, '29446', 'Dolores aut odit accusantium.', '58.27', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (700, '91473', 'Id ad asperiores commodi.', '93.17', 19, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (701, '36531', 'Magnam nihil iusto.', '63.67', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (702, '38322', 'Distinctio dignissimos harum.', '54.88', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (703, '91914', 'Aliquam hic praesentium.', '21.88', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (704, '39702', 'Saepe ut saepe.', '94.99', 23, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (705, '66629', 'Dolores dolor soluta dicta.', '61.22', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (706, '39999', 'Voluptates qui porro quas.', '13.49', 7, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (707, '15451', 'Odit est voluptas distinctio.', '24.23', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (708, '14901', 'Deserunt at et.', '33.73', 21, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (709, '92198', 'Dicta minus qui.', '99.35', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (710, '64738', 'Illum dolore voluptas.', '35.28', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (711, '12366', 'Illo in.', '13.63', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (712, '63198', 'Numquam non omnis esse.', '44.86', 25, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (713, '18032', 'Aspernatur sunt laboriosam ullam nihil.', '13.96', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (714, '19629', 'Quidem sapiente odit quo.', '47.41', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (715, '70975', 'Enim exercitationem.', '15.52', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (716, '48679', 'Quibusdam animi voluptas.', '90.14', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (717, '24045', 'Labore qui cupiditate nihil.', '38.7', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (718, '19787', 'Harum mollitia tenetur accusamus.', '27.05', 4, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (719, '98877', 'Possimus necessitatibus nihil.', '7.75', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (720, '01811', 'Alias odit non vel.', '81.03', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (721, '43809', 'Rem quidem incidunt beatae.', '34.88', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (722, '37818', 'Sequi ut et.', '77.44', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (723, '80069', 'Ut repudiandae aperiam.', '81.72', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (724, '96762', 'Illo voluptas recusandae id.', '97.82', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (725, '28894', 'Ipsam nostrum.', '38.62', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (726, '19775', 'Non voluptates ea voluptatem.', '57.44', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (727, '50277', 'Nemo corrupti soluta.', '63.77', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (728, '53724', 'Eos autem fuga provident.', '97.07', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (729, '27082', 'Non rem fugit voluptatem.', '52.15', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (730, '52925', 'Ut consequatur.', '49.83', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (731, '19091', 'Dolorem minus cumque possimus.', '93.8', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (732, '58517', 'Sed aut cum et.', '38.17', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (733, '27637', 'Sequi doloribus.', '13.88', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (734, '79341', 'Quia molestiae et.', '36.23', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (735, '16037', 'Dolor tempore eligendi.', '6.07', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (736, '83223', 'Et qui et ut.', '55.76', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (737, '20302', 'Reprehenderit optio qui.', '35.35', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (738, '45439', 'Nostrum id et accusamus.', '80.37', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (739, '76295', 'Dolorum vel qui.', '4.64', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (740, '93587', 'Asperiores eum vitae placeat.', '42.27', 5, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (741, '46414', 'Eius excepturi ducimus veritatis.', '58.4', 18, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (742, '13014', 'Et non pariatur.', '25.62', 4, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (743, '18436', 'Ullam quo corrupti cupiditate.', '35.32', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (744, '51805', 'Magni architecto et molestiae deleniti.', '12.89', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (745, '74745', 'Nesciunt libero.', '49.65', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (746, '88078', 'Et quisquam repellendus.', '38.79', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (747, '95544', 'Incidunt fugiat accusantium minima.', '98.7', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (748, '67178', 'Excepturi est earum molestiae.', '19.87', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (749, '63221', 'Debitis dolore eos.', '70.44', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (750, '20169', 'Voluptas ab enim voluptas.', '5.39', 15, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (751, '58364', 'Voluptatibus et harum.', '72.79', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (752, '19440', 'Animi aliquam quo atque.', '36.63', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (753, '09521', 'Harum ullam et.', '17.89', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (754, '29439', 'Esse qui voluptas.', '43.67', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (755, '28224', 'Dolores sint iste praesentium.', '14.56', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (756, '58402', 'Sed ipsum dolores voluptatem.', '67.98', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (757, '01806', 'Sed dicta quis.', '62.44', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (758, '44637', 'Molestias saepe omnis nobis.', '25.91', 0, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (759, '65103', 'Unde facilis voluptatum.', '53.24', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (760, '64207', 'Cumque tempore magnam ratione.', '46.12', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (761, '96271', 'Dignissimos et qui.', '47.39', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (762, '05357', 'Qui nihil.', '34.57', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (763, '46919', 'Consectetur aut odio nemo iusto.', '19.94', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (764, '41898', 'Officia assumenda.', '71.41', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (765, '90850', 'Quisquam consequuntur.', '86.77', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (766, '69875', 'Quidem sunt magnam.', '81', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (767, '88295', 'Ducimus et.', '72.85', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (768, '99367', 'Et temporibus quo.', '16.79', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (769, '19050', 'Voluptatem dolorum ea consequatur.', '86.12', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (770, '91929', 'Eum sit voluptates consequatur.', '4.24', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (771, '55852', 'Unde vel laudantium.', '92.78', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (772, '50343', 'Ducimus delectus harum.', '50.77', 11, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (773, '27904', 'Ut veritatis beatae.', '60.13', 1, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (774, '00076', 'Facilis ut.', '57.67', 3, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (775, '61727', 'Praesentium itaque sunt quia et.', '97.41', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (776, '58839', 'Rerum provident commodi velit.', '9.05', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (777, '62590', 'Delectus omnis quos eius.', '6.39', 14, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (778, '04148', 'Repellat et vel.', '64.89', 29, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (779, '54213', 'Eveniet aut et asperiores.', '21.25', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (780, '31454', 'Sapiente ipsum ipsum.', '29.16', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (781, '20665', 'Sed error voluptas.', '42.87', 1, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (782, '64173', 'Accusantium quod et ratione.', '97.63', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (783, '51499', 'Et cupiditate mollitia.', '28.86', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (784, '87732', 'Quas consequatur odit.', '98.99', 8, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (785, '71264', 'Repellat voluptas repudiandae.', '98.45', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (786, '62777', 'Eligendi quia iste.', '11.46', 16, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (787, '66769', 'Totam sed voluptatem pariatur.', '15.36', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (788, '60014', 'Et similique nihil ipsa repellendus.', '77.16', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (789, '99278', 'Quisquam unde sed molestias et.', '54.87', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (790, '72416', 'Omnis et ratione.', '28.63', 1, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (791, '11429', 'Quis quaerat quasi.', '83.25', 25, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (792, '05442', 'Est eaque qui.', '77.31', 25, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (793, '96065', 'Saepe temporibus eligendi facere.', '94.45', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (794, '83113', 'Soluta tempora corporis blanditiis dolorem.', '87.37', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (795, '89437', 'Expedita rerum laudantium.', '50.18', 7, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (796, '95318', 'Perferendis sed at ea.', '16.16', 23, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (797, '34715', 'Natus at laboriosam.', '66.03', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (798, '09317', 'Aut accusantium nemo quia.', '82.79', 11, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (799, '53751', 'Sed in dignissimos.', '41.33', 6, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (800, '27423', 'Tempora architecto odio.', '27.71', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (801, '18839', 'Omnis dolorum non et est.', '38.35', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (802, '14106', 'Velit maiores quibusdam aut.', '25.35', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (803, '89364', 'Consequatur maiores earum.', '59.96', 28, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (804, '22373', 'Non et occaecati.', '22.07', 8, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (805, '31646', 'Assumenda exercitationem veniam quae.', '51.92', 5, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (806, '40170', 'Quia molestiae.', '90.35', 18, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (807, '71102', 'Vel officiis quia.', '56.91', 26, 6, 36);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (808, '08991', 'Aperiam vel in.', '66.53', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (809, '60838', 'Soluta temporibus dolorem veniam excepturi.', '11.2', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (810, '26590', 'Qui eligendi atque qui.', '57.48', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (811, '26349', 'Suscipit enim optio sunt.', '23.03', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (812, '93327', 'Placeat qui qui.', '16.77', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (813, '77267', 'Dolor recusandae sequi voluptates.', '8.27', 2, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (814, '27346', 'Repellendus dolor rerum.', '30.72', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (815, '55048', 'Impedit quia soluta voluptas.', '10.83', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (816, '97512', 'Quia ut sapiente.', '59.3', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (817, '41402', 'Omnis nihil nihil.', '94.39', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (818, '60251', 'Non voluptas molestiae et.', '39.87', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (819, '78982', 'Unde laborum eum iusto.', '34.45', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (820, '31379', 'Eius expedita praesentium in.', '13.24', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (821, '16956', 'Architecto doloremque commodi eum.', '66.29', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (822, '01699', 'Est quaerat perspiciatis.', '76.33', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (823, '36189', 'Voluptate laboriosam impedit veniam.', '23.39', 0, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (824, '46451', 'Magni unde rerum.', '3.74', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (825, '86384', 'Aut aut maxime qui eaque.', '97.12', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (826, '74556', 'Dolores rerum iusto enim.', '78.5', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (827, '60954', 'Voluptate nihil ad.', '69.27', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (828, '58941', 'Aliquam itaque blanditiis magnam quis.', '4.71', 29, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (829, '41376', 'Reprehenderit cupiditate aut.', '13.83', 16, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (830, '72550', 'Quia vitae quis.', '9.06', 10, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (831, '98386', 'Officia excepturi dolores.', '5.87', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (832, '20783', 'In sit optio.', '55.35', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (833, '61422', 'Sint dolore deleniti odit.', '58.82', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (834, '89881', 'Deserunt aut.', '46.83', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (835, '40930', 'Accusamus et enim.', '28.88', 12, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (836, '42498', 'Unde doloribus magni.', '86.42', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (837, '14885', 'Ad voluptatum pariatur qui.', '88.28', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (838, '27567', 'Ex perspiciatis a vero.', '8.01', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (839, '04583', 'In recusandae est quos.', '99.08', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (840, '67672', 'Et eos sed sed perspiciatis.', '23.24', 14, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (841, '87420', 'Voluptatem optio quae.', '4.72', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (842, '22126', 'Qui quia quasi dolores deserunt.', '29.32', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (843, '25022', 'Id omnis optio.', '61.31', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (844, '09821', 'Eveniet odio ad.', '62.04', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (845, '33156', 'Similique aliquam amet.', '53.7', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (846, '27458', 'Aperiam animi numquam.', '23.6', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (847, '82514', 'Vel et voluptas totam.', '89.31', 24, 4, 44);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (848, '70752', 'Ducimus tempore.', '94.52', 11, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (849, '80052', 'Libero et et.', '81.73', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (850, '27175', 'Sit odio ut.', '10.62', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (851, '73904', 'Perferendis qui possimus facere.', '74.46', 28, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (852, '83998', 'Laudantium praesentium veritatis non.', '40.31', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (853, '75620', 'Commodi ipsam dignissimos ut.', '71.6', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (854, '44149', 'Est nisi facere nostrum.', '86.5', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (855, '49790', 'Dolor nesciunt asperiores qui.', '65.79', 6, 6, 16);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (856, '66287', 'Quis sequi illum reprehenderit.', '55.11', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (857, '38517', 'Doloribus totam sit.', '25.97', 18, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (858, '22292', 'Nulla quas qui.', '77.46', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (859, '94115', 'Dolorem at nisi.', '65.29', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (860, '05142', 'Animi sed dolores.', '68.13', 22, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (861, '85462', 'Quam non necessitatibus ea.', '55.21', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (862, '88265', 'Beatae ea autem.', '10.69', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (863, '59604', 'Qui veritatis doloremque.', '53.9', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (864, '10932', 'Animi aut.', '29.15', 23, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (865, '18066', 'Omnis officiis odio.', '35.52', 0, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (866, '43130', 'Saepe animi accusamus unde.', '31.78', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (867, '75733', 'Sunt esse pariatur nesciunt.', '72.97', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (868, '25755', 'Dolorum quam ipsa ipsam.', '75.61', 27, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (869, '03295', 'Quia in unde.', '16.39', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (870, '17338', 'Voluptas quasi facere mollitia.', '48.43', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (871, '13765', 'Voluptates quia et aut.', '74.47', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (872, '64142', 'Qui nesciunt impedit.', '48.48', 29, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (873, '03786', 'Voluptatem maxime.', '69.3', 9, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (874, '19553', 'Et molestiae.', '65.25', 24, 4, 34);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (875, '59309', 'Aut assumenda quibusdam.', '24.39', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (876, '76539', 'Perspiciatis doloremque ut nesciunt rem.', '41.88', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (877, '14482', 'Non consequatur.', '21.95', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (878, '09730', 'Nisi sapiente.', '79.2', 6, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (879, '69090', 'Consequatur animi.', '32.35', 4, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (880, '29995', 'Minus repudiandae maiores.', '32.93', 9, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (881, '38387', 'Tempore accusamus modi omnis.', '11.85', 23, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (882, '02219', 'Odio et quo.', '46.49', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (883, '79297', 'Qui ipsam et.', '70.74', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (884, '84405', 'Similique exercitationem at sunt.', '17.72', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (885, '77557', 'Et nam sapiente optio.', '20.08', 15, 5, 45);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (886, '78288', 'Accusantium in aut.', '71.67', 7, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (887, '23922', 'Maxime consequatur consequatur.', '28.17', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (888, '65493', 'Optio harum voluptas debitis.', '82.36', 8, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (889, '16349', 'Reiciendis ab aperiam beatae.', '87.62', 17, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (890, '62383', 'Labore possimus.', '45.58', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (891, '57392', 'Accusamus quos quaerat molestias.', '51.25', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (892, '68085', 'Accusamus illo et ea et.', '58.04', 21, 1, 41);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (893, '23467', 'Qui aperiam incidunt.', '40.28', 2, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (894, '48881', 'Tenetur dolor error repudiandae.', '43.61', 11, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (895, '98748', 'Eos est error.', '7.6', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (896, '08219', 'Ea provident non aliquid beatae.', '60.56', 1, 1, 21);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (897, '94810', 'Quam voluptate voluptas.', '64.66', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (898, '42675', 'Unde sit consequuntur.', '85.16', 26, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (899, '95989', 'Tempore tenetur.', '59.79', 5, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (900, '83949', 'Ut sint nesciunt qui quis.', '98.42', 16, 6, 26);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (901, '15560', 'Tenetur quaerat adipisci fuga.', '3.75', 12, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (902, '08377', 'Nam ad delectus.', '97.62', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (903, '99023', 'Molestiae quos velit harum.', '43.39', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (904, '13366', 'Suscipit voluptas natus.', '32.72', 19, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (905, '49235', 'Autem vel sed sed voluptatem.', '34', 8, 8, 18);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (906, '98869', 'Provident inventore libero.', '46.68', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (907, '87731', 'Repellendus sunt facere.', '26.95', 27, 7, 47);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (908, '06211', 'Vero autem architecto.', '51.28', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (909, '98073', 'Aut eos quaerat.', '55.64', 3, 3, 43);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (910, '32035', 'Doloribus et et consectetur.', '99.3', 6, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (911, '33091', 'Quia mollitia consequatur et.', '13.09', 2, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (912, '52526', 'Repudiandae ut qui.', '46.09', 10, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (913, '76317', 'Omnis sunt fugit quam.', '32.74', 18, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (914, '26564', 'Omnis eveniet quod impedit.', '74.06', 11, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (915, '93072', 'Qui illo eveniet molestiae.', '92.13', 26, 6, 46);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (916, '55061', 'Sapiente deserunt labore est.', '85.1', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (917, '70676', 'Est atque sunt.', '43.74', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (918, '47566', 'Harum provident velit.', '15.1', 20, 0, 40);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (919, '94385', 'Aut necessitatibus.', '52.89', 15, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (920, '27763', 'Officia odit voluptates at.', '76.98', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (921, '72495', 'Quo rem autem.', '24.99', 5, 5, 15);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (922, '33702', 'Commodi et laudantium.', '98.29', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (923, '72863', 'Officia nesciunt porro.', '73.85', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (924, '89599', 'Ea at numquam ratione.', '22.02', 21, 1, 1);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (925, '41950', 'Vel rerum quaerat enim recusandae.', '43.16', 14, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (926, '09114', 'Culpa occaecati voluptate.', '44.96', 5, 5, 25);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (927, '61599', 'Enim ratione architecto aut.', '65.29', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (928, '65431', 'Occaecati saepe ut et.', '6.96', 15, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (929, '28710', 'Perspiciatis eos voluptatem id.', '49.58', 22, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (930, '19184', 'Itaque quia facilis.', '25.82', 2, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (931, '46180', 'Perspiciatis ducimus sit cumque.', '19.83', 20, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (932, '32700', 'Distinctio qui repellat sunt.', '67.79', 20, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (933, '28157', 'Nulla eos expedita.', '16.48', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (934, '86640', 'Tempora maiores voluptates incidunt laboriosam.', '74.2', 21, 1, 31);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (935, '69544', 'Similique numquam iure.', '84.19', 25, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (936, '60673', 'Quis id repellat quo.', '37.91', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (937, '58927', 'Veniam ut quam quidem.', '93.59', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (938, '11433', 'Sit animi qui.', '35.47', 27, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (939, '95728', 'Distinctio sapiente minus.', '25.37', 12, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (940, '16281', 'A sit facilis.', '11.62', 12, 2, 2);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (941, '87083', 'Sint soluta eum.', '60.75', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (942, '88244', 'Quia illum praesentium vel.', '18.04', 17, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (943, '15121', 'Ex explicabo nobis adipisci et.', '33.42', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (944, '38444', 'Eligendi neque voluptas sit.', '58.69', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (945, '31031', 'Et voluptas sed voluptatibus.', '17.37', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (946, '10462', 'Voluptatem voluptatum voluptatum soluta.', '68.42', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (947, '20620', 'Tempore blanditiis tempore.', '36.5', 28, 8, 38);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (948, '89526', 'Qui ut facere.', '86.83', 17, 7, 37);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (949, '16805', 'Ut dolores.', '68.13', 23, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (950, '65743', 'Autem laborum.', '16.63', 10, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (951, '55382', 'Ea quis minus et.', '91.09', 9, 9, 19);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (952, '68356', 'Non dignissimos praesentium quibusdam.', '31.92', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (953, '33463', 'Atque vel autem.', '26.27', 27, 7, 17);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (954, '34097', 'Magnam quod a nihil.', '98.56', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (955, '72445', 'Voluptas adipisci animi sunt.', '18.72', 28, 8, 28);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (956, '44244', 'Assumenda enim quidem et.', '69.25', 13, 3, 13);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (957, '86608', 'Aliquam sint amet.', '19.39', 22, 2, 12);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (958, '73240', 'Sit dolores esse.', '81.54', 24, 4, 14);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (959, '73934', 'Esse voluptatum veritatis.', '65.23', 9, 9, 39);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (960, '85487', 'Voluptate est et.', '14.29', 17, 7, 7);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (961, '03769', 'Neque provident quos.', '46.25', 9, 9, 29);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (962, '76779', 'Magnam sed.', '76.76', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (963, '30216', 'Laborum qui rerum.', '26.31', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (964, '58475', 'Soluta sit deserunt perferendis.', '46.81', 29, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (965, '64670', 'Maxime odit.', '26.86', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (966, '15915', 'Quos nemo.', '55.1', 3, 3, 23);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (967, '19360', 'Molestiae voluptatem ad.', '58.47', 10, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (968, '00387', 'At iusto id.', '55.92', 0, 0, 30);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (969, '92455', 'Consequuntur dolor dignissimos doloribus.', '42.72', 24, 4, 4);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (970, '48271', 'Amet soluta esse enim.', '35.14', 21, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (971, '63592', 'Eos porro voluptatem.', '29.26', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (972, '38915', 'Fuga necessitatibus quisquam corporis.', '32.11', 0, 0, 10);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (973, '27105', 'Incidunt temporibus blanditiis velit distinctio.', '40.27', 18, 8, 8);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (974, '71865', 'Excepturi aut.', '13.3', 25, 5, 5);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (975, '85444', 'Facere sed et.', '49.79', 19, 9, 49);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (976, '61626', 'Velit aut qui non.', '53.2', 22, 2, 42);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (977, '23965', 'Eum sint sunt.', '22.2', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (978, '25071', 'Iusto eos sint.', '65', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (979, '96906', 'Nihil labore minus modi.', '36.66', 20, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (980, '49385', 'Doloribus minima perspiciatis.', '87.7', 1, 1, 11);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (981, '51531', 'Itaque perspiciatis blanditiis consequatur.', '29.81', 27, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (982, '35984', 'Deleniti harum corporis.', '12.77', 22, 2, 22);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (983, '93953', 'Debitis neque ullam.', '15.49', 14, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (984, '55180', 'Nihil debitis dolores.', '70.79', 2, 2, 32);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (985, '53208', 'Quaerat sint dolores.', '84.43', 28, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (986, '29787', 'Architecto dolor aut.', '50.86', 20, 0, 0);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (987, '87926', 'Fugiat eaque cumque.', '52.31', 16, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (988, '22002', 'Cumque optio nam sed.', '25.27', 10, 0, 20);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (989, '31325', 'Eum sint aut.', '20.89', 15, 5, 35);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (990, '75389', 'Facilis consectetur.', '92.76', 26, 6, 6);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (991, '73192', 'Et cupiditate qui voluptas.', '46.45', 3, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (992, '61217', 'Occaecati ea voluptas libero.', '31.23', 24, 4, 24);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (993, '50745', 'Distinctio culpa asperiores.', '14.96', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (994, '61867', 'Animi asperiores quia.', '64.62', 19, 9, 9);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (995, '99762', 'Officia aliquam velit aut.', '79.82', 13, 3, 3);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (996, '93737', 'Ad sit error.', '89.42', 13, 3, 33);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (997, '80602', 'Eum at molestiae.', '94.95', 8, 8, 48);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (998, '81168', 'Aut pariatur facere.', '6.24', 7, 7, 27);
INSERT INTO `artikel` (`art_id`, `art_nr`, `art_bezeichnung`, `art_preis`, `art_arttypid`, `art_weintypid`, `art_geschmacktypid`) VALUES (999, '38253', 'Cum ex enim aut.', '32.7', 29, 9, 29);

#
# TABLE STRUCTURE FOR: rechnung_position
#

DROP TABLE IF EXISTS `rechnung_position`;

CREATE TABLE `rechnung_position` (
  `rgpos_id` int(11) NOT NULL,
  `rgpos_rgid` int(11) DEFAULT NULL,
  `rgpos_posnr` int(11) DEFAULT NULL,
  `rgpos_artid` int(11) DEFAULT NULL,
  `rgpos_menge` int(11) DEFAULT NULL,
  `rgpos_preis` float DEFAULT NULL,
  PRIMARY KEY (`rgpos_id`),
  FOREIGN KEY (`rgpos_artid`) REFERENCES `artikel` (`art_id`),
  FOREIGN KEY (`rgpos_rgid`) REFERENCES `rechnung` (`rg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (0, 4, 4, 4, 29, '35.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1, 2, 8, 2, 23, '247.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2, 83, 8, 83, 38, '285.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3, 134, 3, 134, 20, '64.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4, 249, 8, 249, 13, '244.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5, 147, 10, 147, 6, '176.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6, 25, 9, 25, 31, '246.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7, 59, 6, 59, 35, '128.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8, 75, 1, 75, 24, '77.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9, 70, 2, 70, 57, '177.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10, 397, 3, 397, 62, '141.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11, 19, 9, 19, 37, '299.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12, 495, 1, 495, 49, '293.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13, 119, 7, 119, 54, '179.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14, 109, 7, 109, 27, '203.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15, 9, 4, 9, 55, '167.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16, 656, 4, 656, 68, '245.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17, 702, 8, 702, 47, '71.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18, 118, 1, 118, 3, '49.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19, 209, 1, 209, 43, '295.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20, 85, 4, 85, 3, '77.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (21, 10, 7, 10, 60, '129.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22, 841, 9, 841, 36, '204.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23, 961, 9, 961, 54, '251.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24, 27, 9, 27, 17, '237.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25, 417, 10, 417, 3, '256.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26, 486, 3, 486, 11, '134.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (27, 948, 2, 948, 32, '53.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28, 105, 3, 105, 44, '105.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29, 531, 5, 531, 24, '270.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30, 116, 4, 116, 55, '294.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31, 398, 7, 398, 33, '216.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (32, 615, 9, 615, 61, '127.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33, 17, 9, 17, 43, '113.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35, 72, 10, 72, 43, '110.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36, 27, 10, 27, 15, '204.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37, 366, 4, 366, 19, '273.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38, 989, 2, 989, 8, '264.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39, 178, 1, 178, 21, '45.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40, 375, 3, 375, 68, '28.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41, 51, 6, 51, 8, '257.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (42, 537, 10, 537, 60, '272.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43, 538, 7, 538, 52, '283.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (44, 373, 9, 373, 30, '47.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45, 107, 2, 107, 1, '206.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46, 610, 4, 610, 13, '250.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (47, 947, 1, 947, 48, '137.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48, 64, 9, 64, 52, '175.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (49, 92, 10, 92, 3, '75.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50, 81, 8, 81, 59, '136.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (51, 185, 2, 185, 68, '235.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52, 331, 8, 331, 14, '168.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53, 259, 8, 259, 12, '281.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54, 257, 4, 257, 23, '195.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (55, 358, 1, 358, 53, '276.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56, 563, 1, 563, 21, '132.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (57, 57, 6, 57, 14, '168.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58, 147, 6, 147, 6, '139.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59, 222, 8, 222, 48, '117.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60, 5, 10, 5, 57, '267.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (61, 455, 4, 455, 17, '263.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62, 315, 8, 315, 49, '244.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63, 627, 3, 627, 59, '23.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64, 791, 1, 791, 55, '236.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65, 975, 3, 975, 5, '117.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66, 774, 10, 774, 61, '268.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (67, 407, 3, 407, 49, '274.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68, 733, 1, 733, 15, '128.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69, 67, 8, 67, 22, '37.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (71, 309, 7, 309, 37, '183.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72, 470, 10, 470, 6, '219.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73, 173, 2, 173, 4, '53.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74, 924, 5, 924, 56, '215.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75, 34, 8, 34, 45, '97.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (76, 589, 8, 589, 13, '225.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77, 762, 7, 762, 64, '294.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78, 706, 8, 706, 50, '293.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79, 264, 7, 264, 50, '226.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (80, 65, 2, 65, 50, '26.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (81, 328, 5, 328, 57, '120.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (83, 88, 5, 88, 11, '52.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (84, 723, 10, 723, 28, '197.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85, 20, 8, 20, 39, '38.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86, 597, 6, 597, 57, '229.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87, 460, 5, 460, 16, '175.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88, 201, 10, 201, 40, '198.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (89, 246, 8, 246, 24, '67.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90, 467, 8, 467, 59, '226.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91, 140, 9, 140, 5, '142.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (92, 424, 2, 424, 68, '190.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93, 421, 6, 421, 50, '70.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (94, 212, 9, 212, 49, '140.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95, 419, 4, 419, 46, '156.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96, 672, 1, 672, 29, '194.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (97, 505, 1, 505, 14, '211.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (98, 36, 10, 36, 45, '96.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99, 104, 1, 104, 45, '269.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (100, 994, 10, 994, 56, '98.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (103, 539, 4, 539, 41, '181.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (105, 479, 10, 479, 54, '121.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (106, 533, 5, 533, 3, '97.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (108, 541, 6, 541, 24, '264.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (109, 120, 8, 120, 62, '211.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (110, 853, 5, 853, 53, '45.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (113, 509, 10, 509, 5, '284.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (115, 200, 1, 200, 5, '146.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (118, 465, 7, 465, 68, '259.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (120, 844, 1, 844, 31, '102.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (122, 840, 7, 840, 31, '220.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (127, 629, 8, 629, 5, '227.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (128, 719, 4, 719, 4, '211.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (130, 316, 6, 316, 37, '227.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (136, 678, 7, 678, 6, '44.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (141, 782, 3, 782, 53, '18.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (147, 677, 8, 677, 47, '69.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (152, 168, 4, 168, 2, '243.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (155, 486, 7, 486, 37, '85.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (158, 335, 9, 335, 51, '286.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (163, 499, 7, 499, 15, '25.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (166, 173, 8, 173, 25, '164.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (167, 306, 9, 306, 19, '217.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (178, 598, 3, 598, 29, '188.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (180, 8, 4, 8, 12, '168.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (187, 829, 1, 829, 54, '125.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (190, 726, 5, 726, 58, '287.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (191, 431, 3, 431, 22, '186.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (199, 170, 2, 170, 62, '249.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (204, 319, 6, 319, 21, '189.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (206, 369, 8, 369, 14, '173.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (209, 0, 3, 0, 59, '170.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (212, 137, 10, 137, 26, '67.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (214, 873, 2, 873, 33, '49.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (219, 53, 1, 53, 68, '84.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (221, 764, 9, 764, 3, '177.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (222, 603, 9, 603, 59, '115.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (228, 42, 6, 42, 19, '273.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (229, 674, 7, 674, 51, '252.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (244, 786, 10, 786, 9, '93.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (245, 298, 1, 298, 23, '96.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (249, 570, 5, 570, 49, '163.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (250, 892, 1, 892, 60, '286.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (257, 6, 3, 6, 60, '195.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (262, 313, 5, 313, 44, '222.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (263, 657, 10, 657, 25, '169.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (266, 929, 8, 929, 23, '262.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (268, 390, 8, 390, 46, '277.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (269, 894, 9, 894, 7, '259.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (270, 754, 2, 754, 68, '223.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (281, 52, 6, 52, 50, '118.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (283, 689, 4, 689, 12, '96.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (284, 302, 2, 302, 34, '18.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (286, 956, 10, 956, 60, '224.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (287, 511, 10, 511, 60, '298.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (289, 187, 8, 187, 55, '288.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (290, 663, 5, 663, 1, '256.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (291, 268, 5, 268, 43, '248.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (295, 475, 9, 475, 8, '40.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (302, 58, 1, 58, 16, '194.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (306, 82, 7, 82, 53, '206.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (314, 391, 4, 391, 3, '83.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (317, 439, 7, 439, 41, '70.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (319, 250, 5, 250, 13, '234.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (321, 520, 9, 520, 25, '178.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (330, 478, 7, 478, 29, '26.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (332, 775, 2, 775, 65, '116.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (340, 91, 2, 91, 16, '102.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (346, 573, 7, 573, 20, '174.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (350, 735, 3, 735, 68, '139.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (351, 509, 10, 509, 66, '161.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (352, 851, 2, 851, 52, '140.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (354, 649, 9, 649, 38, '200.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (357, 326, 1, 326, 51, '181.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (358, 989, 6, 989, 57, '25.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (359, 355, 5, 355, 20, '256.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (361, 922, 8, 922, 49, '66.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (362, 750, 7, 750, 6, '269.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (366, 495, 1, 495, 46, '107.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (367, 399, 9, 399, 55, '156.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (368, 760, 5, 760, 54, '151.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (369, 998, 7, 998, 13, '80.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (372, 848, 5, 848, 65, '193.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (378, 534, 8, 534, 68, '31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (382, 274, 10, 274, 7, '166.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (390, 432, 1, 432, 54, '179.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (397, 458, 8, 458, 59, '18.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (406, 267, 2, 267, 41, '66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (410, 933, 6, 933, 34, '189.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (412, 242, 4, 242, 5, '259.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (415, 974, 10, 974, 3, '40.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (416, 799, 8, 799, 17, '120.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (419, 171, 10, 171, 60, '109.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (420, 540, 5, 540, 3, '245');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (424, 248, 10, 248, 18, '120.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (427, 580, 4, 580, 38, '104.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (428, 280, 7, 280, 57, '237.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (430, 488, 2, 488, 69, '114.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (432, 462, 5, 462, 62, '214.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (434, 995, 10, 995, 51, '144.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (435, 697, 7, 697, 19, '112.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (439, 457, 6, 457, 30, '110.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (440, 299, 3, 299, 34, '145.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (445, 396, 10, 396, 10, '123.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (446, 934, 10, 934, 11, '149.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (451, 891, 4, 891, 50, '37.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (461, 138, 2, 138, 65, '255.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (465, 569, 7, 569, 36, '123.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (466, 902, 2, 902, 64, '54.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (467, 220, 2, 220, 19, '207.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (468, 244, 2, 244, 24, '290.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (470, 582, 9, 582, 56, '114.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (473, 523, 10, 523, 35, '276.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (474, 339, 1, 339, 33, '27.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (475, 269, 8, 269, 23, '98.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (477, 214, 6, 214, 67, '293.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (480, 950, 9, 950, 56, '250.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (484, 620, 9, 620, 63, '62.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (487, 127, 4, 127, 42, '97.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (489, 778, 10, 778, 7, '61.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (491, 871, 2, 871, 69, '254.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (492, 931, 2, 931, 33, '114.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (495, 233, 3, 233, 21, '122.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (501, 112, 6, 112, 8, '239.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (504, 874, 2, 874, 52, '288.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (506, 915, 7, 915, 58, '86.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (513, 884, 1, 884, 49, '252.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (521, 95, 5, 95, 41, '205.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (527, 980, 5, 980, 58, '193.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (529, 246, 4, 246, 35, '218.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (532, 501, 5, 501, 24, '94.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (533, 839, 7, 839, 50, '178.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (539, 405, 6, 405, 24, '35.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (543, 884, 4, 884, 48, '165.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (544, 186, 2, 186, 34, '227.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (549, 299, 6, 299, 14, '44.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (555, 216, 7, 216, 18, '44.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (562, 606, 8, 606, 35, '122.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (564, 503, 5, 503, 49, '120.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (565, 593, 9, 593, 69, '295.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (567, 784, 3, 784, 53, '206.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (571, 209, 6, 209, 3, '104.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (572, 205, 5, 205, 14, '212.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (577, 239, 3, 239, 37, '51.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (578, 783, 6, 783, 7, '136.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (581, 93, 7, 93, 33, '296.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (583, 111, 2, 111, 68, '50.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (585, 694, 2, 694, 19, '119.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (589, 726, 8, 726, 49, '141.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (592, 259, 2, 259, 4, '231.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (598, 779, 10, 779, 28, '103.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (602, 963, 2, 963, 33, '20.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (603, 14, 4, 14, 69, '259.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (606, 645, 1, 645, 24, '203.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (607, 886, 10, 886, 60, '42.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (608, 849, 5, 849, 44, '193.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (610, 16, 7, 16, 37, '158.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (612, 392, 9, 392, 51, '122.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (614, 485, 7, 485, 17, '291.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (622, 715, 10, 715, 47, '58.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (623, 323, 3, 323, 68, '175.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (624, 899, 7, 899, 33, '288.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (626, 404, 10, 404, 7, '269.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (632, 550, 2, 550, 22, '244.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (633, 145, 7, 145, 24, '42.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (636, 411, 5, 411, 61, '96.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (638, 99, 7, 99, 11, '184.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (640, 906, 10, 906, 26, '151.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (641, 893, 10, 893, 56, '264.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (651, 562, 2, 562, 6, '275.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (655, 90, 3, 90, 14, '164.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (659, 42, 1, 42, 48, '86.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (666, 119, 6, 119, 43, '53.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (667, 863, 10, 863, 21, '292.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (673, 714, 3, 714, 63, '183.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (677, 645, 5, 645, 4, '22.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (681, 193, 10, 193, 52, '204.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (685, 669, 8, 669, 1, '232.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (688, 706, 6, 706, 37, '138.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (697, 738, 8, 738, 52, '296.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (698, 668, 9, 668, 67, '131.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (705, 33, 4, 33, 28, '43.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (707, 204, 7, 204, 57, '68.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (709, 176, 7, 176, 33, '217.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (713, 932, 1, 932, 12, '155.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (714, 822, 8, 822, 45, '31.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (715, 647, 9, 647, 31, '237.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (721, 767, 4, 767, 13, '275.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (725, 880, 6, 880, 19, '85.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (729, 559, 4, 559, 30, '178.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (730, 802, 7, 802, 51, '29.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (734, 40, 6, 40, 19, '112.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (735, 872, 6, 872, 15, '283.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (741, 482, 5, 482, 19, '161.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (743, 761, 7, 761, 20, '118.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (751, 355, 6, 355, 31, '118.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (755, 858, 2, 858, 46, '58.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (756, 200, 2, 200, 13, '56.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (758, 704, 3, 704, 30, '235.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (759, 143, 10, 143, 5, '258.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (761, 94, 3, 94, 23, '82.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (763, 58, 2, 58, 28, '140.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (764, 789, 8, 789, 2, '131.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (767, 322, 7, 322, 18, '212.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (769, 165, 8, 165, 17, '151.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (771, 865, 7, 865, 61, '174.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (772, 837, 3, 837, 49, '88.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (774, 836, 2, 836, 53, '22.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (778, 489, 10, 489, 40, '193.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (780, 406, 1, 406, 13, '213.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (784, 481, 8, 481, 8, '67.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (786, 846, 7, 846, 47, '29.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (789, 507, 5, 507, 16, '287.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (794, 29, 1, 29, 65, '289.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (805, 930, 3, 930, 14, '142.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (823, 628, 5, 628, 45, '184.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (828, 456, 10, 456, 69, '149.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (830, 528, 4, 528, 62, '184.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (835, 859, 5, 859, 2, '276.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (838, 140, 9, 140, 68, '45.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (839, 834, 2, 834, 63, '82.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (840, 732, 8, 732, 63, '101.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (854, 924, 4, 924, 64, '197.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (855, 477, 10, 477, 27, '239.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (856, 540, 6, 540, 58, '115.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (859, 139, 8, 139, 36, '37.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (862, 767, 2, 767, 29, '132.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (865, 552, 10, 552, 55, '63.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (873, 340, 6, 340, 57, '276.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (880, 110, 1, 110, 31, '195.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (881, 241, 3, 241, 31, '91.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (888, 653, 7, 653, 3, '62.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (901, 32, 9, 32, 11, '210.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (904, 711, 3, 711, 46, '218.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (905, 920, 5, 920, 48, '246.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (913, 498, 3, 498, 23, '141.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (920, 252, 3, 252, 17, '238.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (924, 343, 10, 343, 1, '33.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (925, 919, 9, 919, 51, '294.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (932, 705, 6, 705, 38, '281.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (933, 429, 7, 429, 63, '39.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (936, 835, 7, 835, 20, '23.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (937, 395, 6, 395, 61, '48.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (939, 427, 4, 427, 63, '26.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (943, 511, 4, 511, 38, '110.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (947, 62, 1, 62, 68, '244.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (950, 516, 7, 516, 9, '80.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (956, 764, 1, 764, 19, '197.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (958, 231, 9, 231, 25, '45.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (960, 430, 4, 430, 8, '74.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (963, 971, 3, 971, 69, '91.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (966, 626, 10, 626, 5, '86.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (967, 624, 2, 624, 59, '283.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (981, 97, 8, 97, 30, '65.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (984, 320, 2, 320, 15, '219.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (990, 335, 5, 335, 7, '30.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (993, 466, 1, 466, 62, '36.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (995, 875, 1, 875, 22, '191.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (997, 78, 7, 78, 37, '133.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (999, 664, 1, 664, 68, '164.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1014, 303, 7, 303, 42, '82.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1019, 571, 6, 571, 14, '160.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1026, 443, 3, 443, 52, '199.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1176, 979, 9, 979, 56, '191.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1216, 932, 4, 932, 22, '270.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1245, 757, 2, 757, 54, '155.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1256, 897, 8, 897, 25, '36.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1272, 634, 2, 634, 27, '254.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1296, 720, 8, 720, 68, '287.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1393, 329, 1, 329, 51, '163.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1432, 162, 4, 162, 53, '160.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1524, 144, 6, 144, 66, '110.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1636, 759, 6, 759, 62, '60.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1707, 512, 2, 512, 15, '69.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1730, 874, 1, 874, 60, '109.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1747, 72, 3, 72, 28, '263.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1784, 238, 8, 238, 60, '49.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1819, 971, 8, 971, 13, '192.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1875, 112, 8, 112, 69, '265.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1964, 957, 1, 957, 49, '134.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1978, 981, 8, 981, 68, '65.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2008, 210, 1, 210, 21, '91.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2065, 806, 2, 806, 52, '218.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2157, 158, 5, 158, 47, '194.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2173, 641, 6, 641, 16, '293.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2180, 641, 9, 641, 43, '192.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2208, 333, 3, 333, 54, '41.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2214, 476, 4, 476, 46, '245.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2235, 590, 2, 590, 19, '131.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2263, 951, 7, 951, 38, '101.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2282, 997, 7, 997, 2, '149.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2295, 683, 3, 683, 13, '145.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2334, 55, 1, 55, 38, '177.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2369, 235, 2, 235, 25, '220.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2378, 199, 4, 199, 4, '75.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2390, 851, 1, 851, 16, '251.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2417, 896, 2, 896, 28, '215.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2423, 34, 10, 34, 56, '76.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2425, 253, 10, 253, 69, '212.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2443, 294, 8, 294, 4, '69.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2448, 745, 9, 745, 41, '135.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2495, 612, 7, 612, 64, '275.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2520, 580, 8, 580, 34, '288.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2534, 701, 1, 701, 67, '252.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2544, 167, 1, 167, 69, '56.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2622, 473, 9, 473, 28, '243.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2629, 8, 4, 8, 7, '191.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2739, 196, 5, 196, 32, '95.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2742, 453, 6, 453, 29, '197.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2780, 22, 4, 22, 9, '254.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2863, 836, 5, 836, 24, '67.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2869, 418, 8, 418, 23, '51.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2874, 746, 7, 746, 27, '99.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2888, 460, 1, 460, 14, '181.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2925, 51, 2, 51, 4, '145.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2982, 132, 6, 132, 28, '282.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3065, 838, 6, 838, 42, '285.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3092, 121, 1, 121, 12, '135.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3097, 604, 9, 604, 38, '55.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3131, 595, 4, 595, 42, '178.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3179, 300, 4, 300, 65, '25.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3233, 28, 10, 28, 52, '93.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3235, 234, 2, 234, 56, '221.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3250, 742, 8, 742, 42, '222.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3272, 686, 8, 686, 59, '221.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3273, 541, 9, 541, 14, '226.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3306, 621, 4, 621, 1, '65.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3330, 998, 3, 998, 60, '272.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3368, 474, 9, 474, 18, '172.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3391, 267, 1, 267, 36, '165.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3403, 691, 2, 691, 62, '149.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3406, 425, 5, 425, 67, '171.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3408, 93, 3, 93, 40, '238.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3423, 923, 2, 923, 24, '266.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3426, 118, 6, 118, 18, '168.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3427, 999, 1, 999, 20, '237.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3487, 106, 2, 106, 45, '83.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3524, 727, 7, 727, 46, '155.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3526, 735, 5, 735, 8, '215.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3561, 926, 6, 926, 58, '211.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3634, 482, 10, 482, 67, '248.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3645, 912, 8, 912, 49, '158.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3682, 847, 1, 847, 37, '282.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3723, 904, 9, 904, 49, '114.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3732, 662, 1, 662, 42, '226.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3765, 804, 9, 804, 29, '266.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3769, 387, 1, 387, 18, '258.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3805, 286, 10, 286, 9, '289.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3818, 494, 9, 494, 51, '279.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3825, 793, 10, 793, 48, '105.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3836, 655, 9, 655, 29, '56.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3844, 545, 1, 545, 20, '31.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3875, 277, 9, 277, 14, '51.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3895, 941, 1, 941, 56, '180.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3929, 718, 6, 718, 34, '263.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3952, 88, 6, 88, 2, '159.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4080, 792, 2, 792, 25, '235.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4083, 570, 5, 570, 66, '178.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4133, 101, 3, 101, 29, '213.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4243, 137, 8, 137, 39, '197.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4286, 828, 8, 828, 50, '113.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4296, 680, 9, 680, 6, '54.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4297, 115, 2, 115, 42, '267.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4308, 296, 10, 296, 35, '138.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4365, 507, 3, 507, 32, '91.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4481, 821, 4, 821, 56, '48.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4490, 794, 7, 794, 3, '266.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4520, 630, 1, 630, 53, '102.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4535, 776, 9, 776, 18, '91.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4557, 338, 2, 338, 29, '261.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4597, 160, 7, 160, 45, '157.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4603, 356, 10, 356, 61, '42.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4620, 370, 7, 370, 66, '166.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4655, 888, 1, 888, 37, '189.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4664, 652, 3, 652, 69, '89.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4720, 813, 4, 813, 16, '129.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4769, 708, 7, 708, 24, '107.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4797, 98, 1, 98, 31, '37.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4858, 159, 3, 159, 38, '170.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4860, 860, 10, 860, 15, '275.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4875, 618, 1, 618, 33, '155.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4905, 409, 3, 409, 23, '203.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4921, 681, 6, 681, 51, '108.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4960, 102, 5, 102, 26, '170.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5087, 502, 5, 502, 42, '224.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5109, 206, 2, 206, 69, '276.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5116, 909, 6, 909, 55, '191.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5146, 914, 5, 914, 8, '210.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5205, 161, 8, 161, 26, '195.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5230, 991, 2, 991, 6, '81.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5261, 284, 1, 284, 47, '77.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5296, 324, 5, 324, 41, '173.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5302, 661, 1, 661, 63, '93.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5376, 972, 5, 972, 36, '177.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5410, 372, 5, 372, 33, '92.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5412, 788, 5, 788, 28, '130.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5446, 594, 8, 594, 61, '59.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5469, 787, 4, 787, 31, '278.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5503, 609, 4, 609, 7, '77.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5517, 172, 8, 172, 20, '171.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5563, 730, 8, 730, 7, '172.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5597, 556, 1, 556, 13, '101.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5628, 360, 7, 360, 8, '151.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5631, 230, 3, 230, 14, '115.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5662, 637, 9, 637, 9, '128.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5665, 817, 9, 817, 39, '105.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5681, 468, 3, 468, 8, '254.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5727, 0, 10, 0, 48, '260.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5781, 293, 6, 293, 4, '253.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5809, 191, 8, 191, 51, '274.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5810, 24, 4, 24, 64, '228.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5821, 532, 7, 532, 33, '54.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5843, 87, 9, 87, 34, '47.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5859, 274, 5, 274, 35, '183.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6016, 451, 2, 451, 64, '265.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6058, 515, 10, 515, 42, '119.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6079, 617, 1, 617, 50, '88.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6155, 973, 10, 973, 33, '241.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6215, 546, 4, 546, 8, '234.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6249, 381, 1, 381, 69, '68.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6251, 205, 1, 205, 35, '66.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6253, 536, 7, 536, 68, '56.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6266, 427, 6, 427, 52, '150.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6297, 143, 1, 143, 46, '131.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6316, 78, 1, 78, 26, '228.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6333, 643, 6, 643, 12, '142.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6387, 376, 10, 376, 54, '265.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6465, 469, 5, 469, 17, '195.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6474, 403, 3, 403, 33, '159.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6478, 929, 6, 929, 69, '89.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6527, 156, 10, 156, 1, '119.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6543, 38, 7, 38, 30, '189.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6575, 57, 9, 57, 1, '44.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6578, 99, 2, 99, 27, '117.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6593, 131, 6, 131, 24, '100.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6604, 992, 6, 992, 32, '218.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6657, 413, 10, 413, 37, '46.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6684, 897, 1, 897, 54, '186.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6721, 303, 4, 303, 43, '145.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6739, 522, 7, 522, 10, '213.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6777, 810, 5, 810, 29, '109.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6783, 420, 2, 420, 69, '157.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6804, 776, 4, 776, 4, '147.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6824, 54, 5, 54, 26, '80.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6903, 219, 2, 219, 31, '82.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6916, 628, 3, 628, 20, '286.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6960, 194, 4, 194, 36, '17.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6975, 433, 4, 433, 29, '131.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7000, 478, 7, 478, 11, '82.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7004, 275, 7, 275, 12, '152.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7028, 364, 10, 364, 54, '187.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7097, 596, 10, 596, 55, '276.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7102, 255, 8, 255, 59, '97.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7107, 154, 7, 154, 30, '119.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7115, 568, 10, 568, 55, '119.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7168, 740, 2, 740, 66, '171.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7238, 89, 8, 89, 4, '199.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7267, 554, 5, 554, 37, '63.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7279, 455, 5, 455, 1, '251.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7416, 122, 4, 122, 64, '273.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7506, 468, 7, 468, 57, '206.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7522, 271, 7, 271, 38, '68.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7565, 684, 1, 684, 53, '171.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7604, 670, 6, 670, 27, '162.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7609, 126, 5, 126, 7, '197.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7671, 276, 1, 276, 6, '295.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7678, 963, 2, 963, 15, '53.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7759, 353, 10, 353, 28, '30.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7773, 198, 10, 198, 58, '289.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7783, 150, 6, 150, 17, '42.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7790, 958, 3, 958, 60, '287.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7798, 586, 5, 586, 38, '213.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7814, 298, 2, 298, 46, '284.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7818, 312, 9, 312, 8, '127.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7825, 665, 5, 665, 20, '147.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7862, 135, 2, 135, 20, '113.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7928, 816, 8, 816, 48, '124.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7938, 70, 8, 70, 27, '103.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7980, 547, 8, 547, 8, '70.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8001, 215, 5, 215, 4, '64.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8008, 345, 8, 345, 49, '66.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8015, 609, 4, 609, 53, '182.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8016, 802, 5, 802, 52, '266.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8020, 284, 5, 284, 63, '207.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8151, 443, 3, 443, 6, '100.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8154, 448, 1, 448, 3, '123.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8183, 569, 1, 569, 50, '234.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8217, 806, 9, 806, 35, '130.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8285, 716, 5, 716, 21, '289.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8406, 43, 10, 43, 50, '135.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8423, 256, 9, 256, 52, '153.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8439, 261, 10, 261, 20, '106.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8477, 433, 5, 433, 42, '235.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8482, 765, 3, 765, 29, '272.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8522, 819, 2, 819, 1, '262.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8535, 736, 5, 736, 66, '191.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8553, 66, 5, 66, 19, '271.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8591, 854, 5, 854, 1, '242.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8615, 789, 10, 789, 38, '94.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8697, 594, 3, 594, 36, '88.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8805, 731, 10, 731, 62, '52.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8809, 354, 7, 354, 34, '243.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8817, 748, 8, 748, 14, '28.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8842, 650, 8, 650, 22, '82.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8849, 474, 10, 474, 48, '74.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8867, 228, 3, 228, 56, '75.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8869, 832, 2, 832, 13, '250.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8878, 564, 1, 564, 56, '77.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8896, 927, 5, 927, 45, '195.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8964, 30, 4, 30, 36, '66.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8971, 984, 10, 984, 42, '109.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9037, 714, 1, 714, 19, '270.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9049, 450, 2, 450, 42, '123.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9062, 565, 9, 565, 8, '42.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9069, 484, 7, 484, 36, '277.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9107, 978, 9, 978, 7, '196.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9138, 416, 2, 416, 20, '100.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9177, 864, 6, 864, 61, '172.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9231, 452, 8, 452, 20, '280.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9281, 436, 9, 436, 20, '150.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9299, 855, 2, 855, 38, '89.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9301, 124, 1, 124, 21, '41.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9351, 737, 10, 737, 25, '213.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9420, 562, 9, 562, 10, '268.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9456, 310, 7, 310, 19, '169.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9632, 366, 3, 366, 57, '276.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9650, 245, 7, 245, 59, '178.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9661, 327, 10, 327, 3, '132.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9681, 636, 6, 636, 15, '101.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9761, 633, 7, 633, 20, '103.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9791, 683, 10, 683, 30, '263.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9834, 601, 4, 601, 56, '127.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9836, 876, 9, 876, 63, '202.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9855, 64, 7, 64, 39, '179.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9925, 966, 5, 966, 23, '108.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9931, 693, 3, 693, 49, '257.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9940, 239, 7, 239, 2, '269.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9968, 756, 4, 756, 26, '208.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9969, 903, 6, 903, 12, '257.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10996, 955, 9, 955, 2, '147.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11043, 402, 8, 402, 46, '219.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11706, 911, 6, 911, 42, '138.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11811, 733, 3, 733, 41, '244.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12037, 352, 1, 352, 8, '80.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12286, 476, 10, 476, 16, '87.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12550, 644, 7, 644, 64, '163.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12705, 793, 2, 793, 10, '200.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12733, 741, 6, 741, 40, '147.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12843, 745, 3, 745, 67, '39.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (12894, 631, 9, 631, 29, '94.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13332, 227, 7, 227, 67, '39.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13336, 154, 9, 154, 50, '236.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14108, 263, 8, 263, 1, '196.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14153, 187, 9, 187, 11, '188.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14582, 117, 9, 117, 68, '82.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14867, 445, 5, 445, 54, '132.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15181, 790, 4, 790, 11, '148.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15254, 747, 3, 747, 24, '111.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15531, 738, 3, 738, 58, '262.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16076, 279, 6, 279, 69, '245.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16153, 820, 9, 820, 39, '45.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16429, 26, 7, 26, 26, '211.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16487, 123, 4, 123, 17, '214.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16541, 994, 4, 994, 29, '187.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16918, 221, 9, 221, 48, '126.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17202, 368, 1, 368, 59, '103.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17226, 401, 7, 401, 25, '28.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17256, 287, 8, 287, 66, '110.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17371, 722, 9, 722, 12, '233.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17427, 513, 10, 513, 46, '121.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17751, 203, 4, 203, 14, '49.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17779, 827, 4, 827, 9, '153.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17845, 725, 2, 725, 49, '98.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18304, 672, 2, 672, 42, '280.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18408, 314, 8, 314, 12, '183.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18523, 206, 5, 206, 51, '266.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18548, 343, 1, 343, 20, '266.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (18549, 931, 4, 931, 56, '126.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19200, 196, 6, 196, 2, '221.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19343, 940, 6, 940, 24, '215.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19852, 707, 7, 707, 14, '212.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19892, 946, 9, 946, 39, '286.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20102, 942, 4, 942, 42, '297.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20403, 17, 10, 17, 26, '121.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20533, 139, 3, 139, 44, '140.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (21061, 76, 4, 76, 61, '259.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22721, 564, 9, 564, 19, '76.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22775, 781, 8, 781, 51, '150.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22779, 409, 9, 409, 17, '251.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22901, 226, 9, 226, 47, '232.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23130, 960, 8, 960, 65, '256.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23659, 487, 3, 487, 54, '81.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23829, 442, 8, 442, 33, '202.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23912, 894, 1, 894, 56, '288.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25185, 904, 1, 904, 16, '244.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25190, 454, 10, 454, 69, '157.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26336, 522, 3, 522, 3, '218.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26614, 519, 2, 519, 65, '36.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26692, 572, 3, 572, 35, '113.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (27834, 996, 9, 996, 6, '285.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28028, 146, 6, 146, 21, '276.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28093, 765, 7, 765, 42, '167.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28750, 131, 4, 131, 48, '94.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28922, 591, 9, 591, 63, '168.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29012, 435, 5, 435, 47, '65.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29214, 690, 7, 690, 27, '276.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30164, 279, 10, 279, 48, '177.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30629, 638, 8, 638, 3, '176.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30693, 795, 3, 795, 2, '276.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31007, 108, 10, 108, 39, '227.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31255, 955, 3, 955, 1, '266');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31339, 926, 7, 926, 9, '163.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31934, 214, 9, 214, 58, '232.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (32227, 12, 8, 12, 61, '94.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (32728, 22, 9, 22, 62, '188.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (32729, 481, 8, 481, 27, '282.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33172, 281, 5, 281, 35, '207.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33221, 526, 8, 526, 64, '258.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33286, 565, 8, 565, 23, '86.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33594, 668, 3, 668, 46, '146.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33822, 646, 8, 646, 37, '38.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33939, 352, 7, 352, 66, '167.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34098, 286, 5, 286, 14, '276.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34885, 652, 9, 652, 57, '27.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34909, 213, 1, 213, 43, '106.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35228, 469, 6, 469, 51, '248.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35670, 893, 1, 893, 40, '176.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36474, 878, 4, 878, 20, '182.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37038, 642, 1, 642, 57, '214.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37118, 487, 9, 487, 11, '235.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37311, 129, 7, 129, 59, '26.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37402, 265, 10, 265, 46, '243.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37773, 674, 8, 674, 26, '76.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37986, 659, 8, 659, 33, '28.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38141, 843, 3, 843, 4, '52.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38315, 845, 8, 845, 65, '51.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38758, 488, 9, 488, 47, '17.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38817, 127, 10, 127, 34, '37.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38906, 179, 5, 179, 16, '166');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39388, 271, 4, 271, 34, '208.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39423, 635, 3, 635, 65, '234.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39911, 870, 8, 870, 23, '35.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40896, 602, 6, 602, 6, '169.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40908, 870, 2, 870, 55, '273.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41694, 477, 5, 477, 59, '33.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41799, 10, 4, 10, 39, '46.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41939, 610, 10, 610, 63, '197.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41966, 769, 9, 769, 26, '188.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (42015, 861, 7, 861, 7, '33.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (42388, 669, 10, 669, 37, '39.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (42989, 54, 7, 54, 19, '194.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43001, 382, 2, 382, 17, '281.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43145, 664, 9, 664, 59, '238.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43284, 648, 10, 648, 17, '298.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43502, 990, 1, 990, 13, '142.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43579, 198, 3, 198, 42, '256.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43905, 600, 8, 600, 19, '251.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43986, 548, 6, 548, 42, '123.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (44367, 464, 10, 464, 6, '38.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (44487, 825, 9, 825, 52, '19.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (44538, 827, 2, 827, 5, '65.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46524, 36, 8, 36, 44, '215.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46633, 212, 9, 212, 57, '269.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46702, 905, 7, 905, 37, '100.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46854, 599, 1, 599, 33, '82.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (47130, 192, 8, 192, 40, '118.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (47859, 434, 1, 434, 34, '39.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48030, 69, 6, 69, 38, '101.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48615, 255, 4, 255, 55, '65.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48625, 710, 5, 710, 54, '267.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48678, 863, 5, 863, 63, '187.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48710, 835, 3, 835, 42, '43.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48904, 364, 2, 364, 9, '137.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (49463, 993, 8, 993, 42, '186.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50011, 780, 7, 780, 37, '114.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50067, 561, 4, 561, 63, '153.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50803, 743, 1, 743, 23, '187.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50878, 45, 10, 45, 66, '106.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50996, 365, 2, 365, 35, '154.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (51189, 952, 7, 952, 20, '126.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (51772, 391, 8, 391, 68, '96.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52112, 939, 2, 939, 29, '20.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52789, 624, 5, 624, 19, '183.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54113, 927, 5, 927, 28, '114.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54357, 155, 5, 155, 56, '289.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54413, 730, 7, 730, 65, '211.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54468, 342, 1, 342, 54, '212.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (55056, 389, 3, 389, 53, '171.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (55342, 840, 2, 840, 25, '32.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (55668, 820, 4, 820, 66, '25.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (55816, 377, 8, 377, 23, '95.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56130, 21, 3, 21, 40, '152.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56188, 759, 3, 759, 66, '176.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56224, 968, 10, 968, 50, '146.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56385, 505, 4, 505, 62, '281.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56777, 425, 3, 425, 27, '244.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56830, 440, 10, 440, 1, '60.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56923, 266, 10, 266, 62, '185.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (57260, 873, 2, 873, 49, '201.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (57758, 823, 4, 823, 5, '140.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58362, 168, 7, 168, 5, '17.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59017, 334, 2, 334, 7, '224.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59140, 856, 6, 856, 27, '173.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59712, 597, 9, 597, 22, '240.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59923, 423, 2, 423, 35, '150.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59946, 658, 9, 658, 60, '293.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60031, 421, 5, 421, 53, '150.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60629, 646, 6, 646, 4, '61.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62447, 19, 10, 19, 24, '64.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62472, 50, 8, 50, 19, '277.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62623, 197, 1, 197, 51, '145.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62688, 774, 4, 774, 7, '124.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63210, 673, 10, 673, 42, '166.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63444, 247, 7, 247, 11, '213.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63544, 685, 6, 685, 59, '194.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64811, 666, 3, 666, 22, '281.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64880, 581, 4, 581, 13, '76.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64972, 744, 9, 744, 40, '47.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65526, 659, 9, 659, 67, '32.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65723, 467, 4, 467, 9, '277.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65789, 654, 2, 654, 61, '107.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65826, 551, 2, 551, 15, '185.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66108, 71, 4, 71, 69, '33.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66440, 396, 4, 396, 19, '87.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66556, 634, 9, 634, 12, '18.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66711, 384, 10, 384, 31, '157.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (67045, 278, 5, 278, 63, '220.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (67323, 426, 5, 426, 33, '67.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68298, 763, 3, 763, 11, '236.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68996, 2, 4, 2, 69, '94.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68998, 993, 8, 993, 52, '44.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69413, 662, 7, 662, 32, '37.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69769, 772, 9, 772, 40, '42.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69773, 974, 7, 974, 62, '258.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69946, 682, 5, 682, 18, '258.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69975, 555, 3, 555, 32, '58.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70100, 657, 6, 657, 69, '258.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70589, 535, 8, 535, 31, '292.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70721, 882, 5, 882, 65, '42.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70766, 201, 2, 201, 9, '125.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (71651, 845, 5, 845, 31, '105.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (71798, 404, 5, 404, 22, '122.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72127, 650, 7, 650, 13, '143.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72531, 826, 5, 826, 28, '33.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72704, 952, 6, 952, 46, '56.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73007, 98, 6, 98, 39, '274.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73656, 175, 6, 175, 66, '174.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74112, 867, 9, 867, 46, '104.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74502, 747, 4, 747, 22, '32.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75402, 582, 3, 582, 64, '67.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75646, 812, 8, 812, 43, '199.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75860, 193, 3, 193, 54, '260.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75880, 584, 5, 584, 14, '166.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (76750, 471, 2, 471, 7, '187.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (76825, 158, 7, 158, 47, '286.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77114, 938, 2, 938, 49, '171.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77286, 917, 4, 917, 53, '117.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77406, 643, 4, 643, 64, '49.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78165, 560, 9, 560, 34, '174.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78398, 980, 5, 980, 28, '251.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78543, 470, 4, 470, 37, '45.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78604, 771, 8, 771, 20, '263.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79159, 666, 8, 666, 22, '189.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79443, 642, 3, 642, 37, '185.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79918, 623, 8, 623, 64, '26.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (80571, 782, 9, 782, 30, '182.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (80772, 685, 8, 685, 13, '32.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (82133, 208, 3, 208, 53, '111.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (83669, 305, 5, 305, 25, '21.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (83751, 390, 9, 390, 55, '275.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (84199, 717, 5, 717, 17, '238.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85036, 233, 4, 233, 29, '236');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85607, 55, 1, 55, 25, '143.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85706, 559, 5, 559, 21, '224.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85818, 721, 2, 721, 43, '215.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85910, 859, 6, 859, 20, '147.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86482, 380, 8, 380, 14, '35.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86528, 415, 8, 415, 18, '279.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86692, 213, 8, 213, 25, '151.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86697, 707, 6, 707, 5, '108.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86712, 403, 5, 403, 39, '22.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86804, 713, 4, 713, 46, '85.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87638, 935, 8, 935, 37, '48.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87843, 750, 9, 750, 50, '135.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87960, 568, 4, 568, 24, '73.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88148, 506, 7, 506, 49, '47.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88174, 526, 2, 526, 3, '64.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88269, 311, 6, 311, 67, '36.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88685, 708, 3, 708, 15, '276.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88713, 30, 7, 30, 15, '100.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88738, 300, 4, 300, 18, '175.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88784, 397, 10, 397, 63, '284.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (89347, 587, 1, 587, 27, '190.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (89702, 113, 8, 113, 66, '251.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90466, 331, 5, 331, 10, '199.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90635, 973, 2, 973, 69, '85.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90913, 544, 3, 544, 62, '288.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90996, 11, 8, 11, 22, '113.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91301, 922, 7, 922, 69, '39.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91459, 105, 9, 105, 10, '39.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91541, 185, 4, 185, 64, '260.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91701, 712, 1, 712, 50, '113.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (92693, 899, 3, 899, 7, '69.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (92731, 614, 5, 614, 30, '232.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (92802, 166, 2, 166, 13, '226.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93050, 195, 4, 195, 31, '194.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93199, 125, 5, 125, 53, '37.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93232, 408, 7, 408, 38, '211.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93486, 382, 8, 382, 12, '124.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (94829, 753, 3, 753, 15, '219.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95068, 499, 8, 499, 2, '58.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95165, 946, 8, 946, 38, '276.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95277, 527, 1, 527, 23, '260.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95468, 216, 7, 216, 4, '120.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96894, 898, 7, 898, 7, '112.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96927, 590, 9, 590, 66, '140.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96992, 43, 4, 43, 58, '249.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (97258, 617, 2, 617, 10, '154.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (98324, 573, 5, 573, 29, '158.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (98915, 479, 1, 479, 28, '213.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99237, 444, 9, 444, 4, '286.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99399, 199, 7, 199, 53, '207.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99415, 895, 9, 895, 41, '157.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99696, 28, 10, 28, 29, '297.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99719, 857, 1, 857, 21, '81.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99935, 667, 4, 667, 68, '288.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (101276, 734, 7, 734, 48, '34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (110069, 686, 6, 686, 68, '202.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (113392, 80, 5, 80, 13, '33.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (114536, 878, 3, 878, 41, '184.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (122163, 435, 5, 435, 14, '50.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (122563, 502, 6, 502, 65, '70.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (127340, 497, 8, 497, 11, '44.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (128044, 178, 1, 178, 10, '156.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (128924, 828, 4, 828, 26, '252.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (129518, 709, 10, 709, 21, '135.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (129747, 830, 3, 830, 62, '46.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (130520, 701, 9, 701, 49, '71.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (138844, 553, 9, 553, 67, '262.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (143427, 723, 6, 723, 69, '68.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (144244, 549, 9, 549, 9, '38.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (148341, 757, 1, 757, 24, '114.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (171723, 309, 7, 309, 25, '23.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (172231, 350, 7, 350, 44, '286.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (172891, 698, 4, 698, 3, '144.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (174703, 709, 3, 709, 3, '21.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (174753, 231, 9, 231, 49, '189.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (175855, 517, 7, 517, 59, '74.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (179312, 694, 4, 694, 67, '69.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (181315, 983, 10, 983, 47, '212.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (181458, 681, 4, 681, 29, '247.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (183473, 359, 7, 359, 44, '212.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (183793, 869, 3, 869, 14, '35.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (188118, 585, 1, 585, 37, '99.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (196612, 50, 1, 50, 49, '90.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (197413, 325, 2, 325, 65, '113.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (197684, 651, 4, 651, 43, '80.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (209746, 770, 6, 770, 43, '130.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (213284, 177, 9, 177, 56, '151.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (215275, 341, 2, 341, 54, '194.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (221329, 755, 3, 755, 20, '220.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (227567, 951, 8, 951, 32, '120.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (228018, 775, 7, 775, 20, '149');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (229588, 386, 8, 386, 59, '98.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (231967, 202, 2, 202, 8, '46.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (236992, 385, 5, 385, 61, '18.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (244846, 46, 10, 46, 30, '79.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (246826, 536, 7, 536, 3, '185.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (246899, 615, 7, 615, 25, '220.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (249076, 589, 10, 589, 20, '69.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (249447, 489, 6, 489, 16, '224.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (249989, 523, 5, 523, 19, '139.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (253382, 960, 7, 960, 50, '230.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (255205, 719, 9, 719, 4, '35.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (258002, 431, 1, 431, 59, '60.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (260254, 339, 7, 339, 59, '23.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (261790, 900, 5, 900, 59, '151.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (261961, 814, 10, 814, 47, '124.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (268074, 521, 3, 521, 32, '102.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (268798, 639, 3, 639, 20, '186.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (272238, 378, 7, 378, 17, '53.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (275960, 245, 10, 245, 50, '295.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (287004, 768, 9, 768, 12, '197.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (288827, 848, 7, 848, 17, '135.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (291822, 647, 5, 647, 31, '65.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (292262, 921, 8, 921, 45, '56.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (294701, 53, 7, 53, 28, '146.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (295313, 236, 10, 236, 37, '197.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (297404, 97, 10, 97, 5, '198.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (299043, 161, 10, 161, 35, '186.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (299813, 272, 8, 272, 15, '289.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (301364, 821, 8, 821, 27, '270.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (307774, 124, 3, 124, 42, '234.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (310137, 798, 9, 798, 14, '59.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (310891, 141, 4, 141, 54, '118.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (326798, 180, 8, 180, 20, '264.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (327540, 459, 8, 459, 52, '139.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (331755, 577, 3, 577, 36, '45.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (331788, 758, 3, 758, 10, '55.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (332469, 252, 2, 252, 4, '96.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (332722, 518, 4, 518, 35, '25.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (334516, 677, 2, 677, 36, '104.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (337346, 162, 5, 162, 55, '86.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (339929, 46, 1, 46, 61, '21.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (354101, 613, 10, 613, 7, '138.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (355765, 557, 7, 557, 32, '163.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (356526, 689, 8, 689, 2, '264.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (357776, 194, 6, 194, 30, '131.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (363004, 156, 8, 156, 32, '244.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (363015, 379, 8, 379, 51, '147.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (366648, 223, 9, 223, 15, '65.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (367926, 401, 4, 401, 17, '211.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (370800, 936, 4, 936, 20, '286.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (373320, 600, 3, 600, 43, '195.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (375269, 913, 6, 913, 45, '50.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (375467, 967, 8, 967, 66, '176.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (376430, 818, 9, 818, 44, '262.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (376762, 234, 4, 234, 54, '64.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (379579, 340, 7, 340, 5, '154.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (381904, 693, 8, 693, 48, '171.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (384092, 644, 1, 644, 36, '179.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (384204, 591, 9, 591, 43, '202.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (391290, 999, 10, 999, 19, '141.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (393479, 839, 4, 839, 45, '230.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (394381, 792, 1, 792, 25, '236');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (397894, 307, 9, 307, 66, '35.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (398490, 368, 9, 368, 43, '18.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (400020, 560, 3, 560, 7, '87.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (403209, 100, 9, 100, 61, '103.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (403657, 605, 1, 605, 32, '51.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (404609, 810, 6, 810, 9, '48.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (405814, 705, 2, 705, 52, '128.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (407866, 4, 2, 4, 57, '292.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (412524, 753, 8, 753, 30, '255.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (413311, 179, 9, 179, 55, '243.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (422622, 962, 1, 962, 18, '299.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (426403, 918, 8, 918, 23, '271.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (427876, 809, 2, 809, 33, '230.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (428014, 660, 5, 660, 67, '76.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (429101, 283, 2, 283, 53, '33.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (429824, 169, 9, 169, 49, '137.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (429868, 348, 6, 348, 36, '171.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (434475, 461, 10, 461, 9, '221.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (437778, 906, 5, 906, 69, '260.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (440311, 346, 7, 346, 36, '286.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (440988, 330, 7, 330, 16, '29.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (451559, 342, 6, 342, 3, '31.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (452624, 171, 1, 171, 33, '195.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (463684, 344, 4, 344, 49, '89.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (463962, 916, 2, 916, 16, '293.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (464419, 102, 6, 102, 29, '171.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (470400, 333, 6, 333, 57, '37.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (475261, 533, 3, 533, 12, '95.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (478972, 351, 9, 351, 66, '252.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (480100, 808, 3, 808, 51, '48.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (480478, 630, 8, 630, 7, '188.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (482504, 84, 8, 84, 42, '214.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (484349, 436, 8, 436, 5, '227.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (485999, 260, 4, 260, 26, '58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (486362, 531, 2, 531, 46, '261.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (486688, 912, 9, 912, 46, '193.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (488281, 785, 7, 785, 50, '251.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (492064, 671, 4, 671, 23, '247.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (494651, 77, 1, 77, 17, '64.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (497053, 667, 9, 667, 23, '105.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (498695, 483, 8, 483, 12, '120.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (498851, 815, 7, 815, 19, '165.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (509283, 129, 6, 129, 46, '276.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (509804, 711, 2, 711, 2, '72.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (511460, 524, 1, 524, 44, '241.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (517672, 289, 7, 289, 33, '210.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (518662, 48, 7, 48, 21, '75.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (520070, 808, 8, 808, 33, '226.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (528135, 805, 5, 805, 52, '263.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (531708, 625, 6, 625, 54, '177.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (539246, 997, 10, 997, 47, '141.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (539641, 277, 6, 277, 67, '130.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (543305, 558, 1, 558, 36, '134.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (543974, 151, 1, 151, 21, '153.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (544106, 988, 1, 988, 12, '62.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (547146, 751, 2, 751, 32, '271.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (548003, 68, 3, 68, 65, '104.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (548330, 967, 7, 967, 24, '160.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (551578, 229, 10, 229, 66, '165.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (554459, 419, 5, 419, 13, '180.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (554494, 138, 3, 138, 30, '245.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (556986, 833, 5, 833, 12, '80.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (558626, 718, 6, 718, 9, '125.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (563334, 9, 8, 9, 49, '88.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (563645, 512, 4, 512, 22, '59.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (575390, 655, 5, 655, 56, '103.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (580970, 316, 8, 316, 53, '224.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (581784, 734, 4, 734, 29, '78.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (588676, 337, 2, 337, 59, '160.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (594300, 398, 3, 398, 64, '198.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (594564, 243, 6, 243, 63, '96.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (605001, 217, 1, 217, 30, '27.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (609451, 497, 10, 497, 51, '152.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (610702, 463, 2, 463, 69, '120.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (620685, 619, 2, 619, 28, '48.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (631628, 513, 8, 513, 10, '41.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (634817, 798, 1, 798, 13, '106');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (639101, 204, 4, 204, 36, '56.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (639434, 584, 3, 584, 36, '38.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (640999, 729, 8, 729, 2, '147.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (642441, 410, 10, 410, 47, '259.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (643380, 95, 3, 95, 48, '21.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (645007, 830, 1, 830, 48, '270.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (648229, 18, 1, 18, 8, '248.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (651821, 871, 7, 871, 24, '257.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (654075, 881, 5, 881, 15, '157.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (654805, 503, 7, 503, 13, '21.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (657383, 240, 7, 240, 12, '297.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (668040, 671, 6, 671, 41, '235.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (676126, 202, 8, 202, 63, '294.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (681559, 106, 7, 106, 59, '210.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (686274, 530, 4, 530, 36, '271.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (691443, 822, 8, 822, 20, '48.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (691734, 3, 3, 3, 47, '206.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (693308, 504, 10, 504, 20, '86.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (701246, 654, 1, 654, 23, '103.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (703551, 174, 7, 174, 17, '211.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (704243, 716, 6, 716, 21, '82.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (708254, 935, 10, 935, 47, '85.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (713754, 608, 8, 608, 62, '277.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (715733, 358, 6, 358, 8, '275.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (718365, 514, 1, 514, 59, '96.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (718777, 530, 10, 530, 39, '118.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (720538, 117, 3, 117, 10, '131');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (721316, 424, 7, 424, 49, '40.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (722102, 665, 7, 665, 17, '25.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (725957, 258, 5, 258, 6, '271.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (726727, 697, 3, 697, 49, '134.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (730825, 256, 9, 256, 45, '286.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (737510, 37, 7, 37, 16, '145.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (738669, 688, 3, 688, 1, '44.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (744570, 885, 2, 885, 46, '280.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (745736, 607, 7, 607, 58, '275.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (745967, 332, 2, 332, 9, '151.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (757291, 422, 3, 422, 19, '220.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (758332, 87, 4, 87, 52, '26.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (762263, 986, 3, 986, 46, '101.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (767965, 732, 7, 732, 46, '185.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (778545, 691, 2, 691, 12, '261.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (781067, 889, 9, 889, 7, '178.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (781273, 449, 10, 449, 11, '251.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (781395, 949, 1, 949, 38, '163.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (781990, 629, 5, 629, 9, '296.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (790994, 297, 4, 297, 31, '134.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (793380, 237, 7, 237, 35, '98.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (794495, 31, 4, 31, 25, '154.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (803204, 240, 2, 240, 30, '212.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (805531, 887, 9, 887, 55, '264.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (806329, 459, 7, 459, 26, '168.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (811719, 539, 6, 539, 11, '58.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (813603, 918, 1, 918, 58, '61.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (816337, 148, 4, 148, 31, '141.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (820553, 464, 8, 464, 65, '84.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (822789, 902, 9, 902, 15, '299.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (824723, 475, 5, 475, 22, '250.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (825851, 1, 10, 1, 41, '195.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (831900, 308, 3, 308, 52, '263.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (835436, 614, 3, 614, 49, '186.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (837408, 5, 2, 5, 4, '288.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (837556, 797, 3, 797, 8, '220.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (839493, 508, 5, 508, 25, '252.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (845934, 941, 3, 941, 20, '100.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (852669, 197, 8, 197, 29, '73.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (853304, 882, 4, 882, 51, '136.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (860246, 754, 2, 754, 60, '56.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (861480, 374, 5, 374, 58, '195.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (866975, 603, 1, 603, 29, '241.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (871274, 521, 9, 521, 43, '173.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (872143, 862, 9, 862, 55, '121.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (889684, 700, 5, 700, 31, '193.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (890318, 611, 8, 611, 32, '207.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (894166, 292, 3, 292, 51, '161.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (896524, 736, 1, 736, 62, '216.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (897794, 768, 6, 768, 22, '216.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (899449, 755, 9, 755, 9, '31.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (904798, 520, 5, 520, 23, '106.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (908065, 135, 4, 135, 38, '177.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (914515, 362, 4, 362, 45, '225.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (921518, 713, 6, 713, 63, '115.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (922159, 760, 3, 760, 7, '111.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (926147, 437, 8, 437, 3, '75.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (935356, 695, 10, 695, 9, '244.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (935542, 155, 9, 155, 18, '100.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (938534, 855, 4, 855, 41, '132.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (941826, 203, 3, 203, 11, '90.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (941913, 670, 2, 670, 57, '161.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (948938, 444, 2, 444, 25, '264.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (951260, 347, 7, 347, 22, '193.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (954539, 551, 10, 551, 67, '216.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (957876, 934, 1, 934, 13, '279.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (963072, 281, 4, 281, 68, '191.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (968475, 388, 10, 388, 23, '229.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (976277, 130, 5, 130, 10, '201.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (980939, 943, 4, 943, 34, '117.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (983930, 317, 1, 317, 40, '17.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (985111, 282, 7, 282, 69, '262.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (989746, 383, 2, 383, 64, '273.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (991230, 687, 6, 687, 2, '249');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (992809, 437, 10, 437, 50, '180.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1024398, 561, 3, 561, 54, '263.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1046966, 426, 4, 426, 52, '33.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1067074, 572, 6, 572, 50, '160.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1074024, 543, 9, 543, 44, '229.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1082599, 824, 5, 824, 54, '58.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1095717, 101, 6, 101, 13, '277.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1100958, 834, 8, 834, 10, '227.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1114482, 75, 7, 75, 9, '138.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1122397, 578, 9, 578, 35, '103.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1144218, 990, 1, 990, 13, '274.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1167265, 593, 2, 593, 36, '27.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1184021, 334, 8, 334, 37, '140.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1269720, 164, 2, 164, 49, '220.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1272599, 722, 3, 722, 38, '199.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1278914, 620, 9, 620, 37, '201.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1350836, 294, 8, 294, 1, '115.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1358942, 297, 4, 297, 65, '90.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1424873, 280, 2, 280, 38, '181.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1477074, 288, 4, 288, 38, '166.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1502497, 943, 5, 943, 68, '288.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1567937, 323, 2, 323, 35, '231.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1591418, 59, 9, 59, 67, '188.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1755508, 558, 2, 558, 20, '42.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1790665, 779, 2, 779, 58, '54.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1820377, 879, 4, 879, 49, '55.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1832483, 586, 8, 586, 68, '201.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1901008, 907, 3, 907, 39, '31.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (1933149, 260, 1, 260, 31, '237.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2034806, 977, 7, 977, 68, '111.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2119661, 500, 1, 500, 66, '207.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2180977, 432, 1, 432, 21, '237.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2258626, 907, 8, 907, 69, '294.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2292191, 283, 7, 283, 31, '203.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2304092, 20, 8, 20, 11, '297.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2308207, 44, 7, 44, 51, '120.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2318604, 794, 8, 794, 1, '109.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2319435, 181, 3, 181, 7, '188.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2344326, 290, 2, 290, 38, '71.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2367412, 174, 7, 174, 35, '40.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2369878, 510, 2, 510, 4, '227.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2369906, 423, 8, 423, 41, '291.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2450683, 995, 7, 995, 36, '209.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2472577, 275, 3, 275, 37, '206.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2503118, 703, 8, 703, 24, '117.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2511795, 842, 8, 842, 24, '204.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2533950, 315, 6, 315, 30, '58.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2539975, 623, 10, 623, 8, '101.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2653377, 969, 4, 969, 65, '149.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2658231, 985, 1, 985, 37, '216.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2684047, 227, 7, 227, 34, '57.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2692953, 148, 9, 148, 4, '287.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2772764, 35, 9, 35, 57, '145.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2778840, 149, 10, 149, 29, '200.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2782108, 392, 9, 392, 65, '47.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2803454, 191, 1, 191, 67, '173.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2877418, 535, 3, 535, 34, '178.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2935050, 890, 3, 890, 6, '281.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (2961691, 879, 8, 879, 38, '233.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3063257, 942, 3, 942, 43, '202.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3108408, 406, 9, 406, 3, '292.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3123958, 412, 8, 412, 62, '38.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3135464, 913, 8, 913, 62, '232.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3149429, 547, 4, 547, 25, '26.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3176823, 172, 6, 172, 1, '143.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3201305, 649, 9, 649, 12, '126.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3207809, 703, 3, 703, 62, '263.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3311250, 656, 3, 656, 31, '205.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3318421, 883, 6, 883, 12, '243.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3329123, 225, 10, 225, 5, '245.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3409930, 465, 1, 465, 69, '32.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3418725, 144, 9, 144, 47, '48.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3439963, 353, 3, 353, 1, '237.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3446435, 908, 8, 908, 5, '233.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3484307, 235, 8, 235, 36, '152.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3549749, 889, 9, 889, 18, '181.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3594487, 910, 2, 910, 45, '270.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3604674, 207, 2, 207, 66, '184.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3625948, 317, 1, 317, 60, '88.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3646329, 833, 4, 833, 29, '141.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3699299, 357, 7, 357, 65, '80.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3740048, 379, 5, 379, 24, '210.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3770386, 853, 2, 853, 22, '236.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3772421, 953, 5, 953, 68, '223.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3778287, 308, 4, 308, 62, '193.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3782659, 136, 7, 136, 66, '254.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3802464, 461, 2, 461, 10, '129.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3804919, 807, 7, 807, 55, '207.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3911128, 678, 3, 678, 49, '250.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (3925807, 163, 4, 163, 61, '83.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4130287, 811, 3, 811, 7, '130.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4137843, 891, 8, 891, 36, '91.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4160660, 744, 4, 744, 60, '158.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4163582, 788, 5, 788, 32, '235.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4219086, 241, 4, 241, 8, '230.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4276682, 313, 7, 313, 64, '96.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4287891, 189, 1, 189, 19, '135.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4298218, 393, 7, 393, 19, '226.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4318269, 868, 5, 868, 29, '108.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4326603, 496, 6, 496, 8, '269.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4385408, 901, 3, 901, 23, '88.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4388407, 362, 8, 362, 6, '271.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4390597, 872, 9, 872, 28, '255.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4405753, 819, 5, 819, 51, '36.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4419226, 190, 9, 190, 27, '51.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4476078, 56, 10, 56, 22, '226.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4479392, 777, 4, 777, 36, '133.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4511821, 176, 1, 176, 7, '23.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4554353, 575, 5, 575, 8, '106.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4570875, 47, 9, 47, 26, '181.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4587204, 728, 9, 728, 54, '108.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4588943, 743, 8, 743, 61, '287.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4617302, 69, 8, 69, 66, '86.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4640149, 571, 10, 571, 41, '137.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4694599, 186, 5, 186, 47, '24.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4702573, 930, 1, 930, 23, '168.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4708733, 354, 6, 354, 27, '97.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4726733, 728, 8, 728, 45, '65.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4765380, 908, 3, 908, 45, '272.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4794151, 32, 8, 32, 45, '26.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4902897, 574, 10, 574, 9, '74.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4910967, 429, 10, 429, 68, '36.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4918393, 965, 6, 965, 43, '237.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (4932958, 14, 1, 14, 31, '34.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5012004, 250, 4, 250, 1, '161.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5077745, 357, 3, 357, 2, '105.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5126729, 349, 3, 349, 43, '241.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5156528, 181, 2, 181, 7, '208.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5187461, 790, 4, 790, 65, '267.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5204681, 441, 3, 441, 21, '219.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5205908, 415, 2, 415, 13, '162.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5219289, 751, 2, 751, 20, '268.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5236055, 159, 10, 159, 2, '141.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5252610, 844, 2, 844, 68, '179.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5253283, 856, 4, 856, 60, '96.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5278346, 492, 4, 492, 54, '235.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5288015, 945, 8, 945, 60, '38.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5306190, 229, 5, 229, 68, '183.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5321786, 66, 3, 66, 29, '260.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5327446, 183, 3, 183, 54, '223.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5366448, 494, 3, 494, 58, '58.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5584323, 816, 1, 816, 51, '164.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5591710, 301, 7, 301, 4, '72.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5685449, 109, 9, 109, 20, '38.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5690188, 472, 8, 472, 24, '35.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5708886, 635, 7, 635, 37, '272.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5730269, 346, 5, 346, 43, '250.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5743175, 953, 6, 953, 32, '273.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5746361, 295, 2, 295, 10, '171.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5754252, 578, 2, 578, 46, '140.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5767984, 247, 3, 247, 61, '71.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5783498, 180, 9, 180, 39, '189.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5801251, 341, 7, 341, 69, '48.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5860562, 33, 10, 33, 64, '124.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5881638, 360, 6, 360, 31, '257.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5894585, 230, 4, 230, 51, '92.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5899661, 602, 8, 602, 67, '197.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5937777, 984, 6, 984, 48, '198.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (5986594, 330, 8, 330, 56, '74.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6048532, 45, 2, 45, 6, '186.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6048605, 446, 3, 446, 40, '51.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6164912, 150, 5, 150, 21, '193.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6184208, 622, 1, 622, 32, '106.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6224382, 500, 4, 500, 40, '81.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6230095, 405, 9, 405, 68, '246.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6235724, 847, 10, 847, 22, '52.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6255052, 900, 3, 900, 15, '299.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6317230, 567, 6, 567, 25, '93.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6393796, 866, 8, 866, 61, '239.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6433756, 556, 2, 556, 55, '90.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6495453, 125, 10, 125, 25, '209.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6519161, 860, 5, 860, 57, '164.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6523608, 785, 9, 785, 30, '195.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6642719, 378, 5, 378, 64, '186.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6819887, 784, 4, 784, 22, '107.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6878248, 959, 5, 959, 26, '34.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6878908, 71, 7, 71, 5, '100.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6907501, 611, 9, 611, 47, '162.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6907986, 282, 10, 282, 13, '200.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6917172, 825, 3, 825, 46, '79.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6929345, 982, 4, 982, 44, '39.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (6947881, 575, 5, 575, 42, '168.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7008552, 428, 2, 428, 18, '86.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7088179, 466, 1, 466, 63, '191.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7098156, 21, 1, 21, 6, '258.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7108352, 724, 1, 724, 27, '191.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7126278, 740, 4, 740, 8, '169.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7160482, 473, 4, 473, 33, '215.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7203290, 938, 8, 938, 51, '76.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7208553, 442, 7, 442, 35, '130.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7224086, 966, 6, 966, 23, '110.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7237968, 94, 6, 94, 28, '214.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7244355, 288, 5, 288, 43, '67.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7276641, 778, 8, 778, 24, '252.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7354549, 633, 3, 633, 52, '247.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7358959, 305, 3, 305, 59, '154.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7393976, 96, 9, 96, 66, '241.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7405075, 265, 9, 265, 17, '83.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7505824, 23, 1, 23, 32, '102.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7540899, 548, 9, 548, 29, '263.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7580417, 310, 6, 310, 44, '82.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7623073, 133, 8, 133, 50, '114.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7665247, 89, 6, 89, 30, '64.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7683865, 937, 8, 937, 43, '172.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7686175, 251, 2, 251, 31, '168.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7691150, 875, 1, 875, 69, '161.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7743192, 132, 10, 132, 66, '24.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7795772, 319, 10, 319, 17, '105.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7844876, 868, 5, 868, 7, '299.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7884832, 407, 4, 407, 59, '150.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7908678, 318, 4, 318, 29, '110.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7909335, 986, 4, 986, 43, '36.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7969022, 152, 9, 152, 7, '297.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (7977867, 622, 5, 622, 10, '276.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8012404, 278, 6, 278, 44, '108.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8022840, 373, 1, 373, 52, '157.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8026777, 41, 2, 41, 33, '191.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8090688, 438, 7, 438, 51, '206.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8091374, 595, 3, 595, 51, '42.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8116856, 616, 3, 616, 23, '21.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8121449, 128, 10, 128, 32, '289.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8125388, 263, 8, 263, 64, '250.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8186247, 881, 1, 881, 15, '34.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8212860, 1, 8, 1, 6, '254.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8234824, 864, 1, 864, 61, '220.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8246282, 920, 7, 920, 29, '257.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8252054, 553, 6, 553, 65, '245.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8284280, 31, 9, 31, 15, '169.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8333376, 506, 8, 506, 65, '55.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8411371, 416, 5, 416, 32, '237.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8429792, 399, 6, 399, 63, '294.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8431240, 978, 2, 978, 45, '210.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8444935, 410, 5, 410, 34, '25.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8485584, 915, 7, 915, 13, '107.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8536432, 292, 4, 292, 49, '67.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8551009, 480, 2, 480, 10, '145.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8593766, 749, 3, 749, 33, '101.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8664370, 516, 8, 516, 15, '53.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8680902, 183, 6, 183, 3, '184.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8717650, 164, 4, 164, 63, '98.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8740545, 557, 1, 557, 27, '25.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8747789, 805, 9, 805, 63, '173.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8749241, 519, 10, 519, 16, '164.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8791254, 592, 4, 592, 35, '80.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8797140, 517, 10, 517, 46, '102.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8807144, 877, 9, 877, 52, '230.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8844961, 377, 3, 377, 24, '106.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8853526, 696, 3, 696, 49, '228.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (8870666, 167, 4, 167, 62, '256.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9013103, 965, 7, 965, 15, '242.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9028073, 950, 10, 950, 26, '66.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9032411, 395, 3, 395, 24, '289.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9035475, 62, 7, 62, 16, '224.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9038323, 532, 2, 532, 50, '287.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9070118, 384, 8, 384, 63, '249.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9071743, 453, 3, 453, 61, '65.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9080369, 936, 6, 936, 26, '200.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9108730, 626, 1, 626, 68, '175.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9127616, 653, 3, 653, 21, '188.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9198021, 73, 8, 73, 58, '176.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9199890, 338, 5, 338, 21, '244.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9222168, 823, 8, 823, 58, '85.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9260143, 542, 4, 542, 11, '224.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9285249, 850, 2, 850, 41, '25.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9354444, 514, 5, 514, 54, '52.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9371822, 910, 8, 910, 57, '118.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9581152, 491, 7, 491, 58, '137.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9616501, 182, 6, 182, 67, '173.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9657107, 510, 5, 510, 1, '92.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9666942, 676, 10, 676, 41, '254.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9686490, 328, 10, 328, 54, '245.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9691745, 454, 1, 454, 38, '196');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9714175, 956, 6, 956, 9, '242.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9717202, 307, 4, 307, 8, '197.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9759304, 576, 7, 576, 67, '248.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9763389, 383, 6, 383, 49, '17.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9785262, 555, 9, 555, 6, '24.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9796411, 606, 9, 606, 48, '263.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9797902, 608, 6, 608, 23, '135.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9798417, 637, 8, 637, 26, '68.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9832516, 968, 3, 968, 64, '118.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9868128, 207, 2, 207, 22, '219.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9927314, 534, 6, 534, 13, '154.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (9995696, 268, 10, 268, 47, '102.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10324125, 542, 7, 542, 45, '272.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10405880, 327, 6, 327, 32, '91.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10423852, 365, 3, 365, 34, '238.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (10511496, 74, 3, 74, 59, '112.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11214967, 273, 10, 273, 41, '218.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (11528514, 160, 9, 160, 37, '143.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13090225, 885, 5, 885, 17, '171.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13150572, 846, 7, 846, 51, '290.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (13781507, 270, 2, 270, 11, '108.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14145603, 261, 10, 261, 48, '206.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14719995, 710, 6, 710, 29, '75.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14754198, 524, 1, 524, 23, '115.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14845799, 113, 4, 113, 22, '223.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (14971980, 226, 9, 226, 30, '133.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15141095, 752, 1, 752, 57, '146.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15141892, 528, 5, 528, 13, '213.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15276181, 363, 9, 363, 39, '52.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15361955, 552, 9, 552, 61, '199.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15474225, 457, 10, 457, 14, '287.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (15922900, 682, 1, 682, 69, '267.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (16350732, 566, 4, 566, 50, '40.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17273423, 537, 6, 537, 51, '98.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (17414066, 969, 3, 969, 51, '131.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19374058, 725, 1, 725, 65, '198.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19656288, 130, 9, 130, 22, '18.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19885018, 24, 8, 24, 19, '171.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (19921924, 414, 1, 414, 49, '244.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20126586, 919, 2, 919, 60, '150.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20250907, 883, 3, 883, 65, '221.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (20966913, 696, 6, 696, 58, '51.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (21101493, 68, 6, 68, 27, '51.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (21384682, 326, 1, 326, 60, '173.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (21639516, 63, 10, 63, 34, '287.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22059689, 293, 3, 293, 8, '259.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22236541, 867, 9, 867, 18, '67.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (22302863, 253, 1, 253, 3, '141.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23104249, 336, 6, 336, 40, '125.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23221455, 100, 10, 100, 1, '232.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23229362, 248, 8, 248, 27, '90.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23536344, 866, 6, 866, 25, '170');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (23564042, 428, 1, 428, 41, '211.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24258595, 80, 3, 80, 55, '250.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24364134, 944, 3, 944, 52, '227.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24727906, 800, 8, 800, 69, '64.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24776814, 811, 4, 811, 34, '178.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (24838934, 371, 8, 371, 6, '284.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25138554, 692, 10, 692, 7, '58.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25186190, 39, 5, 39, 10, '271.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25372982, 639, 2, 639, 69, '269.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (25388955, 76, 8, 76, 17, '159.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26593873, 876, 5, 876, 5, '178.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (26954617, 579, 6, 579, 61, '124.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (27067879, 598, 5, 598, 44, '180.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28306053, 61, 4, 61, 44, '297.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28493857, 815, 5, 815, 55, '133.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28672771, 814, 4, 814, 28, '232.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (28952160, 888, 8, 888, 19, '181.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29089516, 285, 3, 285, 41, '38.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29240889, 715, 5, 715, 56, '235.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29296489, 224, 6, 224, 43, '295.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29440288, 970, 3, 970, 43, '267.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29446414, 675, 2, 675, 67, '136.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29942820, 81, 3, 81, 67, '186.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (29993632, 903, 2, 903, 51, '172.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30077552, 791, 1, 791, 55, '253.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30292872, 621, 8, 621, 5, '102.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30528953, 91, 9, 91, 4, '198.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (30589202, 544, 6, 544, 4, '130.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31092522, 232, 4, 232, 12, '244.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (31898042, 381, 8, 381, 14, '202.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (32495564, 232, 6, 232, 37, '107.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33102000, 115, 9, 115, 15, '89.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33571615, 695, 5, 695, 57, '111.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (33684131, 349, 10, 349, 47, '111.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34103765, 752, 9, 752, 50, '141.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34404185, 896, 3, 896, 66, '249.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34490299, 976, 10, 976, 26, '228.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34610110, 781, 7, 781, 31, '105.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (34918816, 976, 5, 976, 26, '225.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35210260, 515, 7, 515, 4, '257.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35222546, 38, 4, 38, 27, '93.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35395237, 758, 7, 758, 1, '280.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35523523, 766, 7, 766, 30, '283.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35795054, 651, 6, 651, 17, '167.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (35982140, 925, 1, 925, 8, '187.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36051030, 11, 5, 11, 54, '133.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36349027, 192, 7, 192, 44, '120.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36608064, 773, 7, 773, 27, '40.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36747742, 3, 8, 3, 21, '32.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (36851632, 962, 10, 962, 5, '80.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37095791, 103, 1, 103, 64, '193.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37356864, 48, 4, 48, 59, '137.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (37565560, 574, 2, 574, 62, '50.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38495359, 451, 9, 451, 54, '251.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38618982, 958, 8, 958, 57, '175.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (38904368, 841, 9, 841, 26, '36.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39111285, 287, 2, 287, 25, '25.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (39572150, 412, 7, 412, 35, '103.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40103659, 270, 5, 270, 22, '282.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40479517, 449, 2, 449, 34, '72.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (40573326, 289, 4, 289, 19, '89.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41299915, 92, 5, 92, 38, '281.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41331785, 146, 10, 146, 24, '246.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41635749, 73, 6, 73, 29, '41.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (41657517, 911, 1, 911, 29, '177.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (42274221, 786, 4, 786, 58, '235.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43041847, 74, 5, 74, 55, '127.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43261968, 484, 9, 484, 60, '238.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43441011, 756, 3, 756, 28, '128.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43466242, 182, 3, 182, 32, '205.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (43710822, 493, 7, 493, 24, '37.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (44372612, 389, 4, 389, 64, '207.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45038925, 491, 3, 491, 20, '281.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45148503, 49, 10, 49, 59, '105.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45313169, 852, 7, 852, 48, '286.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45900703, 596, 5, 596, 50, '185.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (45981871, 63, 8, 63, 45, '42.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46519766, 350, 8, 350, 6, '46.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (46704288, 717, 2, 717, 36, '202.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (47552782, 40, 2, 40, 39, '103.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48144793, 905, 10, 905, 13, '199.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (48320541, 727, 3, 727, 59, '62.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (49591073, 804, 8, 804, 7, '288.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (49605035, 96, 8, 96, 63, '168.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50089042, 485, 9, 485, 42, '274.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50408836, 948, 8, 948, 24, '253.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (50851123, 959, 4, 959, 41, '217.78');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (51614655, 225, 4, 225, 44, '153.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52060189, 47, 7, 47, 22, '127.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52186009, 563, 1, 563, 2, '227.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (52517555, 648, 4, 648, 28, '208.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53141047, 273, 2, 273, 48, '250.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53202753, 417, 5, 417, 41, '167.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53255399, 739, 2, 739, 22, '180.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53749714, 400, 10, 400, 1, '283.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (53803031, 812, 1, 812, 52, '168.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54171812, 418, 1, 418, 9, '98.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54280505, 190, 4, 190, 50, '192.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (54447342, 222, 2, 222, 6, '95.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56049096, 982, 4, 982, 39, '51.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56511901, 769, 2, 769, 30, '76.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56564168, 545, 2, 545, 56, '67.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (56650464, 699, 10, 699, 64, '65.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (57339695, 15, 7, 15, 56, '75.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58031724, 163, 5, 163, 8, '98.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58230767, 386, 1, 386, 29, '58.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58566892, 151, 2, 151, 6, '28.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58728618, 82, 10, 82, 64, '66.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (58915902, 543, 10, 543, 14, '181.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (59554748, 676, 10, 676, 67, '193.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60017390, 712, 10, 712, 51, '158.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60059421, 599, 6, 599, 24, '88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60164006, 746, 2, 746, 22, '155.02');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60195441, 673, 1, 673, 69, '256.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60211933, 826, 10, 826, 41, '169.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60340700, 566, 10, 566, 61, '155.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60372309, 842, 8, 842, 45, '62.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60617792, 440, 1, 440, 11, '187.92');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60629124, 801, 7, 801, 29, '176.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60848913, 493, 1, 493, 6, '244.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (60886939, 177, 4, 177, 12, '284.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (61693659, 272, 10, 272, 40, '87.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (61872345, 448, 8, 448, 69, '260.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62047205, 886, 2, 886, 20, '136.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62074029, 329, 1, 329, 6, '86.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62129247, 133, 10, 133, 24, '282.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (62745904, 447, 7, 447, 29, '144.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63225218, 114, 1, 114, 7, '156.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63337002, 579, 9, 579, 52, '263.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63362302, 434, 9, 434, 66, '24.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63472027, 818, 9, 818, 54, '106.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63571798, 142, 2, 142, 9, '142.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63915944, 777, 2, 777, 65, '49.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (63976195, 242, 7, 242, 61, '107.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64102346, 604, 5, 604, 33, '270.31');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (64369336, 688, 3, 688, 61, '33.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65111649, 780, 10, 780, 32, '48.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65280093, 901, 8, 901, 12, '119.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (65715126, 612, 1, 612, 28, '158.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66014471, 983, 2, 983, 40, '275.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66497953, 737, 9, 737, 14, '164.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66561912, 56, 3, 56, 10, '257.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (66912847, 166, 4, 166, 43, '122.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (67253312, 304, 9, 304, 68, '70.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68026809, 41, 10, 41, 53, '83.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68049255, 15, 4, 15, 19, '71.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68070805, 218, 3, 218, 57, '211.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (68235588, 783, 5, 783, 68, '107.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69192612, 361, 6, 361, 44, '126.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (69710269, 625, 10, 625, 59, '274.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70020606, 977, 1, 977, 40, '254.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70032111, 276, 2, 276, 41, '109.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70679992, 452, 2, 452, 2, '155.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (70794023, 221, 1, 221, 18, '145.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (71837356, 985, 5, 985, 24, '249.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72532148, 374, 4, 374, 25, '230.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (72545850, 266, 5, 266, 10, '220.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73014326, 411, 3, 411, 23, '228.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73040577, 16, 8, 16, 32, '34.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73077867, 372, 6, 372, 65, '100.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (73641011, 581, 6, 581, 48, '57.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74209627, 947, 6, 947, 56, '219.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74404265, 838, 1, 838, 46, '227.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74440386, 439, 9, 439, 43, '25.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (74629029, 605, 8, 605, 44, '68.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75438892, 991, 4, 991, 16, '115.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75475686, 587, 8, 587, 38, '84.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (75625933, 351, 6, 351, 53, '223.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77145306, 12, 6, 12, 22, '99.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77208035, 104, 7, 104, 29, '96.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77691604, 525, 10, 525, 65, '52.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (77697685, 67, 6, 67, 7, '278.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78508899, 773, 4, 773, 39, '136.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78672850, 809, 5, 809, 36, '294.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78906665, 720, 2, 720, 48, '123.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (78960866, 748, 3, 748, 21, '84.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79393100, 446, 7, 446, 45, '192.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79409525, 414, 1, 414, 20, '185.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79602227, 803, 4, 803, 55, '83.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (79852637, 219, 1, 219, 63, '189.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (80695760, 631, 4, 631, 23, '174.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (80801521, 60, 3, 60, 61, '34.94');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (82232305, 496, 9, 496, 28, '78.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (83535113, 359, 4, 359, 50, '185.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (83796465, 114, 10, 114, 12, '184');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (84328835, 220, 7, 220, 58, '194.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (84893393, 254, 1, 254, 16, '213.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (84979184, 843, 3, 843, 41, '270.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (85526661, 861, 1, 861, 50, '25.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86005453, 483, 6, 483, 58, '41.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (86038088, 189, 5, 189, 8, '208.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87277748, 687, 5, 687, 26, '25.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87426805, 766, 2, 766, 40, '97.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (87624906, 224, 10, 224, 6, '181.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88048259, 420, 5, 420, 52, '142.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88169271, 640, 4, 640, 32, '73.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88634831, 175, 9, 175, 3, '18.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (88917540, 632, 1, 632, 59, '42.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (89050561, 408, 4, 408, 49, '41.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90046029, 627, 9, 627, 53, '293.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (90125604, 367, 10, 367, 37, '119.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91618214, 549, 3, 549, 40, '162.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (91711267, 890, 7, 890, 69, '286.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93085960, 157, 6, 157, 29, '209.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93099596, 291, 10, 291, 43, '149.4');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93103163, 184, 4, 184, 25, '130.17');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93881963, 813, 4, 813, 24, '159.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93883315, 742, 1, 742, 29, '252.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (93963639, 394, 9, 394, 1, '256.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (94377810, 18, 4, 18, 17, '27.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95144942, 729, 6, 729, 13, '78.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95157037, 347, 1, 347, 33, '196.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (95786040, 388, 8, 388, 44, '67.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96053198, 954, 1, 954, 61, '161.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96068728, 218, 9, 218, 50, '25.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96184207, 690, 7, 690, 28, '243.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (96957553, 916, 5, 916, 35, '17.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (97114520, 157, 7, 157, 64, '88.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (97354483, 824, 1, 824, 63, '257.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (97517526, 880, 5, 880, 26, '289.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99087497, 933, 5, 933, 45, '24.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99121491, 577, 3, 577, 1, '76.52');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99146890, 318, 7, 318, 18, '66.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99196477, 795, 4, 795, 9, '76.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99339129, 37, 7, 37, 16, '182.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (99973388, 236, 2, 236, 37, '94.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (100922619, 370, 1, 370, 52, '141.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (103782727, 529, 10, 529, 41, '297.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (106473519, 463, 5, 463, 29, '86.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (117336318, 325, 2, 325, 69, '254.46');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (125831140, 122, 1, 122, 38, '216.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (126624485, 306, 5, 306, 68, '269.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (132061165, 210, 3, 210, 33, '37.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (137802176, 367, 7, 367, 38, '257.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (138006583, 116, 6, 116, 1, '50.26');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (138019793, 661, 6, 661, 23, '297.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (143136906, 295, 10, 295, 62, '128.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (144085678, 498, 2, 498, 13, '172.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (147116017, 103, 4, 103, 55, '249.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (147241609, 923, 4, 923, 23, '207.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (155354999, 550, 3, 550, 5, '59.82');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (156417712, 312, 9, 312, 67, '240.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (157301056, 301, 9, 301, 18, '102.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (163692991, 217, 7, 217, 30, '168.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (169835710, 35, 9, 35, 34, '19.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (171739814, 679, 2, 679, 13, '17.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (172193120, 979, 9, 979, 20, '263.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (176428991, 925, 3, 925, 7, '172.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (190940598, 807, 7, 807, 32, '190.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (191384976, 831, 10, 831, 61, '174.35');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (199334982, 123, 5, 123, 53, '290.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (200932424, 576, 6, 576, 59, '210.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (202804440, 90, 7, 90, 57, '111.8');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (206541460, 957, 2, 957, 42, '280.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (207678946, 480, 4, 480, 31, '282.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (209319267, 60, 10, 60, 27, '173.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (213095073, 211, 5, 211, 6, '18.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (220021422, 858, 6, 858, 22, '30.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (230839127, 324, 4, 324, 32, '140.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (233675171, 169, 9, 169, 47, '278.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (235691271, 110, 6, 110, 16, '110.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (243013149, 832, 3, 832, 42, '68.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (249107955, 211, 6, 211, 49, '279.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (250089895, 640, 8, 640, 66, '67.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (252587331, 304, 10, 304, 16, '31.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (253145276, 311, 5, 311, 29, '203.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (256659704, 83, 1, 83, 28, '249.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (259280617, 285, 7, 285, 10, '181.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (259958014, 348, 8, 348, 65, '99.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (261901501, 914, 2, 914, 8, '149.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (262542655, 796, 2, 796, 31, '249.11');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (267890176, 52, 10, 52, 51, '81.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (273996748, 800, 7, 800, 68, '233.33');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (280567273, 394, 1, 394, 51, '142.56');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (281541960, 456, 4, 456, 8, '145.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (282525281, 797, 5, 797, 58, '150.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (289563810, 616, 8, 616, 3, '120.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (290113005, 430, 6, 430, 58, '18.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (292805248, 954, 6, 954, 25, '261.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (298528054, 538, 6, 538, 49, '84.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (300933327, 917, 1, 917, 1, '287.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (301542785, 909, 7, 909, 21, '158.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (301594637, 153, 9, 153, 55, '163.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (308105390, 84, 4, 84, 26, '26.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (310502411, 749, 6, 749, 53, '296.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (321215461, 6, 3, 6, 39, '289.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (322033375, 238, 7, 238, 41, '30.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (328557909, 763, 7, 763, 4, '44.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (330221293, 120, 2, 120, 55, '185.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (333432375, 940, 10, 940, 48, '191.71');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (334554816, 892, 7, 892, 43, '251.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (336015239, 79, 9, 79, 28, '259.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (341074724, 928, 1, 928, 10, '249.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (342261503, 128, 10, 128, 65, '181.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (344176891, 85, 1, 85, 2, '97.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (346365221, 721, 10, 721, 31, '53.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (347387881, 585, 10, 585, 55, '21.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (348599332, 527, 7, 527, 33, '65.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (348746742, 607, 9, 607, 48, '222.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (349972536, 771, 4, 771, 60, '185.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (353118572, 702, 10, 702, 30, '170.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (353452436, 363, 7, 363, 3, '199.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (356968159, 107, 3, 107, 59, '43.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (361083336, 972, 2, 972, 47, '232.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (361896255, 529, 10, 529, 62, '98.81');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (366632638, 170, 5, 170, 16, '223.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (371260263, 332, 2, 332, 1, '112.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (372383009, 762, 1, 762, 31, '276.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (373455774, 39, 8, 39, 28, '293.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (378743096, 447, 1, 447, 44, '32.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (378879197, 508, 8, 508, 51, '212.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (381453795, 504, 7, 504, 33, '235.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (391940712, 422, 10, 422, 60, '241.12');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (392737305, 243, 5, 243, 56, '67.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (401808588, 921, 4, 921, 40, '186.67');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (413626755, 438, 3, 438, 20, '79.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (418639823, 165, 3, 165, 3, '185.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (419984562, 981, 1, 981, 17, '249.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (425194290, 61, 9, 61, 33, '50.93');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (433520307, 939, 5, 939, 34, '39.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (433856105, 699, 8, 699, 17, '260.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (435106520, 320, 9, 320, 47, '130.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (437495480, 492, 2, 492, 61, '296.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (439968952, 108, 3, 108, 42, '174.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (440307015, 321, 8, 321, 7, '23.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (441729309, 385, 10, 385, 4, '152.59');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (444798417, 402, 8, 402, 24, '152.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (449961042, 23, 4, 23, 11, '265.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (451703311, 583, 7, 583, 22, '105.68');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (455115341, 850, 4, 850, 46, '283.61');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (461414834, 992, 6, 992, 16, '296.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (464069061, 145, 8, 145, 24, '96.69');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (468126096, 356, 5, 356, 26, '88.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (471776643, 450, 2, 450, 34, '258.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (473844661, 369, 1, 369, 18, '269.84');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (476762056, 314, 1, 314, 14, '74.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (480105868, 731, 4, 731, 24, '134.89');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (483373558, 291, 7, 291, 15, '90.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (484380809, 996, 6, 996, 7, '102.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (484521267, 898, 1, 898, 37, '284.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (488805054, 7, 7, 7, 34, '97.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (495107762, 987, 9, 987, 56, '273.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (496316266, 877, 9, 877, 33, '194.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (501265621, 796, 9, 796, 55, '98.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (511256174, 445, 7, 445, 60, '19.09');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (514750043, 472, 3, 472, 29, '52.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (518521687, 244, 1, 244, 54, '251.41');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (523010604, 619, 3, 619, 14, '42.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (523859126, 588, 3, 588, 3, '116.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (524905902, 817, 2, 817, 56, '281.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (525747713, 471, 1, 471, 8, '156.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (527162101, 601, 10, 601, 48, '253.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (528821027, 831, 9, 831, 9, '230.03');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (530632151, 380, 8, 380, 3, '144.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (532605804, 588, 2, 588, 28, '297.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (534450670, 26, 7, 26, 4, '45.45');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (535288560, 949, 5, 949, 15, '236.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (539578030, 837, 1, 837, 51, '243.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (541216688, 770, 1, 770, 19, '17.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (544795559, 857, 9, 857, 3, '243.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (545170793, 592, 6, 592, 38, '159.21');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (546472445, 13, 2, 13, 52, '245.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (546490656, 567, 10, 567, 6, '292.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (547035522, 658, 2, 658, 4, '76.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (550869803, 862, 7, 862, 25, '264.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (552345562, 321, 6, 321, 48, '82.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (555660536, 188, 8, 188, 66, '135.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (566564565, 988, 7, 988, 16, '44.47');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (580843500, 251, 1, 251, 64, '200.95');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (582649274, 583, 7, 583, 42, '266.73');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (582752827, 854, 1, 854, 36, '267.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (586058954, 801, 4, 801, 41, '231.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (588254521, 413, 5, 413, 23, '278.88');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (588679542, 13, 8, 13, 65, '298.13');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (590775495, 975, 7, 975, 27, '84.25');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (592348561, 724, 4, 724, 56, '87.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (607432126, 65, 9, 65, 24, '19.29');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (613150651, 704, 10, 704, 61, '155.04');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (614520696, 121, 3, 121, 26, '162.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (614775110, 262, 9, 262, 60, '177.54');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (615111646, 663, 1, 663, 1, '276');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (618141312, 264, 7, 264, 55, '217.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (624508482, 462, 5, 462, 58, '225.9');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (627933420, 361, 5, 361, 35, '111.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (628870985, 44, 9, 44, 53, '77.28');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (634829416, 787, 1, 787, 60, '238.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (644414349, 441, 7, 441, 54, '213.98');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (644433131, 741, 3, 741, 42, '141.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (644567623, 249, 4, 249, 27, '180.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (647506696, 336, 2, 336, 48, '150.22');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (649064874, 296, 6, 296, 36, '292.85');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (650137813, 254, 7, 254, 11, '279.63');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (650188355, 849, 3, 849, 47, '205.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (653316052, 638, 7, 638, 58, '113.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (659091956, 501, 3, 501, 27, '42.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (666909963, 237, 5, 237, 60, '108.08');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (667668978, 458, 8, 458, 40, '191.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (669805233, 111, 9, 111, 56, '258.3');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (676275965, 49, 9, 49, 63, '34.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (676621760, 632, 10, 632, 57, '171.53');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (680530532, 928, 3, 928, 30, '271.14');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (684305186, 700, 9, 700, 64, '121.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (686892593, 376, 7, 376, 11, '176.39');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (686964369, 337, 4, 337, 28, '269.2');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (690710206, 142, 5, 142, 13, '127.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (693814137, 739, 8, 739, 53, '244.83');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (695220455, 79, 7, 79, 57, '194.7');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (721745321, 803, 10, 803, 65, '118.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (723642000, 554, 10, 554, 53, '160.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (727045255, 344, 2, 344, 60, '259.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (728044486, 208, 5, 208, 29, '236.16');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (729497245, 215, 9, 215, 65, '227.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (732079850, 680, 4, 680, 53, '207.32');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (736529669, 195, 1, 195, 13, '248.1');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (747010345, 887, 1, 887, 30, '163.97');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (758916374, 228, 9, 228, 22, '96.19');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (760351744, 970, 7, 970, 47, '108.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (761297401, 895, 8, 895, 32, '125.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (761813422, 679, 8, 679, 29, '55.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (762856967, 77, 1, 77, 27, '179.36');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (765027264, 322, 9, 322, 53, '191.91');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (765676772, 636, 3, 636, 64, '241');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (768109556, 302, 4, 302, 17, '145.58');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (769094700, 29, 1, 29, 64, '88.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (770962737, 799, 8, 799, 21, '94.79');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (785130550, 961, 2, 961, 12, '93.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (786663290, 371, 6, 371, 55, '24.07');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (788984514, 188, 8, 188, 8, '199.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (797082530, 692, 3, 692, 5, '178.62');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (803918331, 865, 7, 865, 63, '249.65');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (807083587, 375, 3, 375, 28, '294.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (809974939, 964, 7, 964, 2, '130.23');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (812184524, 400, 9, 400, 9, '281.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (813168904, 937, 5, 937, 36, '283.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (813450985, 964, 1, 964, 49, '155.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (815592818, 490, 9, 490, 43, '69.24');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (833425818, 25, 6, 25, 11, '258.76');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (837640604, 223, 2, 223, 44, '136.86');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (846256387, 546, 2, 546, 54, '56.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (848840259, 490, 2, 490, 51, '77.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (849547923, 675, 9, 675, 10, '238');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (859949330, 660, 10, 660, 60, '280.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (862752170, 987, 1, 987, 12, '190.34');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (865381806, 829, 9, 829, 59, '60.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (871155204, 141, 9, 141, 33, '211.42');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (872411637, 698, 3, 698, 23, '196.43');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (875205968, 945, 3, 945, 11, '33.77');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (875623893, 290, 4, 290, 40, '46.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (890472737, 258, 2, 258, 8, '276.37');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (892569285, 86, 6, 86, 55, '296.06');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (893484811, 525, 8, 525, 50, '265.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (897535461, 613, 8, 613, 48, '175.5');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (902056312, 761, 10, 761, 48, '34.72');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (904464963, 518, 9, 518, 1, '51.51');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (906190129, 269, 7, 269, 37, '243.05');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (919133210, 345, 8, 345, 49, '105.96');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (920163365, 184, 4, 184, 37, '86.18');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (923852978, 772, 10, 772, 22, '248.75');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (936193626, 944, 6, 944, 22, '258.15');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (941723795, 852, 3, 852, 2, '88.57');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (946959377, 684, 5, 684, 33, '43.99');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (948176532, 618, 3, 618, 62, '279.66');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (955444053, 869, 5, 869, 9, '294.27');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (956754434, 393, 2, 393, 53, '177.49');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (958143697, 134, 9, 134, 50, '115.74');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (959890645, 262, 10, 262, 58, '246.38');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (962729123, 136, 5, 136, 1, '122.55');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (976347418, 126, 1, 126, 64, '96.64');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (978111973, 152, 10, 152, 46, '74.6');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (980216220, 257, 9, 257, 48, '58.87');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (981739378, 7, 7, 7, 17, '75.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (985128956, 387, 10, 387, 15, '285.48');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (990120274, 86, 10, 86, 6, '212.44');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (991975709, 153, 1, 153, 32, '132.01');
INSERT INTO `rechnung_position` (`rgpos_id`, `rgpos_rgid`, `rgpos_posnr`, `rgpos_artid`, `rgpos_menge`, `rgpos_preis`) VALUES (996410217, 149, 1, 149, 26, '187.65');
